/***************************************************************************
 *   copyright            : (C) 2003 by Pascal Brachet                     *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qapplication.h>
#include <qtranslator.h>
#include <qtextcodec.h> 
#include "texmaker.h"

int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    QTranslator appTranslator;
#if defined( Q_WS_X11 ) || defined( Q_WS_MACX )
QString transdir=PREFIX"/share/texmaker";
#endif
#if defined(Q_WS_WIN)
QString transdir=QDir::currentDirPath();
#endif
    appTranslator.load(QString("texmaker_")+QTextCodec::locale(),transdir);
    a.installTranslator(&appTranslator);
    Texmaker * mw = new Texmaker();
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    for ( int i = 1; i < a.argc(); ++i )
        {
	      QString arg = a.argv()[ i ];
	      if ( arg[0] != '-' )    mw->load( arg );
        }
    return a.exec();
}
