/***************************************************************************
 *   copyright            : (C) 2003 by Pascal Brachet                     *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "symbolview.h"

#include <qfileinfo.h>
#include <qpixmap.h>
#include <qmessagebox.h>

/* XPM */
static const char *img100[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========OOOOOOOOOO%===========",
"========== o======@ @===========",
"==========O+O====#o@@===========",
"==========O=+O==@o=@@===========",
"==========O==+O@o==@@===========",
"==========O===O.*==@@===========",
"==========O==$XO+==@@===========",
"==========O=%.&=o+=@@===========",
"==========O%.&===O+@@===========",
"==========..&=====O.@===========",
"========== XOOOOOOO @==========="
};
/* XPM */
static const char *img101[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #777777",
"+ c #888888",
"@ c #AAAAAA",
"# c gray80",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%oooooooooo@%%%%%%%%%%%",
"%%%%%%%%%%o%%%%%%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%%%%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%%%%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%$#%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%o %%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%@+%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%%%%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%%%%%%OO%%%%%%%%%%%",
"%%%%%%%%%%o%%%%%%%%OO%%%%%%%%%%%",
"%%%%%%%%%%.ooooooooXO%%%%%%%%%%%"
};
/* XPM */
static const char *img102[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #777777",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##########oooooooooo+###########",
"##########o###@O###OO###########",
"##########o###@O###OO###########",
"##########o###@O###OO###########",
"##########o###@O###OO###########",
"########## oooX.ooo.O###########",
"##########o###@O###OO###########",
"##########o###@O###OO###########",
"##########o###@O###OO###########",
"##########o###@O###OO###########",
"########## oooX.ooo.O###########"
};
/* XPM */
static const char *img103[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;$O;;;;;;;;;;;;;;;",
";;;;;;;;;;;;+#;o &=X;;;;;;;;;;;;",
";;;;;;;;;;;;-X$&#*X$;;;;;;;;;;;;",
";;;;;;;;;;;;;=.#=X@;;;;;;;;;;;;;",
";;;;;;;;;;;@@@@ .X@@@*;;;;;;;;;;",
";;;;;;;;;;;@@@@ .X@@@*;;;;;;;;;;",
";;;;;;;;;;;;;=.#=X@;;;;;;;;;;;;;",
";;;;;;;;;;;;=X$%@*X#;;;;;;;;;;;;",
";;;;;;;;;;;;+$;o &-X;;;;;;;;;;;;",
";;;;;;;;;;;;;;;$O;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img104[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&O@&&&&%X&&&&&&&&&&&&&",
"&&&&&&&&&&&o #&&%X#&&&&&&&&&&&&&",
"&&&&&&&&&&&o#.@%X+&&&&&&&&&&&&&&",
"&&&&&&&&&&&o$&X.#&&&&&&&&&&&&&&&",
"&&&&&&&&&&&o$&..@&&&&&&&&&&&&&&&",
"&&&&&&&&&&&o#.@%X+&&&&&&&&&&&&&&",
"&&&&&&&&&&&o #&&%X@&&&&&&&&&&&&&",
"&&&&&&&&&&&O#&&&&&X&&&&&&&&&&&&&"
};
/* XPM */
static const char *img105[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&O@&&&&$X&&&&&&&&&&&&&",
"&&&&&&&&&&&%X#&&$X &&&&&&&&&&&&&",
"&&&&&&&&&&&&$.@$X+o&&&&&&&&&&&&&",
"&&&&&&&&&&&&&%X.#&o&&&&&&&&&&&&&",
"&&&&&&&&&&&&&%..@&o&&&&&&&&&&&&&",
"&&&&&&&&&&&&$.@$X+o&&&&&&&&&&&&&",
"&&&&&&&&&&&$X#&&$X &&&&&&&&&&&&&",
"&&&&&&&&&&&O#&&&&&X&&&&&&&&&&&&&"
};
/* XPM */
static const char *img106[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;=;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;; &;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;% =;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;$.-;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;#X-;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;+o-;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;oO;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;$.o+;;;;;;;;;;;;;;;",
";;;;;;;;;;;;& *-X@;;;;;;;;;;;;;;",
";;;;;;;;;;;* %;;*X$;;;;;;;;;;;;;",
";;;;;;;;;;= %;;;;=.%;;;;;;;;;;;;",
";;;;;;;;;;X@;;;;;;* &;;;;;;;;;;;",
";;;;;;;;;;%;;;;;;;;*&;;;;;;;;;;;"
};
/* XPM */
static const char *img107[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-X#;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;o@;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;+O;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;+o;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;@X;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;$ ;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;$.o+;;;;;;;;;;;;;;;",
";;;;;;;;;;;;& *-X@;;;;;;;;;;;;;;",
";;;;;;;;;;;* %;;*X$;;;;;;;;;;;;;",
";;;;;;;;;;= %;;;;=.%;;;;;;;;;;;;",
";;;;;;;;;;X@;;;;;;* &;;;;;;;;;;;",
";;;;;;;;;;%;;;;;;;;*&;;;;;;;;;;;"
};
/* XPM */
static const char *img108[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==============++================",
"==============++================",
"==============O+================",
"==============o+================",
"==============XX================",
"=============*X *===============",
"=============OOO@===============",
"============%.== &==============",
"==========$+.&==$.+%============",
"==========$#======#%============"
};
/* XPM */
static const char *img109[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c gray60",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&%%&&&&&&&%&&&&&&&&&&&&",
"&&&&&&&&&&+Xo&&&$oo@&&&&&&&&&&&&",
"&&&&&&&&&&&&@X&& @&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&o+++&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&#o $&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&..&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&o+&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&O+&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&++&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&++&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&$$&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img10greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 18 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c gainsboro",
"; c #DDDDDD",
": c #EEEEEE",
"> c gray100",
", c None",
/* pixels */
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>>>@$@#>>>>>>>>>>>>>",
">>>>>>>>>>>>>>&@>* >>>>>>>>>>>>>",
">>>>>>>>>>>>>>+=>* >>>>>>>>>>>>>",
">>>>>>>>>>>>>>+*>% >>>>>>>>>>>>>",
">>>>>>>>>>>$#=;O># >>>>>>>>>>>>>",
">>>>>>>>>>;#*X>;$X.;>>>>>>>>>>>>",
">>>>>>>>>>#&#o>>: @=>>>>>>>>>>>>",
">>>>>>>>>>=,X#>>* *>>>>>>>>>>>>>",
">>>>>>>>>>>= *>>#.>>>>>>>>>>>>>>",
">>>>>>>>>>>> ;>> %>>>>>>>>>>>>>>",
">>>>>>>>>>>> >>#+>>>>>>>>>>>>>>>",
">>>>>>>>>>>;.$%O>>>>>>>>>>>>>>>>",
">>>>>>>>>>>>>==>>>>>>>>>>>>>>>>>"
};
/* XPM */
static const char *img10[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&%@&&&&&&%O&&&&&&&&&&&&",
"&&&&&&&&&&#O&&&&&&#X&&&&&&&&&&&&",
"&&&&&&&&&&#O&&$O&&#X&&&&&&&&&&&&",
"&&&&&&&&&&#O&&#X&&#X&&&&&&&&&&&&",
"&&&&&&&&&&#O%#+.###X&&&&&&&&&&&&",
"&&&&&&&&&&#OOX. XX@X&&&&&&&&&&&&",
"&&&&&&&&&&#O&&#X&&#X&&&&&&&&&&&&",
"&&&&&&&&&&#o&&#X&&@X&&&&&&&&&&&&",
"&&&&&&&&&&& @&&&&$.#&&&&&&&&&&&&",
"&&&&&&&&&&&%.XOOO @&&&&&&&&&&&&&",
"&&&&&&&&&&&&&%OO@&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img110[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #555555",
". c gray40",
"X c #777777",
"o c #888888",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c gray80",
"# c #DDDDDD",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%@+$%%%%%%%%%%%%%%",
"%%%%%%%%%%%%$XXO+o.+%%%%%%%%%%%%",
"%%%%%%%%%%%$.#%%%%%oO%%%%%%%%%%%",
"%%%%%%%%%%%X@%%%%%%%.$%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%#o%%%%%%%%%%",
"%%%%%%%%%%%X%#+++++%%X%%%%%%%%%%",
"%%%%%%%%%%%X%#+++++%%X%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%#o%%%%%%%%%%",
"%%%%%%%%%%%X+%%%%%%% $%%%%%%%%%%",
"%%%%%%%%%%%$.#%%%%%oO%%%%%%%%%%%",
"%%%%%%%%%%%%$XXO+o.+%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%@+$%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img111[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"=============&@+#===============",
"===========*+@&=#+#=============",
"==========*O&=*#==@#============",
"==========+%==$X===O*===========",
"==========+=o+*+$.%&@===========",
"==========+=*+X X$==+===========",
"==========+=*+. .$==+===========",
"==========+=o+*+$.%&@===========",
"==========+$==$X===o*===========",
"==========*O&=*#==@#============",
"===========*+@&=#+#=============",
"=============&@+#==============="
};
/* XPM */
static const char *img112[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------&%=---------------",
"-----------=@@$%#+%-------------",
"----------=+*-----#$------------",
"----------@&--&%=--+=-----------",
"----------@--@X@ *-*#-----------",
"----------@--.--@@--@-----------",
"----------@--.=-@#--@-----------",
"----------@--#.Xo*-*#-----------",
"----------@%--*%---O=-----------",
"----------=+*-----#$------------",
"-----------=@@$%#+%-------------",
"--------------&%=---------------"
};
/* XPM */
static const char *img113[] = {
/* columns rows colors chars-per-pixel */
"32 32 4 1",
"  c black",
". c #777777",
"X c #BBBBBB",
"o c gray100",
/* pixels */
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooX  .ooooooooooooooo",
"oooooooooooooX  .ooooooooooooooo",
"oooooooooooooX  .ooooooooooooooo"
};
/* XPM */
static const char *img114[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c gray60",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"***********.     o**************",
"***********+OX oO@**************",
"*************@ $****************",
"*************@ $****************",
"*************@ $****************",
"*************@ $****************",
"*************@ $****************",
"*************@ $****************",
"*************@ $****************",
"*************@ $****************",
"*************%#&****************"
};
/* XPM */
static const char *img115[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::-#o:::::::::::",
"::::::::::::::::=@.%;:::::::::::",
"::::::::::::::-+.$::::::::::::::",
"::::::::::::;@o#::::::::::::::::",
":::::::::::# #::::::::::::::::::",
":::::::::::-+X&:::::::::::::::::",
":::::::::::::=Oo%:::::::::::::::",
":::::::::::::::-+o$:::::::::::::",
":::::::::::::::::=+.&:::::::::::",
":::::::::::::::::::*#:::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::%#########:::::::::::",
":::::::::::-********=:::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::-********=:::::::::::",
":::::::::::#OOOOOOOO+:::::::::::"
};
/* XPM */
static const char *img116[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::-::::::::::::",
":::::::::::::::::=+o::::::::::::",
":::::::::::::::=+o&:::::::::::::",
":::::::::::::=Oo%:::::::::::::::",
":::::::::::=+o&:::=@::::::::::::",
"::::::::::#X&:::&+o*::::::::::::",
"::::::::::::::*oo*::::::::::::::",
"::::::::::::=oo&::::::::::::::::",
"::::::::::*OO&::::::::::::::::::",
"::::::::::% #;::::::::::::::::::",
":::::::::::;#.$;::::::::::::::::",
":::::::::::::;#o#;::::::::::::::",
":::::::::::::::;#.#-::::::::::::",
":::::::::::::::::-#X::::::::::::"
};
/* XPM */
static const char *img117[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::=@::::::::::::",
"::::::::::::::::&+o*::::::::::::",
"::::::::::::::*oX*::::::::::::::",
"::::::::::::=+o&::::::::::::::::",
"::::::::::*OO&::::::::::::::::::",
"::::::::::% $;::::::::::::::::::",
":::::::::::-#.$;::::::::::::::::",
":::::::::::::;#o#;::::::::::::::",
":::::::::::::::;@.#:::::::::::::",
":::::::::::::::::-#X::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#O#:::::-&:::::::::::",
"::::::::::#X#oX-:::&#:::::::::::",
"::::::::::X;::#.&;=X-:::::::::::",
"::::::::::#::::&.  #::::::::::::",
"::::::::::-::::::*-:::::::::::::"
};
/* XPM */
static const char *img118[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::&Oo::::::::::::",
"::::::::::::::;$XO*:::::::::::::",
"::::::::::::-+.@;:::::::::::::::",
"::::::::::=+o#;:::::::::::::::::",
"::::::::::$.@=::::::::::::::::::",
":::::::::::;%.O*::::::::::::::::",
"::::::::::::::&Oo$::::::::::::::",
"::::::::::::::::-@X#::::::::::::",
"::::::::::::::::::;$::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::-+ O&::::=$:::::::::::",
"::::::::::o+*#.@;::@%:::::::::::",
"::::::::::@:::;OXOoo::::::::::::",
"::::::::::*;*;::%#$;;:::::::::::",
"::::::::::=X .$::::*#:::::::::::",
"::::::::::X$*&XO=:;O&:::::::::::",
"::::::::::#::::# o.@::::::::::::",
"::::::::::*:::::-#&:::::::::::::"
};
/* XPM */
static const char *img119[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;-&-;;;;;;-;;;;;;;;;;;",
";;;;;;;;;;&X .@;;;;&@;;;;;;;;;;;",
";;;;;;;;;;X$;&OX%-*o&;;;;;;;;;;;",
";;;;;;;;;;@;;;;#   @;;;;;;;;;;;;",
";;;;;;;;;;=*@&;;=&*-*;;;;;;;;;;;",
";;;;;;;;;;$ O.O=;;;%@;;;;;;;;;;;",
";;;;;;;;;;.*;-+ #-&.*;;;;;;;;;;;",
";;;;;;;;;;@;;;;%X .$;;;;;;;;;;;;",
";;;;;;;;;;=;;;;;;&=;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@@@@@@@@@@&;;;;;;;;;;;",
";;;;;;;;;;@@@@@@@@@@&;;;;;;;;;;;"
};
/* XPM */
static const char *img11greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************$+****************",
"**************oO****************",
"*************& #****************",
"*************$ %****************",
"*************+X*****************",
"*************.+*$@**************",
"************* $*o%**************",
"************* @o#***************",
"*************&$*****************"
};
/* XPM */
static const char *img11[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;; oOOOOOOOOO *;;;;;;;;;",
";;;;;;;;;;+#;;;;;;;;%X;;;;;;;;;;",
";;;;;;;;;;= =;;;;;;;X%;;;;;;;;;;",
";;;;;;;;;;;##;;;;;;%O;;;;;;;;;;;",
";;;;;;;;;;;=.=;;;;; %;;;;;;;;;;;",
";;;;;;;;;;;;$+;;;;#@;;;;;;;;;;;;",
";;;;;;;;;;;;;X*;;-X*;;;;;;;;;;;;",
";;;;;;;;;;;;;$o;;#@;;;;;;;;;;;;;",
";;;;;;;;;;;;;;o%=.;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;%o+#;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;o.=;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*&;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img120[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==================@O============",
"===============*#.@&============",
"=============*$.@&==============",
"===========*#.@&=*==============",
"==========$o+*==O $=============",
"==========$XO*==O $=============",
"===========*#.@&=*==============",
"=============*$.@%==============",
"================#.@&============",
"==================@O============"
};
/* XPM */
static const char *img121[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;&;;;;&-;;;&-;;;;;;",
";;;;;;;;;;;;*oO;;=Oo=;=OX=;;;;;;",
";;;;;;;;;;=+X%;-@.$;-# $;;;;;;;;",
";;;;;;;;;$.#-;% #-;&.@-;;;;;;;;;",
";;;;;;;&XO*;*Oo=;*oX*;;;;;;;;;;;",
";;;;;;O.*;;+X%;;@X%;;;;;;;;;;;;;",
";;;;;;O.*;;+ %;;@.%;;;;;;;;;;;;;",
";;;;;;;&XO*;*Oo=;*oX*;;;;;;;;;;;",
";;;;;;;;;$.@-;% @-;&.@-;;;;;;;;;",
";;;;;;;;;;;+X%;;@.$;;# $;;;;;;;;",
";;;;;;;;;;;;*oO;;=Oo=;=OX=;;;;;;",
";;;;;;;;;;;;;;*;;;;*-;;;*-;;;;;;"
};
/* XPM */
static const char *img122[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::;$@@:::::::::::",
":::::::::::::::*+X+*::::::::::::",
"::::::::::::-#oO$;::::::::::::::",
":::::::::;%oX#-:::::::::::::::::",
":::::::::& X*:::::::::::::::::::",
"::::::::::-&oX#-::::::::::::::::",
":::::::::::::;#oo#::::::::::::::",
":::::::::%.@-:::*@.O=:::::::::::",
"::::::::::-#oX%-:::%%:::::::::::",
":::::::::::::=#.+$::::::::::::::",
"::::::::::::::::*+.#=:::::::::::",
":::::::::::::::::=+.#:::::::::::",
"::::::::::::::=#.O$;::::::::::::",
":::::::::::;%OX#=:::::::::::::::",
":::::::::=@ @*::::::::::::::::::",
":::::::::=&:::::::::::::::::::::"
};
/* XPM */
static const char *img123[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::;-:::::::::::",
":::::::::::::::::-@X%:::::::::::",
":::::::::::::::&XO$:::::::::::::",
"::::::::::::=#X@&:::::::::::::::",
":::::::::::# #-:::::::::::::::::",
":::::::::::;#.+&::::::::::::::::",
"::::::::::::::&+X#;:::::::::::::",
"::::::::::::::::-#X+-:::::::::::",
"::::::::::::::::::;&*:::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::@        #:::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::&=:::::::::::::::::::",
":::::::::::%oo&:::::::::::::::::",
":::::::::::::&@X#=::::::::::::::",
":::::::::::::::-#XO*::::::::::::",
":::::::::::::::::;+ #:::::::::::",
":::::::::::::::-@o+=::::::::::::",
":::::::::::::*+o#;::::::::::::::",
":::::::::::%.+&:::::::::::::::::",
":::::::::::=-:::::::::::::::::::"
};
/* XPM */
static const char *img124[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*@.;;;;;;;;;;;;",
";;;;;;;;;;;;;;-#X.$=;;;;;;;;;;;;",
";;;;;;;;;;;;&@ +&;;;;;;;;;;;;;;;",
";;;;;;;;;;$XX#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%o.#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@ +&;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;-%X.@=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;-@.;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%@@@@@@@@#;;;;;;;;;;;;",
";;;;;;;;;;*&&&&&&&&&;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@ooooooooO;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@#-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;*@ O&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-#o.$=;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*@ +%;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=@ O;;;;;;;;;;;;",
";;;;;;;;;;;;;;&OX+=;;;;;;;;;;;;;",
";;;;;;;;;;;*@ O$;;;;;;;;;;;;;;;;",
";;;;;;;;;;@.#*;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;=-;;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img125[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c #111111",
". c #444444",
"X c #555555",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$@$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$X @$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$oX$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$++++++++++#$$$$$$$$$$$$",
"$$$$$$$$$..........O$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$..........O$$$$$$$$$$$$",
"$$$$$$$$$++++++++++#$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$oX$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$X @$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$@$$$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img126[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************.X**********",
"********************O+**********",
"********************************",
"***********##########&**********",
"***********oooooooooo@**********",
"********************************",
"********************************",
"***********oooooooooo@**********",
"***********##########&**********",
"********************************",
"**********@o%*******************",
"**********+ $*******************"
};
/* XPM */
static const char *img127[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**********+ $*******************",
"**********@o%*******************",
"********************************",
"***********##########&**********",
"***********oooooooooo@**********",
"********************************",
"********************************",
"***********oooooooooo@**********",
"***********##########&**********",
"********************************",
"********************O+**********",
"********************.X**********"
};
/* XPM */
static const char *img128[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%;;;;;$++*;;;;;;;;;;;;",
";;;;;;;;;;O;;;-oo#@X=;;;;;;;;;;;",
";;;;;;;;;;O+*#.#-;;&#;;;;;;;;;;;",
";;;;;;;;;;=+ O&;;;;;#;;;;;;;;;;;"
};
/* XPM */
static const char *img129[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c gray20",
"o c #777777",
"O c #888888",
"+ c #BBBBBB",
"@ c gray80",
"# c #DDDDDD",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%+%%%%%@OO#%%%%%%%%%%%%",
"%%%%%%%%%%o%%%$o X.X$%%%%%%%%%%%",
"%%%%%%%%%%.o+OXX@%%oo%%%%%%%%%%%",
"%%%%%%%%%%#X XO%%%%%o%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%          o%%%%%%%%%%%"
};
/* XPM */
static const char *img12greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::*#::;%%::::::::::::",
":::::::::::::++:*#oX::::::::::::",
"::::::::::::; %$$:-;::::::::::::",
"::::::::::::* X+=:::::::::::::::",
"::::::::::::$.:&Oo;:::::::::::::",
"::::::::::::o@::; *%=:::::::::::",
":::::::::::: #::* ;@;:::::::::::",
":::::::::::- *::: $@::::::::::::",
"::::::::::::=::::;=:::::::::::::"
};
/* XPM */
static const char *img12[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c gray20",
". c #444444",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************$#&***************",
"***********&OO@#OO%*************",
"**********&.@****& $************",
"**********O#o%**&o%o************",
"**********O*&o$&X$*+#***********",
"**********O***oo%***O***********",
"**********O***XX%***O***********",
"**********O*&o$&X$*+#***********",
"**********O@X%**&o$o************",
"**********&.#***** $************",
"***********&OO@#OO%*************",
"**************$#&***************"
};
/* XPM */
static const char *img130[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;$ .ooooO;;;;;;;;;;;;",
";;;;;;;;;;;@X*;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;* -;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+@;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;o&;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;o$;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;$O;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-.$;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;=.o$&&&&*;;;;;;;;;;;;",
";;;;;;;;;;;;;#@@@@@@;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@ooooooooO;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%@@@@@@@@#;;;;;;;;;;;;",
";;;;;;;;;;%@@@@@@@@#;;;;;;;;;;;;"
};
/* XPM */
static const char *img131[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"============&OoooooO============",
"===========#.@&=================",
"==========& %=&$$$$%============",
"==========++=@XooooO============",
"==========o#=X*=================",
"==========o#=X*=================",
"==========++=@XooooO============",
"==========& %=&$$$$%============",
"===========$.@&=================",
"============&OoooooO============"
};
/* XPM */
static const char *img132[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;@;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;-.;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;+#;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;=@O-;;;;;;;;;;;",
";;;;;;;;;;;=&%##O.$;;;;;;;;;;;;;",
";;;;;;;;;;;#OOO.X#-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;&@.%;;;;;;;;;;;;",
";;;;;;;;;;;%#%&-;;*X%;;;;;;;;;;;",
";;;;;;;;;;;*&#+.#-;&O;;;;;;;;;;;",
";;;;;;;;;;;;;;;;#o=; ;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;#o;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;X-;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;$=;;;;;;;;;;;;"
};
/* XPM */
static const char *img133[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::-::::::::::::::",
":::::::::::::::::+=:::::::::::::",
"::::::::::::::::* ::::::::::::::",
":::::::::::::::-X%:@::::::::::::",
":::::::::::::=@o%:;.::::::::::::",
"::::::::::@ o@$;::+#::::::::::::",
"::::::::::::::::-@O;::::::::::::",
"::::::::::-*&##O.$::::::::::::::",
"::::::::::#OOO.X#;::::::::::::::",
":::::::::::::::*@.&:::::::::::::",
":::::::::::::::::=X&::::::::::::",
"::::::::::::::::::*O::::::::::::",
"::::::::::::::::::: ::::::::::::"
};
/* XPM */
static const char *img134[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::@::::::::::::",
"::::::::::::::::::-X::::::::::::",
"::::::::::::::::::O#::::::::::::",
"::::::::::::::::=O@:::::::::::::",
"::::::::::=*&#+ O%::::::::::::::",
"::::::::::&##O.X#-::::::::::::::",
":::::::::::::::*$.%:::::::::::::",
":::::::::::::::::;o%::::::::::::",
"::::::::::::::::::*o::::::::::::",
":::::::::::::::::::X::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#O#:::::-&:::::::::::",
"::::::::::#X#oX-:::&#:::::::::::",
"::::::::::X;::#.&;=X-:::::::::::",
"::::::::::#::::&.  #::::::::::::",
"::::::::::-::::::*-:::::::::::::"
};
/* XPM */
static const char *img135[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::: ::::::::::::",
"::::::::::::::::::%O::::::::::::",
":::::::::::::::::$X=::::::::::::",
"::::::::::-**%#OX+;:::::::::::::",
"::::::::::%##@O o&::::::::::::::",
":::::::::::::::;*++;::::::::::::",
"::::::::::::::::::@@::::::::::::",
":::::::::::::::::::.::::::::::::",
":::::::::::::::::::%::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::-+ O&::::=$:::::::::::",
"::::::::::o+*#.@;::@%:::::::::::",
"::::::::::@:::;OXOoo::::::::::::",
"::::::::::*;*;::%#$;;:::::::::::",
"::::::::::=X .$::::*#:::::::::::",
"::::::::::X$*&XO=:;O&:::::::::::",
"::::::::::#::::# o.@::::::::::::",
"::::::::::*:::::-#&:::::::::::::"
};
/* XPM */
static const char *img136[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------------*+-------------",
"---------------&Oo -------------",
"-------------&OX%- -------------",
"-----------&+.$=-- -------------",
"---------&Oo%----- -------------",
"---------@ #------ -------------",
"----------&+.$=--- -------------",
"------------&@X#=- -------------",
"--------------=OX# -------------",
"----------------*O.-------------"
};
/* XPM */
static const char *img137[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*+ ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*+o& ;;;;;;;;;;;;",
";;;;;;;;;;;;;*Oo%;; ;;;;;;;;;;;;",
";;;;;;;;;;;*+o&;;;; ;;;;;;;;;;;;",
";;;;;;;;;;# %;;;;;; ;;;;;;;;;;;;",
";;;;;;;;;;-@o#;;;;; ;;;;;;;;;;;;",
";;;;;;;;;;;;=+X$;;; ;;;;;;;;;;;;",
";;;;;;;;;;;;;;=#.$- ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=#. ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@        X;;;;;;;;;;;;"
};
/* XPM */
static const char *img138[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #777777",
"O c #BBBBBB",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@+@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@ XXXXXXo@@@@@@@@@@@@@",
"@@@@@@@@@@@.OOOOOO+@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@.OOOOOO+@@@@@@@@@@@@@",
"@@@@@@@@@@@ XXXXXXo@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@X@@@@@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img139[] = {
/* columns rows colors chars-per-pixel */
"32 32 4 1",
"  c black",
". c #444444",
"X c #DDDDDD",
"o c gray100",
/* pixels */
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooXooXooXoooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo      ooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo",
"ooooooooo.oo.oo oooooooooooooooo"
};
/* XPM */
static const char *img13greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;=+X*;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;X@;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;@.;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;* %;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;o@;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;# -;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;% &;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;%OOO;;;;;;;;;;;;;",
";;;;;;;;;;;;;;&.=% *;;;;;;;;;;;;",
";;;;;;;;;;;;;& *;= $;;;;;;;;;;;;",
";;;;;;;;;;;;% &;;;@X;;;;;;;;;;;;",
";;;;;;;;;;;; #;;;;$ *;;;;;;;;;;;",
";;;;;;;;;;;;*;;;;;;*=;;;;;;;;;;;"
};
/* XPM */
static const char *img13[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c black",
". c #777777",
"X c #888888",
"o c gray60",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@..@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@  +@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@Oo@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@..........@@@@@@@@@@@",
"@@@@@@@@@@@..........@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@oX@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@  +@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@..@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img140[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========&========**===========",
"========== %=======X#===========",
"==========#X*=====+O============",
"===========#.#*=$X+*============",
"============%@oo@$=============="
};
/* XPM */
static const char *img141[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==============%$*===============",
"============#.Xo +*=============",
"==========*OO*===+o%============",
"==========+O======@o============",
"==========.&=======o@===========",
"==========&========**==========="
};
/* XPM */
static const char *img142[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&@ XO%&&&&&&&&&&&&&&",
"&&&&&&&&&&$$#.%&O+$$%&&&&&&&&&&&",
"&&&&&&&&&&ooo+&&#ooo#&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&oooooooooo#&&&&&&&&&&&",
"&&&&&&&&&&$$$$$$$$$$%&&&&&&&&&&&"
};
/* XPM */
static const char *img143[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&@ XO%&&&&&&&&&&&&&&",
"&&&&&&&&&&$$#.%&O+$$%&&&&&&&&&&&",
"&&&&&&&&&&ooo+&&#ooo#&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&ooo+&&#ooo#&&&&&&&&&&&",
"&&&&&&&&&&$$#.%&O+$$%&&&&&&&&&&&",
"&&&&&&&&&&&&&@ XO%&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img144[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&O.@&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&@.X@&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&#..#&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&#..#&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&@ .&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&$o.#&&&&&&&&&&&&",
"&&&&&&&&&&&&&&#o @&&&&&&&&&&&&&&",
"&&&&&&&&&&&&$o.@&&&&&&&&&&&&&&&&",
"&&&&&&&&&&$X.@&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&++&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&+OOOOOOOOO&&&&&&&&&&&&",
"&&&&&&&&&&%########$&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&%########$&&&&&&&&&&&&",
"&&&&&&&&&&OXXXXXXXXo&&&&&&&&&&&&"
};
/* XPM */
static const char *img145[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;=;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@.#;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;*OX%;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&+.%-;;;;;;;;;;;;;;",
";;;;;;;;;;@$-;;*O.%;;;;;;;;;;;;;",
";;;;;;;;;;=O.#;;;*oX;;;;;;;;;;;;",
";;;;;;;;;;;;=OX#;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=O #;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;*+ $;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;$.+;;;;;;;;;;;;",
";;;;;;;;;;;;;;;$Xo=;;;;;;;;;;;;;",
";;;;;;;;;;;;;%XO*;;;;;;;;;;;;;;;",
";;;;;;;;;;-%.+&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+O&;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img146[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#%;:::::::::::::::::::",
"::::::::::-+X$::::::::::::::::::",
"::::::::::::-OX$::::::::::::::::",
"::::::::::::::-+o$::::::::::::::",
"::::::::::::::::=@.%::::::::::::",
":::::::::::::::::&X@::::::::::::",
":::::::::::::::%oO=:::::::::::::",
":::::::::::::&o+=:::::::::::::::",
":::::::::::*X+*:::::::::::::::::",
"::::::::::@+*:::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#O#:::::-&:::::::::::",
"::::::::::#X#oX-:::&#:::::::::::",
"::::::::::X;::#.&;=X-:::::::::::",
"::::::::::#::::&.  #::::::::::::",
"::::::::::-::::::*-:::::::::::::"
};
/* XPM */
static const char *img147[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#X%;::::::::::::::::::",
":::::::::::=#.#-::::::::::::::::",
"::::::::::::::#.O*::::::::::::::",
"::::::::::::::::%oO&::::::::::::",
"::::::::::::::::-$.@::::::::::::",
"::::::::::::::=# #=:::::::::::::",
"::::::::::::&+.%;:::::::::::::::",
"::::::::::%oO*::::::::::::::::::",
"::::::::::&=::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::-+ O&::::=$:::::::::::",
"::::::::::o+*#.@;::@%:::::::::::",
"::::::::::@:::;OXOoo::::::::::::",
"::::::::::*;*;::%#$;;:::::::::::",
"::::::::::=X .$::::*#:::::::::::",
"::::::::::X$*&XO=:;O&:::::::::::",
"::::::::::#::::# o.@::::::::::::",
"::::::::::*:::::-#&:::::::::::::"
};
/* XPM */
static const char *img148[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&Oo%&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&%+.O#&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&%@ O$&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&%&%+ O$&&&&&&&&&&&&&",
"&&&&&&&&&&&#  &&&+XO&&&&&&&&&&&&",
"&&&&&&&&&&&#  &&&+.O&&&&&&&&&&&&",
"&&&&&&&&&&&&%&%+ O$&&&&&&&&&&&&&",
"&&&&&&&&&&&&%+ O$&&&&&&&&&&&&&&&",
"&&&&&&&&&&%+.O%&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&Oo%&&&&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img149[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;%;;;-%;;;-*;;;;;;;;;;;;;;",
";;;;;;;XX*;=XO=;=X+-;;;;;;;;;;;;",
";;;;;;;;&XO*;$.@=-# @-;;;;;;;;;;",
";;;;;;;;;;$ #--# #-=@.%;;;;;;;;;",
";;;;;;;;;;;-@ #;=+.$;*Oo&;;;;;;;",
";;;;;;;;;;;;;=+X&;*Oo*;*XO;;;;;;",
";;;;;;;;;;;;;=OX&;*Xo*;* O;;;;;;",
";;;;;;;;;;;-@ #;=+.$;*Oo&;;;;;;;",
";;;;;;;;;;# #--@ #-=@.%;;;;;;;;;",
";;;;;;;;&XO-;$.@;-# @;;;;;;;;;;;",
";;;;;;;XX*;=XO=;=X+-;;;;;;;;;;;;",
";;;;;;;*;;;-*;;;-=;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img14greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-O;;;=#;;;;;;;;;;;;;",
";;;;;;;;;;;;& ;;;@.;;;;;;;;;;;;;",
";;;;;;;;;;;;@X;;;o+;;;;;;;;;;;;;",
";;;;;;;;;;;;X@;;= %;;;;;;;;;;;;;",
";;;;;;;;;;;* &;;& *;;;;;;;;;;;;;",
";;;;;;;;;;;& =;;@X;@;;;;;;;;;;;;",
";;;;;;;;;;;+ ;;-.@$@;;;;;;;;;;;;",
";;;;;;;;;;;X @%O+OO-;;;;;;;;;;;;",
";;;;;;;;;;; #**;;*-;;;;;;;;;;;;;",
";;;;;;;;;;% =;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+o;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;O#;;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img14[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c gray20",
". c #444444",
"X c gray40",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@........O@@@@@@@@@@@@@",
"@@@@@@@@@@ ++++++Xo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@",
"@@@@@@@@@@.@@@@@@oo@@@@@@@@@@@@@"
};
/* XPM */
static const char *img150[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;+O$;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&XX@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;*OX@-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;-@.O*;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;$ X;;;;;;;;;;;",
";;;;;;;;;;;;;;;-#.o&;;;;;;;;;;;;",
";;;;;;;;;;;;;=O.+-;;;;;;;;;;;;;;",
";;;;;;;;;;;*o.@-;;*o.;;;;;;;;;;;",
";;;;;;;;;;;$$;;-%.o#;;;;;;;;;;;;",
";;;;;;;;;;;;;=@ +&;;;;;;;;;;;;;;",
";;;;;;;;;;;*@ @-;;;;;;;;;;;;;;;;",
";;;;;;;;;;;@ +-;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-# o&;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;#oX%;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;&O #;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;-#;;;;;;;;;;;"
};
/* XPM */
static const char *img151[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::-;:::::::::::::::::::",
":::::::::::#o@-:::::::::::::::::",
"::::::::::::;$oo&:::::::::::::::",
":::::::::::::::&@.#=::::::::::::",
":::::::::::::::::-# %:::::::::::",
"::::::::::::::::%O.$::::::::::::",
":::::::::::::;#o+*::::::::::::::",
":::::::::::*OX$-::::::::::::::::",
":::::::::::&&;::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::@        #:::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::**:::::::::::",
":::::::::::::::::%oO*:::::::::::",
"::::::::::::::=#.#*:::::::::::::",
":::::::::::;&Oo$-:::::::::::::::",
":::::::::::@ +::::::::::::::::::",
"::::::::::::*+o#-:::::::::::::::",
"::::::::::::::-#o+*:::::::::::::",
":::::::::::::::::%+.*:::::::::::",
":::::::::::::::::::=-:::::::::::"
};
/* XPM */
static const char *img152[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+O%;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-%o @=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;*@ +$;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;%OX@;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;%o.#;;;;;;;;;;;;",
";;;;;;;;;;;;;*@ +$;;;;;;;;;;;;;;",
";;;;;;;;;;-#o #=;;;;;;;;;;;;;;;;",
";;;;;;;;;;+O*;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%@@@@@@@@#;;;;;;;;;;;;",
";;;;;;;;;;*&&&&&&&&&;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@ooooooooO;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;&O;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*@ +%;;;;;;;;;;;;",
";;;;;;;;;;;;-%o.@=;;;;;;;;;;;;;;",
";;;;;;;;;;*@ O&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@ O*;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;-@Xo$;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;&@ +&;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=%oX;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;*;;;;;;;;;;;;"
};
/* XPM */
static const char *img153[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #777777",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray80",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%@@@@@@@@@@$%%%%%%%%%%%",
"%%%%%%%%%%ooo.Xo ooo+%%%%%%%%%%%",
"%%%%%%%%%%%%%O%%O#%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O%%O#%%%%%%%%%%%%%%",
"%%%%%%%%%%ooo.Xo ooo+%%%%%%%%%%%",
"%%%%%%%%%%@@@@@@@@@@$%%%%%%%%%%%"
};
/* XPM */
static const char *img154[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"=============# .O===============",
"=============X*=.%==============",
"=============o@$ *==============",
"=============*+o&===============",
"================================",
"==========%%%%%%%%%%*===========",
"==========XXXXXXXXXX$===========",
"================================",
"================================",
"==========XXXXXXXXXX$===========",
"==========%%%%%%%%%%*==========="
};
/* XPM */
static const char *img155[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"---------------*----------------",
"--------------@.*---------------",
"-------------=X+@---------------",
"-------------O@*.%--------------",
"------------$o=-@o--------------",
"------------o$---o$-------------",
"-----------& OOOOX+-------------",
"--------------------------------",
"----------%%%%%%%%%%*-----------",
"----------OOOOOOOOOO#-----------",
"--------------------------------",
"--------------------------------",
"----------OOOOOOOOOO#-----------",
"----------%%%%%%%%%%*-----------"
};
/* XPM */
static const char *img156[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------=@o@%----*$-----------",
"----------OXoX.@---+#-----------",
"----------.&--@ .@o.*-----------",
"----------@----&+ .%------------"
};
/* XPM */
static const char *img157[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::;#O#=::::-%:::::::::::",
"::::::::::O O. $;::##:::::::::::",
"::::::::::X-:-# .#O -:::::::::::",
"::::::::::%::::-@OO*::::::::::::",
"::::::::::-O o&::::=$:::::::::::",
"::::::::::XX#o +=:;+$:::::::::::",
"::::::::::O;::*. o..;:::::::::::",
"::::::::::%::::;$O+-::::::::::::"
};
/* XPM */
static const char *img158[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#OOOOo #;:::::::::::::",
"::::::::::::::::-#o;::::::::::::",
"::::::::::::::::::+$::::::::::::",
"::::::::::::::::::-X::::::::::::",
"::::::::::::::::::: ::::::::::::",
"::::::::::::::::::: ::::::::::::",
"::::::::::::::::::$@::::::::::::",
":::::::::::::::::=X*::::::::::::",
"::::::::::-****&@.%:::::::::::::",
"::::::::::%######;::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#OOOOOOOO+::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::&########$::::::::::::",
"::::::::::&########$::::::::::::"
};
/* XPM */
static const char *img159[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========@oooooo$==============",
"===============*#o+=============",
"==========&$$$$%=*X#============",
"==========@oooo.O*$o============",
"================o$= ============",
"================o$= ============",
"==========@oooo.O*$o============",
"==========&$$$$%=*.#============",
"===============*#o@=============",
"==========@oooooo$=============="
};
/* XPM */
static const char *img15greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;@+o;;;-O;;;;;;;;;;;;;",
";;;;;;;;;;;&XO;;;# ;;;;;;;;;;;;;",
";;;;;;;;;;;- $;;;oO;;;;;;;;;;;;;",
";;;;;;;;;;;& &;;&.*;;;;;;;;;;;;;",
";;;;;;;;;;;#.;;-.%;;;;;;;;;;;;;;",
";;;;;;;;;;;X+;=o$;;;;;;;;;;;;;;;",
";;;;;;;;;;; @%o&;;;;;;;;;;;;;;;;",
";;;;;;;;;;= o$;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img15[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================%o$=============",
"==============&@.O$=============",
"=============# @*@$=============",
"===========%X+*==@$=============",
"===========%Xo*==@$=============",
"=============# @*@$=============",
"==============&@.o$=============",
"================&o$============="
};
/* XPM */
static const char *img160[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#-:::::::::::::::::::",
":::::::::::+$:::::::::::::::::::",
":::::::::::&X;::::::::::::::::::",
"::::::::::::#o=:::::::::::::::::",
":::::::::::::*oX##%*=:::::::::::",
"::::::::::::::&O OOO+:::::::::::",
"::::::::::::-o+%::::::::::::::::",
":::::::::::-.%:::**#$:::::::::::",
":::::::::::##::%Xo#&*:::::::::::",
":::::::::::O&:@o-:::::::::::::::",
":::::::::::::$O:::::::::::::::::",
":::::::::::::o-:::::::::::::::::",
":::::::::::::@::::::::::::::::::"
};
/* XPM */
static const char *img161[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::-:::::::::::::::::::",
"::::::::::::.:::::::::::::::::::",
"::::::::::::@#::::::::::::::::::",
"::::::::::#--X%:::::::::::::::::",
"::::::::::+$:=O+&;::::::::::::::",
"::::::::::&X;::%#O X::::::::::::",
":::::::::::#o=::::::::::::::::::",
"::::::::::::*oX##%*=::::::::::::",
":::::::::::::&O OOO+::::::::::::",
":::::::::::-o+%:::::::::::::::::",
"::::::::::-.%:::::::::::::::::::",
"::::::::::##::::::::::::::::::::",
"::::::::::O&::::::::::::::::::::"
};
/* XPM */
static const char *img162[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#-::::::::::::::::::::",
"::::::::::@#::::::::::::::::::::",
"::::::::::*.-:::::::::::::::::::",
":::::::::::%o&::::::::::::::::::",
"::::::::::::=@.o#%**::::::::::::",
"::::::::::::;%+ O@#$::::::::::::",
":::::::::::=o#*;::::::::::::::::",
"::::::::::=X*:::::::::::::::::::",
"::::::::::##::::::::::::::::::::",
"::::::::::+*::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#O#:::::-&:::::::::::",
"::::::::::#X#oX-:::&#:::::::::::",
"::::::::::X;::#.&;=X-:::::::::::",
"::::::::::#::::&.  #::::::::::::",
"::::::::::-::::::*-:::::::::::::"
};
/* XPM */
static const char *img163[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::O&:::::::::::::::::::::",
":::::::::#+:::::::::::::::::::::",
":::::::::;o+;:::::::::::::::::::",
":::::::::::#XO#$**=:::::::::::::",
":::::::::::=+.o+###:::::::::::::",
"::::::::::$X&-::::::::::::::::::",
":::::::::%o;::::::::::::::::::::",
":::::::::+$:::::::::::::::::::::",
":::::::::&;:::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::-+ O&::::=$::::::::::::",
":::::::::o+*#.@;::@%::::::::::::",
":::::::::@:::;OXOoo:::::::::::::",
":::::::::*;*;::%#$;;::::::::::::",
":::::::::=X .$::::*#::::::::::::",
":::::::::X$*&XO=:;O&::::::::::::",
":::::::::#::::# o.@:::::::::::::",
":::::::::*:::::-#&::::::::::::::"
};
/* XPM */
static const char *img164[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%O@%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X. @%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X#$X.@%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X#%%$XX+%%%%%%%%%%%%%",
"%%%%%%%%%%%X#%%%%$o.@%%%%%%%%%%%",
"%%%%%%%%%%%X#%%%%%$ X%%%%%%%%%%%",
"%%%%%%%%%%%X#%%%@.X@%%%%%%%%%%%%",
"%%%%%%%%%%%X#%@X.@%%%%%%%%%%%%%%",
"%%%%%%%%%%%XOo.#%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%o.#%%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img165[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========&=====================",
"==========o.@===================",
"==========o@OX#=================",
"==========o$=$+.#*==============",
"==========o$===%O.#=============",
"==========o$=====%.X============",
"==========o$====#XO%============",
"==========o$==$.X$==============",
"==========o$#Xo#================",
"==========o.o%==================",
"==========#%====================",
"================================",
"================================",
"==========+        .============"
};
/* XPM */
static const char *img166[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c #444444",
"X c gray60",
"o c #BBBBBB",
"O c #DDDDDD",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++O++O++++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.     X++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++",
"++++++++++.++.o+++++++++++++++++"
};
/* XPM */
static const char *img167[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #444444",
". c #555555",
"X c #AAAAAA",
"o c #BBBBBB",
"O c gray80",
"+ c #EEEEEE",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@.O@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@ o@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@ o@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@ o@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@ o@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@ o@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@ o@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@X+@@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img168[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #444444",
". c #777777",
"X c gray60",
"o c #BBBBBB",
"O c gray80",
"+ c #EEEEEE",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@O.@@ O@@@@@@@@@@@@@@",
"@@@@@@@@@@@@o.@@ o@@@@@@@@@@@@@@",
"@@@@@@@@@@@@o.@@ o@@@@@@@@@@@@@@",
"@@@@@@@@@@@@o.@@ o@@@@@@@@@@@@@@",
"@@@@@@@@@@@@o.@@ o@@@@@@@@@@@@@@",
"@@@@@@@@@@@@o.@@ o@@@@@@@@@@@@@@",
"@@@@@@@@@@@@o.@@ o@@@@@@@@@@@@@@",
"@@@@@@@@@@@@+o@@X+@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img169[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #222222",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------$+==+%--------------",
"-------------&oo*---------------",
"-------------=Xo----------------",
"-------------+%@+---------------",
"------------&X--X=--------------",
"------------+@--++--------------",
"------------.&--&O--------------",
"------------ ----X--------------",
"------------ ----X--------------",
"------------.*--*O--------------",
"------------O#--#+--------------",
"------------%O--X*--------------",
"-------------o&$O---------------",
"-------------*XX=---------------",
"-------------=Xo=---------------",
"------------%O=*O%--------------"
};
/* XPM */
static const char *img16greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::#%::::::::::::::::",
":::::::::::::=OoO&::::::::::::::",
"::::::::::::%.%=*;::::::::::::::",
":::::::::::= O::::::::::::::::::",
":::::::::::* &::::::::::::::::::",
":::::::::::= $**;:::::::::::::::",
"::::::::::::+XOo%:::::::::::::::",
":::::::::::@$:::::::::::::::::::",
"::::::::::*+::::::::::::::::::::",
"::::::::::+%::::::::::::::::::::",
"::::::::::O+::::::::::::::::::::",
"::::::::::& +%::::::::::::::::::",
":::::::::::*O X#::::::::::::::::",
":::::::::::::-#.#:::::::::::::::",
"::::::::::::;-:O%:::::::::::::::",
"::::::::::::;$#%::::::::::::::::"
};
/* XPM */
static const char *img16[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c gray20",
". c #444444",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"***************$#&**************",
"************&OO@#OO%************",
"***********&o%****& $***********",
"***********O$****&o%o***********",
"***********O****&X$*+#**********",
"***********O****o%***O**********",
"***********O***X$****O**********",
"***********O*&o$****+#**********",
"***********O@X%*****o***********",
"***********&.#*****O$***********",
"************&OO@#OO%************",
"***************$#&**************"
};
/* XPM */
static const char *img170[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"===============O================",
"===============o================",
"===============o================",
"============*$o +&==============",
"===========%.@%X#Oo*============",
"=========== &==o==+@============",
"===========X===o==%o============",
"===========o===o==&o============",
"===========o===o==&o============",
"===========o===o==&o============",
"===========o===o==&o============",
"===========o===o==&o============",
"===========%===%==*%============"
};
/* XPM */
static const char *img171[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"===========&+O@*==%O$===========",
"==========$X+$Oo*Oo#&===========",
"==========.#===Oo.*=============",
"==========o====* +==============",
"==========o====* +==============",
"==========.#===Oo.*=============",
"==========$XOOOo*OoO%===========",
"===========*+O@===&O$==========="
};
/* XPM */
static const char *img172[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c #111111",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c gray80",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$@o$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$+X  $$$$$$$$$$$",
"$$$$$$$$$$$$$$$+X    $$$$$$$$$$$",
"$$$$$$$$$$$$$+o      $$$$$$$$$$$",
"$$$$$$$$$$$+X        $$$$$$$$$$$",
"$$$$$$$$$$$O         $$$$$$$$$$$",
"$$$$$$$$$$$$+o       $$$$$$$$$$$",
"$$$$$$$$$$$$$$+O     $$$$$$$$$$$",
"$$$$$$$$$$$$$$$$#X   $$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$@X.$$$$$$$$$$$"
};
/* XPM */
static const char *img173[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************&%****************",
"**************o.****************",
"**************@O****************",
"********************************",
"********************************",
"********************************",
"********************************",
"**********%+&*****#@************",
"**********+ $*****XX************"
};
/* XPM */
static const char *img174[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-------------*&-----------------",
"-----------=+#$o*---------------",
"-----------=*--@X---------------",
"---------------% &--------------",
"------------*%%+ &--------------",
"------------&++.X---------------",
"--------------$ %---------------",
"-----------*+Oo&----------------"
};
/* XPM */
static const char *img175[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%+#%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%o .#%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%o   X#%%%%%%%%%%%%%%%%",
"%%%%%%%%%%o     o@%%%%%%%%%%%%%%",
"%%%%%%%%%%o       X#%%%%%%%%%%%%",
"%%%%%%%%%%o        o%%%%%%%%%%%%",
"%%%%%%%%%%o      o#%%%%%%%%%%%%%",
"%%%%%%%%%%o    X#%%%%%%%%%%%%%%%",
"%%%%%%%%%%o  X$%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%OX$%%%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img176[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #444444",
"X c #555555",
"o c #777777",
"O c #888888",
"+ c #AAAAAA",
"@ c gray80",
"# c #DDDDDD",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%@%%%%%%##%%%%%%%%%%%%",
"%%%%%%%%%%O @%%%%%X.%%%%%%%%%%%%",
"%%%%%%%%%%@X$%%%%%Oo%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%+O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%. %%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img177[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;%;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;*X;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;+@;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;&.@O;;;;;;;;;;;",
";;;;;;;;;;;;;;;;-O @=;;;;;;;;;;;",
";;;;;;;;;;;;;;-$..=;;;;;;;;;;;;;",
";;;;;;;;;;;;-#.@o#;;;;;;;;;;;;;;",
";;;;;;;;;;;$o+-=.-;;;;;;;;;;;;;;",
";;;;;;;;;;;$XO-O#;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-#..*;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;OO.@*;;;;;;;;;;;;;",
";;;;;;;;;;;;;*X;;#.@=;;;;;;;;;;;",
";;;;;;;;;;;;;+@;;;;@O;;;;;;;;;;;",
";;;;;;;;;;;;*.;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;+#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;%-;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img178[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::o::::::::::::",
"::::::::::::::::::&o::::::::::::",
"::::::::::::::::::@$*:::::::::::",
":::::::::::::::::= oo:::::::::::",
"::::::::::::::::*Xo*::::::::::::",
"::::::::::::::&oO =:::::::::::::",
"::::::::::::&oO=&O::::::::::::::",
":::::::::::@ %::o&::::::::::::::",
":::::::::::;#o#=X:::::::::::::::",
":::::::::::::;#.+;::::::::::::::",
"::::::::::::::;X#.#-::::::::::::",
"::::::::::::::#+:-$X#:::::::::::",
"::::::::::::::X*::::%:::::::::::",
":::::::::::::&O:::::::::::::::::",
":::::::::::::+%:::::::::::::::::",
":::::::::::+        .:::::::::::",
"::::::::::::$#::::::::::::::::::",
"::::::::::::#=::::::::::::::::::"
};
/* XPM */
static const char *img179[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::o::::::::::::",
"::::::::::::::::::&o::::::::::::",
"::::::::::::::::::@$*:::::::::::",
":::::::::::::::::= oo:::::::::::",
"::::::::::::::::*Xo*::::::::::::",
"::::::::::::::&oO =:::::::::::::",
"::::::::::::&oO=&O::::::::::::::",
":::::::::::@ %::o&::::::::::::::",
":::::::::::;#o#=X:::::::::::::::",
":::::::::::::;#.+;::::::::::::::",
":::::::::::=-:;X#.#-::::::::::::",
":::::::::::%.##+:-$X#:::::::::::",
":::::::::::::$ +-:::%:::::::::::",
":::::::::::::&O#o@;:::::::::::::",
":::::::::::::+%:;$X#-:::::::::::",
"::::::::::::- ::::;$X:::::::::::",
"::::::::::::$#::::::::::::::::::",
"::::::::::::#=::::::::::::::::::"
};
/* XPM */
static const char *img17greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::;&######%::::::::::::",
":::::::::::@+#X#o@#%::::::::::::",
"::::::::::&@:%#:X;::::::::::::::",
":::::::::::::#=:o:::::::::::::::",
":::::::::::::.::O:::::::::::::::",
"::::::::::::&X:*X:::::::::::::::",
"::::::::::::o$:* -::::::::::::::",
":::::::::::* *:: *::::::::::::::",
"::::::::::::=:::=:::::::::::::::"
};
/* XPM */
static const char *img17[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************$%****************",
"**************@@****************",
"************ @@#@X**************",
"************&+Xo@&**************",
"************&O.X@&**************",
"************ @@#@X**************",
"**************@@****************",
"**************$%****************"
};
/* XPM */
static const char *img180[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::%::::::::::::",
"::::::::::::::::::-X::::::::::::",
"::::::::::::::::::#@::::::::::::",
"::::::::::::::::::OO.:::::::::::",
"::::::::::::::::;# #-:::::::::::",
"::::::::::::::;#.o@:::::::::::::",
"::::::::::::;#X#;O*:::::::::::::",
":::::::::::$ #;:*X;:::::::::::::",
":::::::::::*OO=:##::::::::::::::",
":::::::::::::&oOX*::::::::::::::",
":::::::::::::::% o*:::::::::::::",
":::::::::::::::##&oo=:::::::::::",
":::::::::::::::o*::&@:::::::::::",
"::::::::::::::-o::::::::::::::::",
":::::::::::%##OX#####:::::::::::",
":::::::::::&## #####$:::::::::::",
":::::::::::::&O:::::::::::::::::",
":::::::::::::##:::::::::::::::::",
":::::::::::+        .:::::::::::",
"::::::::::::*X::::::::::::::::::",
"::::::::::::#$::::::::::::::::::",
"::::::::::::#-::::::::::::::::::"
};
/* XPM */
static const char *img181[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*+o;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*+o&;;;;;;;;;;;;;",
";;;;;;;;;;;;;*Oo%;;;;;;;;;;;;;;;",
";;;;;;;;;;;*+o&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;# %;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-@o#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=+X$;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=#.$-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=#.$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;$*;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;#o=;;;;;;;;;;;;;;",
";;;;;;;;;;@        X;;;;;;;;;;;;",
";;;;;;;;;;;;;$X=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;@-;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img182[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::-#o::::::::::::",
":::::::::::::::=@.%;::::::::::::",
":::::::::::::-+.$:::::::::::::::",
":::::::::::;@o#:::::::::::::::::",
"::::::::::# #:::::::::::::::::::",
"::::::::::-+X&::::::::::::::::::",
"::::::::::::=Oo%::::::::::::::::",
"::::::::::::::-+o$::::::::::::::",
"::::::::::::::::=+.&::::::::::::",
":::::::::::::::::-%#::::::::::::",
"::::::::::::::::=o&:::::::::::::",
"::::::::::%#####Oo##::::::::::::",
"::::::::::-****o@**=::::::::::::",
"::::::::::::::$O;:::::::::::::::",
"::::::::::-**%.$***=::::::::::::",
"::::::::::#OX.OOOOO+::::::::::::",
":::::::::::-X%::::::::::::::::::",
":::::::::::-&:::::::::::::::::::"
};
/* XPM */
static const char *img183[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::-#o:::::::::::",
"::::::::::::::::=@.%;:::::::::::",
"::::::::::::::-+.$::::::::::::::",
"::::::::::::;@o#::::::::::::::::",
":::::::::::# #::::::::::::::::::",
":::::::::::-+X&:::::::::::::::::",
":::::::::::::=Oo%:::::::::::::::",
":::::::::::::::-+o$:::::::::::::",
":::::::::::::::::=+.&:::::::::::",
":::::::::::::::;-::*#:::::::::::",
":::::::::::::::*#:::::::::::::::",
":::::::::::%###@O####:::::::::::",
":::::::::::-***$@***=:::::::::::",
":::::::::::::::*#:::::::::::::::",
":::::::::::-***$@***=:::::::::::",
":::::::::::#OOOoXOOO+:::::::::::",
":::::::::::::::*#:::::::::::::::",
":::::::::::::::-*:::::::::::::::"
};
/* XPM */
static const char *img184[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::=@::::::::::::",
"::::::::::::::::&+o*::::::::::::",
"::::::::::::::*oX*::::::::::::::",
"::::::::::::=+o&::::::::::::::::",
"::::::::::*OO&::::::::::::::::::",
"::::::::::% $;::::::::::::::::::",
":::::::::::-#.$;::::::::::::::::",
":::::::::::::;#o#;::::::::::::::",
":::::::::::::::;@.#:::::::::::::",
":::::::::::::::::-#X::::::::::::",
"::::::::::::::::$&::::::::::::::",
":::::::::::::::-.=::::::::::::::",
":::::::::::#O#:##::-&:::::::::::",
"::::::::::#X#oX -::&#:::::::::::",
"::::::::::X;::O.&;=X-:::::::::::",
"::::::::::#::;X$.  #::::::::::::",
"::::::::::-::#+::*-:::::::::::::",
"::::::::::::;X-:::::::::::::::::",
"::::::::::::;%::::::::::::::::::"
};
/* XPM */
static const char *img185[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::&Oo::::::::::::",
"::::::::::::::;$XO*:::::::::::::",
"::::::::::::-+.@;:::::::::::::::",
"::::::::::=+o#;:::::::::::::::::",
"::::::::::$.@=::::::::::::::::::",
":::::::::::;%.O*::::::::::::::::",
"::::::::::::::&Oo$::::::::::::::",
"::::::::::::::::-@X#::::::::::::",
"::::::::::::::::*=;$::::::::::::",
"::::::::::::::::o&::::::::::::::",
"::::::::::-+ O&=.;:=$:::::::::::",
"::::::::::o+*#.o$::@%:::::::::::",
"::::::::::@:::; XOoo::::::::::::",
"::::::::::*;*;*O%#$;;:::::::::::",
"::::::::::=X .X$:::*#:::::::::::",
"::::::::::X$*% O=:;O&:::::::::::",
"::::::::::#::#+# o.@::::::::::::",
"::::::::::*::O*:-#&:::::::::::::",
"::::::::::::-X::::::::::::::::::"
};
/* XPM */
static const char *img186[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;*;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;*X;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;@#;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;&.;O;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;+$-X;;;;;;;;;;;",
";;;;;;;;;;;;;;;;*.-+#;;;;;;;;;;;",
";;;;;;;;;;;;;;;;+@+O-;;;;;;;;;;;",
";;;;;;;;;;;=&%#+ o$;;;;;;;;;;;;;",
";;;;;;;;;;;#OOO.X#-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;*X%#.%;;;;;;;;;;;;",
";;;;;;;;;;;;;;+#;;=X%;;;;;;;;;;;",
";;;;;;;;;;;;;*X;;;;&O;;;;;;;;;;;",
";;;;;;;;;;;;;@#;;;;;X;;;;;;;;;;;",
";;;;;;;;;;;;&.;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;+$;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;*-;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img187[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::o::::::::::::",
"::::::::::::::::::&o::::::::::::",
"::::::::::::::::::@$*:::::::::::",
":::::::::::::::::= : :::::::::::",
":::::::::::::::::##&+:::::::::::",
"::::::::::::::::;.$X*:::::::::::",
":::::::::::::::=$ X=::::::::::::",
":::::::::::#Oo   $;:::::::::::::",
":::::::::::::;*#.o@:::::::::::::",
":::::::::::::::@#;#X;:::::::::::",
"::::::::::::::;X-::##:::::::::::",
"::::::::::::::#+:::;.:::::::::::",
"::::::::::::::X*::::%:::::::::::",
":::::::::::::&O:::::::::::::::::",
":::::::::::::+%:::::::::::::::::",
":::::::::::@        X:::::::::::",
"::::::::::::$#::::::::::::::::::",
"::::::::::::#=::::::::::::::::::"
};
/* XPM */
static const char *img188[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::@::::::::::::",
"::::::::::::::::::-X::::::::::::",
"::::::::::::::::::O#::::::::::::",
"::::::::::::::::=O@:::::::::::::",
"::::::::::=*&#+ O%::::::::::::::",
"::::::::::&##O.X#-::::::::::::::",
":::::::::::::::*$.%:::::::::::::",
":::::::::::::::::;o%::::::::::::",
"::::::::::::::::::*o::::::::::::",
":::::::::::::::::::X::::::::::::",
"::::::::::::::::$&::::::::::::::",
":::::::::::::::-.=::::::::::::::",
":::::::::::#O#:##::-&:::::::::::",
"::::::::::#X#oX -::&#:::::::::::",
"::::::::::X;::O.&;=X-:::::::::::",
"::::::::::#::;X$.  #::::::::::::",
"::::::::::-::#+::*-:::::::::::::",
"::::::::::::;X-:::::::::::::::::",
"::::::::::::;%::::::::::::::::::"
};
/* XPM */
static const char *img189[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::: :::::::::::::",
":::::::::::::::::%O:::::::::::::",
"::::::::::::::::$X=:::::::::::::",
":::::::::-**%#OX+;::::::::::::::",
":::::::::%##@O o&:::::::::::::::",
"::::::::::::::;*++;:::::::::::::",
":::::::::::::::::@@:::::::::::::",
"::::::::::::::::::.:::::::::::::",
"::::::::::::::::::%:::::::::::::",
":::::::::::::::&&:::::::::::::::",
":::::::::-+ O&;X*:=$::::::::::::",
":::::::::o+*#.OO::@%::::::::::::",
":::::::::@:::; XOoo:::::::::::::",
":::::::::*;*;*o%#$;;::::::::::::",
":::::::::=X ..%:::*#::::::::::::",
":::::::::X$*# O=:;O&::::::::::::",
":::::::::#::+## o.@:::::::::::::",
":::::::::*:-X::-#&::::::::::::::"
};
/* XPM */
static const char *img18greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::;&###########:::::::::",
"::::::::::@+O+#######X#:::::::::",
":::::::::&#-o;::-;:::#::::::::::",
":::::::::::#&:::@*:::@::::::::::",
":::::::::::o:::- :::;X::::::::::",
"::::::::::-O:::+ :::$$::::::::::",
"::::::::::=X;:#+.-:%o;::::::::::",
":::::::::::oo.+:#Xoo;:::::::::::",
"::::::::::::*;:::==:::::::::::::"
};
/* XPM */
static const char *img18[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c #777777",
"O c #AAAAAA",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"+++++++++++o++++++OO++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++X++++++oo++++++++++++",
"+++++++++++ XXXXXX.o++++++++++++"
};
/* XPM */
static const char *img190[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------------$=-------------",
"----------------#X=-------------",
"----------=@o@%& &-*$-----------",
"----------OXoX..%--+#-----------",
"----------.&--X .@o.*-----------",
"----------@--o+&+ .%------------",
"------------@o=-----------------",
"------------O=------------------"
};
/* XPM */
static const char *img191[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************O$%***************",
"**************ooO***************",
"**************XX&***************",
"*************+ #****************",
"************@..#****************",
"************%%o#****************",
"**************o#****************",
"**************@&****************"
};
/* XPM */
static const char *img192[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************$+****************",
"**************$+****************",
"**************$+****************",
"**************$+&%**************",
"**************$+o@**************",
"**************# +***************",
"*************%.O****************",
"************%X++****************",
"************$#$+****************",
"**************$+****************",
"**************$+****************",
"**************$+****************",
"**************$+****************",
"**************$+****************",
"**************$+****************",
"**************$+****************"
};
/* XPM */
static const char *img193[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;=;;;;;;*;;;;;;;;;;;",
";;;;;;;;;;;;;O;;;;;#+;;;;;;;;;;;",
";;;;;;;;;;;;;O;;;;$.=;;;;;;;;;;;",
";;;;;;;;;;;;;O;;;*X*;;;;;;;;;;;;",
";;;;;;;;;;;;;O;;=X&;;;;;;;;;;;;;",
";;;;;;;;;;;;;O;-X$;;;;;;;;;;;;;;",
";;;;;;;;;;;;;       @;;;;;;;;;;;",
";;;;;;;;;;;;;O@+;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;; o-;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;%X*;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&XO;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o%O;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img194[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::-::::::=::::::::::::",
"::::::::::::O:::::#+::::::::::::",
"::::::::::::O::::%.-::::::::::::",
"::::::::::::O:::=X=:::::::::::::",
"::::::::::::.OOO.XO#::::::::::::",
"::::::::::::o*&.$**-::::::::::::",
"::::::::::::O;O#::::::::::::::::",
"::::::::::::o@X****-::::::::::::",
":::::::::::: XOOOOO#::::::::::::",
":::::::::::&X=::::::::::::::::::",
"::::::::::*XO:::::::::::::::::::",
"::::::::::o&O:::::::::::::::::::"
};
/* XPM */
static const char *img195[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-*;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;#@;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;-.=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;$O&O;;;;;;;;;;;",
";;;;;;;;;;;;;;;;-X O ;;;;;;;;;;;",
";;;;;;;;;;;;;;;*OX%; ;;;;;;;;;;;",
";;;;;;;;;;;;;%Oo %;; ;;;;;;;;;;;",
";;;;;;;;;;;&oo&=.;;; ;;;;;;;;;;;",
";;;;;;;;;;;#.#;+$;;; ;;;;;;;;;;;",
";;;;;;;;;;;;-#X.&;;; ;;;;;;;;;;;",
";;;;;;;;;;;;;;@o.#-; ;;;;;;;;;;;",
";;;;;;;;;;;;;-X=-#.$ ;;;;;;;;;;;",
";;;;;;;;;;;;;$+;;;-#X;;;;;;;;;;;",
";;;;;;;;;;;;;X*;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&X;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-=;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img196[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::&+:::::::::::::",
":::::::::::::::::#%:::::::::::::",
"::::::::::::::::-.;*::::::::::::",
"::::::::::::::::$Xo ::::::::::::",
":::::::::::::::*Xo* ::::::::::::",
":::::::::::::&oo.;: ::::::::::::",
":::::::::::&oO=$#:: ::::::::::::",
"::::::::::@ %::X*:: ::::::::::::",
"::::::::::;#o#=X::: ::::::::::::",
"::::::::::::;#.+;:: ::::::::::::",
"::::::::::::::o#.#- ::::::::::::",
":::::::::::::%o:-$X ::::::::::::",
":::::::::::::+$::::%::::::::::::",
"::::::::::::;X;:::::::::::::::::",
"::::::::::::$+::::::::::::::::::",
"::::::::::+        .::::::::::::",
":::::::::::- :::::::::::::::::::",
":::::::::::=#:::::::::::::::::::"
};
/* XPM */
static const char *img197[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::o:::::::::::::",
":::::::::::::::::&o:::::::::::::",
"::::::::::::::=**+@=::::::::::::",
"::::::::::::#.XOo O+::::::::::::",
":::::::::::@O;::##::::::::::::::",
"::::::::::&X;::;.=::::::::::::::",
"::::::::::@#:::&O:::::::::::::::",
"::::::::::O*:::o&:::::::::::::::",
"::::::::::+$::-X::::::::::::::::",
"::::::::::%O::@#::::::::::::::::",
"::::::::::;o#;X-::::::::::::::::",
":::::::::::;OXX####$::::::::::::",
":::::::::::::X#####$::::::::::::",
"::::::::::::&O::::::::::::::::::",
"::::::::::::+%::::::::::::::::::",
"::::::::::*        X::::::::::::",
":::::::::::$#:::::::::::::::::::",
":::::::::::#=:::::::::::::::::::"
};
/* XPM */
static const char *img198[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::=****=::::::::::::",
"::::::::::::#.XOOOO+::::::::::::",
":::::::::::@O;::::::::::::::::::",
"::::::::::&X;:::::::::::::::::::",
"::::::::::@#::::::::::::::::::::",
"::::::::::O*::::::::::::::::::::",
"::::::::::+$::::::::::::::::::::",
"::::::::::%O::::::::::::::::::::",
"::::::::::;o#:::::::::::::::::::",
":::::::::::;OO#####$::::::::::::",
":::::::::::::=$####$::::::::::::",
"::::::::::::::::%&::::::::::::::",
":::::::::::::::#o-::::::::::::::",
"::::::::::*        X::::::::::::",
":::::::::::::@O;::::::::::::::::",
"::::::::::::-#::::::::::::::::::"
};
/* XPM */
static const char *img199[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::=****=::::::::::::",
"::::::::::::#.XOOOO+::::::::::::",
":::::::::::@O;::::::::::::::::::",
"::::::::::&X;:::::::::::::::::::",
"::::::::::@#::::::::::::::::::::",
"::::::::::O*::::::::::::::::::::",
"::::::::::+$::::::::::::::::::::",
"::::::::::%O::::::::::::::::::::",
"::::::::::;o#:::-X-:::::::::::::",
":::::::::::;OO##OX#$::::::::::::",
":::::::::::::=$Xo##$::::::::::::",
"::::::::::::::*X-:::::::::::::::",
":::::::::::::-X*::::::::::::::::",
"::::::::::*        X::::::::::::",
"::::::::::::#O::::::::::::::::::",
"::::::::::::+:::::::::::::::::::"
};
/* XPM */
static const char *img19greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::=##&:::::::::::::",
"::::::::::::::%O;;X$::::::::::::",
":::::::::::::* ;::Oo::::::::::::",
":::::::::::::O@:::X.::::::::::::",
"::::::::::::= *::= +::::::::::::",
"::::::::::::& -::& &::::::::::::",
"::::::::::::@ -:;X@:::::::::::::",
"::::::::::::XO@&O#::::::::::::::",
":::::::::::: $-*::::::::::::::::",
":::::::::::& -::::::::::::::::::",
":::::::::::@o:::::::::::::::::::",
":::::::::::+$:::::::::::::::::::"
};
/* XPM */
static const char *img19[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&@O$&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&+O @%&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&++%+.#&&&&&&&&&&&&&&",
"&&&&&&&&&&&&++&&$OX$&&&&&&&&&&&&",
"&&&&&&&&&&&&++&&$XX$&&&&&&&&&&&&",
"&&&&&&&&&&&&++%+.#&&&&&&&&&&&&&&",
"&&&&&&&&&&&&+o @%&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&@O$&&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img1greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-------------&+++=--------------",
"-----------=+.*-@X=&+-----------",
"-----------+ *--* %O%-----------",
"----------= O---- $X------------",
"----------# @---- .$------------",
"----------+ %---- O-------------",
"----------* $---@ #*=-----------",
"-----------OX$@+$+oo*-----------",
"------------=%*---&=------------"
};
/* XPM */
static const char *img1[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%$#%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%ooooX.oooo@%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%          +%%%%%%%%%%%"
};
/* XPM */
static const char *img200[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::=$####$::::::::::::",
":::::::::::;OO#####$::::::::::::",
"::::::::::;o#:::::::::::::::::::",
"::::::::::%O::::::::::::::::::::",
"::::::::::+$::::::::::::::::::::",
"::::::::::O*::::::::::::::::::::",
"::::::::::@#::::::::::::::::::::",
"::::::::::&X;:::::::::::::::::::",
":::::::::::@O;::::::::::::::::::",
"::::::::::::#.XOOOO+::::::::::::",
"::::::::::::::=****=::::::::::::",
":::::::::::::::::;&:::::::::::::",
":::::::::::::::::+#:::::::::::::",
"::::::::::::::::#O::::::::::::::",
"::::::::::#OOOO..OO+::::::::::::",
"::::::::::::::;.*:::::::::::::::",
"::::::::::::::O#::::::::::::::::",
"::::::::::#OOo OOOO+::::::::::::",
"::::::::::-*#X*****=::::::::::::",
":::::::::::-.=::::::::::::::::::",
":::::::::::-*:::::::::::::::::::"
};
/* XPM */
static const char *img201[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::%.XOOOO+::::::::::::",
":::::::::::#o=::::::::::::::::::",
"::::::::::=.;:::::::::::::::::::",
"::::::::::@#::::::::::::::::::::",
"::::::::::O*::::::::::::::::::::",
"::::::::::O%::::::::::::::::::::",
"::::::::::%+::::::::::::::::::::",
"::::::::::;X%:::::##::::::::::::",
":::::::::::-XO%**& *::::::::::::",
":::::::::::::$###.@#::::::::::::",
"::::::::::::::::%X::::::::::::::",
":::::::::::::::;X&::::::::::::::",
"::::::::::#OOOOo OO+::::::::::::",
"::::::::::::::;.-:::::::::::::::",
"::::::::::::::+#::::::::::::::::",
"::::::::::&### ####$::::::::::::",
"::::::::::&## #####$::::::::::::",
"::::::::::::$+::::::::::::::::::"
};
/* XPM */
static const char *img202[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::&::::::::::::",
"::::::::::::::::::=X::::::::::::",
"::::::::::::::::::@#::::::::::::",
":::::::::::#@;:::*.:::::::::::::",
":::::::::::;$X#=:+$:::::::::::::",
":::::::::::::;%.+.;:::::::::::::",
":::::::::::::::;o #-::::::::::::",
":::::::::::::::-.;$o#:::::::::::",
":::::::::::::::+$:$X#:::::::::::",
"::::::::::::::=.#.#-::::::::::::",
":::::::::::::;O #-::::::::::::::",
":::::::::::;$XX;::::::::::::::::",
":::::::::::#@+#:::::::::::::::::",
"::::::::::::=.::::::::::::::::::",
"::::::::::::@$::::::::::::::::::",
"::::::::::::&;::::::::::::::::::"
};
/* XPM */
static const char *img203[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::o:::::::::::::",
":::::::::::::::::&o:::::::::::::",
"::::::::::=;:::::@$:::::::::::::",
"::::::::::#X#:::= ::::::::::::::",
":::::::::::;@o#:##::::::::::::::",
":::::::::::::-#..*::::::::::::::",
":::::::::::::::%X.%;::::::::::::",
":::::::::::::::o&-XX::::::::::::",
"::::::::::::::-X$X+-::::::::::::",
"::::::::::::::@ +=::::::::::::::",
":::::::::::;%..=::::::::::::::::",
"::::::::::%X+++:::::::::::::::::",
"::::::::::&-:X*:::::::::::::::::",
"::::::::::::&O::::::::::::::::::",
"::::::::::::+%::::::::::::::::::",
"::::::::::+        .::::::::::::",
":::::::::::$#:::::::::::::::::::",
":::::::::::#=:::::::::::::::::::"
};
/* XPM */
static const char *img204[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::o:::::::::::::",
":::::::::::::::::&o:::::::::::::",
"::::::::::=;:::::@$:::::::::::::",
"::::::::::#X#:::= ::::::::::::::",
":::::::::::;@o#:##::::::::::::::",
":::::::::::::-#..*::::::::::::::",
":::::::::::::::%X.%;::::::::::::",
":::::::::::::::o&-XX::::::::::::",
"::::::::::::::-X$X+-::::::::::::",
"::::::::::::::@ +=::::::::::::::",
":::::::::::;%..=::;*::::::::::::",
"::::::::::%X+++:;$.#::::::::::::",
"::::::::::&-:X*$X+;:::::::::::::",
"::::::::::::&.o@;:::::::::::::::",
"::::::::::;$.@-:::::::::::::::::",
"::::::::::+O :::::::::::::::::::",
":::::::::::$#:::::::::::::::::::",
":::::::::::#=:::::::::::::::::::"
};
/* XPM */
static const char *img205[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::::%::::::::::::",
"::::::::::::::::::-X::::::::::::",
"::::::::::::::::::#@::::::::::::",
":::::::::::++=::::O*::::::::::::",
":::::::::::;&X@*:- :::::::::::::",
"::::::::::::::&.++@:::::::::::::",
"::::::::::::::::$ O-::::::::::::",
"::::::::::::::::*X%X+:::::::::::",
"::::::::::::::::#@#.%:::::::::::",
":::::::::::::::-X.$;::::::::::::",
":::::::::::::-+XX:::::::::::::::",
":::::::::::;+X###:::::::::::::::",
":::::::::::#$;:o*:::::::::::::::",
"::::::::::::::-o::::::::::::::::",
":::::::::::%##OX#####:::::::::::",
":::::::::::&## #####$:::::::::::",
":::::::::::::&O:::::::::::::::::",
":::::::::::::##:::::::::::::::::",
":::::::::::+        .:::::::::::",
"::::::::::::*X::::::::::::::::::",
"::::::::::::#$::::::::::::::::::",
"::::::::::::#-::::::::::::::::::"
};
/* XPM */
static const char *img206[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------*---------------------",
"----------@.#-------------------",
"-----------&OX$-----------------",
"-------------%+.$=--------------",
"---------------&O.$-------------",
"-----------------&.X------------",
"----------------$XO&------------",
"--------------%.X%--------------",
"------------$Xo$----------------",
"----------$oo&------------------",
"----------$&--------------------",
"----------------#&--------------",
"---------------@X*--------------",
"----------+        .------------",
"-------------#.*----------------",
"-------------+=-----------------"
};
/* XPM */
static const char *img207[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;@X%;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;%Xo%;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;&XX&;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;&XX&;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;%.X;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*OX&;;;;;;;;;;;",
";;;;;;;;;;;;;;;&O.%;;;;;;;;;;;;;",
";;;;;;;;;;;;;*OX%;;;;;;;;;;;;;;;",
";;;;;;;;;;;*oX%;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;$$;;;;;==;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*X%;;;;;;;;;;;;",
";;;;;;;;;;;$@@@@@oX@@;;;;;;;;;;;",
";;;;;;;;;;;=&&&&X+&&*;;;;;;;;;;;",
";;;;;;;;;;;;;;;#o-;;;;;;;;;;;;;;",
";;;;;;;;;;;=&&$ #&&&*;;;;;;;;;;;",
";;;;;;;;;;;@o. oooooO;;;;;;;;;;;",
";;;;;;;;;;;;=.$;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=%;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img208[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------+.$-------------------",
"-----------$.X$-----------------",
"-------------%..%---------------",
"---------------%..%-------------",
"-----------------$ .------------",
"----------------&o.%------------",
"--------------%o $--------------",
"------------&o.$----------------",
"----------&X.$------------------",
"----------##--=*----------------",
"--------------%+----------------",
"----------#+++OX++++------------",
"----------*%%%@O%%%&------------",
"--------------%+----------------",
"----------*%%%@O%%%&------------",
"----------+XXX. XXXo------------",
"--------------%+----------------",
"--------------*%----------------"
};
/* XPM */
static const char *img209[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#%;:::::::::::::::::::",
"::::::::::-+X$::::::::::::::::::",
"::::::::::::-OX$::::::::::::::::",
"::::::::::::::-+o$::::::::::::::",
"::::::::::::::::=@.%::::::::::::",
":::::::::::::::::&X@::::::::::::",
":::::::::::::::%oO=:::::::::::::",
":::::::::::::&o+=:::::::::::::::",
":::::::::::*X+*:::::::::::::::::",
"::::::::::@+*:::::::::::::::::::",
"::::::::::::::::$&::::::::::::::",
":::::::::::::::-.=::::::::::::::",
":::::::::::#O#:##::-&:::::::::::",
"::::::::::#X#oX -::&#:::::::::::",
"::::::::::X;::O.&;=X-:::::::::::",
"::::::::::#::;X$.  #::::::::::::",
"::::::::::-::#+::*-:::::::::::::",
"::::::::::::;X-:::::::::::::::::",
"::::::::::::;%::::::::::::::::::"
};
/* XPM */
static const char *img20greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::=##&:::::::::::::",
"::::::::::::::%O;;X$::::::::::::",
":::::::::::::* ;::Oo::::::::::::",
":::::::::::::O@:::X.::::::::::::",
"::::::::::::- *::= +::::::::::::",
"::::::::::::* *::& &::::::::::::",
"::::::::::::# *:;X@:::::::::::::",
"::::::::::::O$+&O#::::::::::::::",
"::::::::::::o:-*::::::::::::::::",
"::::::::::::X-::::::::::::::::::",
"::::::::::::@   .%::::::::::::::",
":::::::::::::-****::::::::::::::"
};
/* XPM */
static const char *img20[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #222222",
"X c gray40",
"o c #777777",
"O c gray60",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&#@%&&&&&&&&&&&&&&&",
"&&&&&&&&&&&%oo+@oo$&&&&&&&&&&&&&",
"&&&&&&&&&&%X$&&&&&o#&&&&&&&&&&&&",
"&&&&&&&&&&o#&&&&&&&X&&&&&&&&&&&&",
"&&&&&&&&&&o&&&%$&&&O@&&&&&&&&&&&",
"&&&&&&&&&&o&&&. #&&&o&&&&&&&&&&&",
"&&&&&&&&&&o&&&. #&&&o&&&&&&&&&&&",
"&&&&&&&&&&o&&&%$&&&O@&&&&&&&&&&&",
"&&&&&&&&&&o@&&&&&&&X&&&&&&&&&&&&",
"&&&&&&&&&&%X$&&&&&o#&&&&&&&&&&&&",
"&&&&&&&&&&&%oo+@oo$&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&#@%&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img210[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::#X%;::::::::::::::::::",
":::::::::::=#.#-::::::::::::::::",
"::::::::::::::#.O*::::::::::::::",
"::::::::::::::::%oO&::::::::::::",
"::::::::::::::::-$.@::::::::::::",
"::::::::::::::=# #=:::::::::::::",
"::::::::::::&+.%;:::::::::::::::",
"::::::::::%oO*::::::::::::::::::",
"::::::::::&=::::*=::::::::::::::",
"::::::::::::::::o&::::::::::::::",
"::::::::::-+ O&=.;:=$:::::::::::",
"::::::::::o+*#.o$::@%:::::::::::",
"::::::::::@:::; XOoo::::::::::::",
"::::::::::*;*;*O%#$;;:::::::::::",
"::::::::::=X .X$:::*#:::::::::::",
"::::::::::X$*% O=:;O&:::::::::::",
"::::::::::#::#+# o.@::::::::::::",
"::::::::::*::O*:-#&:::::::::::::",
"::::::::::::-X::::::::::::::::::"
};
/* XPM */
static const char *img211[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::=:::::::::::::",
":::::::::::::::::=X:::::::::::::",
":::::::::::::::::@#:::::::::::::",
"::::::::::#=::::*.::::::::::::::",
"::::::::::@#::::+$::::::::::::::",
"::::::::::&X;::=.;::::::::::::::",
":::::::::::#o&:+$:::::::::::::::",
"::::::::::::=+o #%*=::::::::::::",
":::::::::::::&o OOO+::::::::::::",
":::::::::::=ooX;::::::::::::::::",
"::::::::::-.&+#:::::::::::::::::",
"::::::::::##=X::::::::::::::::::",
"::::::::::+*@#::::::::::::::::::",
":::::::::::*.:::::::::::::::::::",
":::::::::::+$:::::::::::::::::::",
":::::::::::=;:::::::::::::::::::"
};
/* XPM */
static const char *img212[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::o:::::::::::::",
":::::::::::::::::&o:::::::::::::",
"::::::::::=;:::::@$:::::::::::::",
"::::::::::O%::::= ::::::::::::::",
"::::::::::$@::::##::::::::::::::",
"::::::::::-o#::;.=::::::::::::::",
":::::::::::;@o%$O:::::::::::::::",
":::::::::::::=@  XO+::::::::::::",
"::::::::::::%ooX*-::::::::::::::",
":::::::::::@O-@#::::::::::::::::",
"::::::::::&o;;X-::::::::::::::::",
"::::::::::+$:#+:::::::::::::::::",
"::::::::::&;:X*:::::::::::::::::",
"::::::::::::&O::::::::::::::::::",
"::::::::::::+%::::::::::::::::::",
"::::::::::@        X::::::::::::",
":::::::::::$#:::::::::::::::::::",
":::::::::::#=:::::::::::::::::::"
};
/* XPM */
static const char *img213[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::#-:::::::::::::::::::::",
":::::::::@#:::::::::::::::::::::",
":::::::::*.-::::::::::::::::::::",
"::::::::::%o&:::::::::::::::::::",
":::::::::::=@.o#%**:::::::::::::",
":::::::::::;%+ O@#$:::::::::::::",
"::::::::::=o#*;:::::::::::::::::",
":::::::::=X*::::::::::::::::::::",
":::::::::##:::::::::::::::::::::",
":::::::::+*:::::::::::::::::::::",
":::::::::::::::$&:::::::::::::::",
"::::::::::::::-.=:::::::::::::::",
"::::::::::#O#:##::-&::::::::::::",
":::::::::#X#oX -::&#::::::::::::",
":::::::::X;::O.&;=X-::::::::::::",
":::::::::#::;X$.  #:::::::::::::",
":::::::::-::#+::*-::::::::::::::",
":::::::::::;X-::::::::::::::::::",
":::::::::::;%:::::::::::::::::::"
};
/* XPM */
static const char *img214[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::O&:::::::::::::::::::::",
":::::::::#+:::::::::::::::::::::",
":::::::::;o+;:::::::::::::::::::",
":::::::::::#XO#$**=:::::::::::::",
":::::::::::=+.o+###:::::::::::::",
"::::::::::$X&-::::::::::::::::::",
":::::::::%o;::::::::::::::::::::",
":::::::::+$:::::::::::::::::::::",
":::::::::&;:::::::::::::::::::::",
":::::::::::::::&&:::::::::::::::",
":::::::::-+ O&;X*:=$::::::::::::",
":::::::::o+*#.OO::@%::::::::::::",
":::::::::@:::; XOoo:::::::::::::",
":::::::::*;*;*o%#$;;::::::::::::",
":::::::::=X ..%:::*#::::::::::::",
":::::::::X$*# O=:;O&::::::::::::",
":::::::::#::+## o.@:::::::::::::",
":::::::::*:-X::-#&::::::::::::::",
"::::::::::::;:::::::::::::::::::"
};
/* XPM */
static const char *img215[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::%:::::::::::::",
":::::::::::-#=:::*X;=:::::::::::",
"::::::::::& o +;:O%&#:::::::::::",
"::::::::::.=:-@.O.*.-:::::::::::",
"::::::::::#::::%   %::::::::::::",
"::::::::::-::::#@*=:::::::::::::",
"::::::::::::::-.-:::::::::::::::",
"::::::::::####oO####=:::::::::::",
"::::::::::###oX#####*:::::::::::",
"::::::::::::;X*:::::::::::::::::",
"::::::::::::#+::::::::::::::::::",
"::::::::::Oo OOOOOOO&:::::::::::",
":::::::::::@$:::::::::::::::::::",
":::::::::::%;:::::::::::::::::::"
};
/* XPM */
static const char *img216[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------&+--o%=-------------",
"------------%+--o $-------------",
"------------%+&o.%--------------",
"------------%.X#o%--------------",
"-----------&.O=-o%--------------",
"-----------*@+--o%--------------",
"------------%+--o%--------------",
"------------=%--#=--------------"
};
/* XPM */
static const char *img217[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"============$+==o%==============",
"============$+==o$==============",
"============$+==o$==============",
"============$+==o$&*============",
"============$+==o+.&============",
"============$+==o.%=============",
"============$+=#.#==============",
"============$+#XX$==============",
"============$O.$o$==============",
"============# @=o$==============",
"===========%.+==o$==============",
"==========%X++==o$==============",
"==========$#$+==o$==============",
"============$+==o$==============",
"============$+==o$==============",
"============$+==o%=============="
};
/* XPM */
static const char *img218[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;=;;=;;;;-=;;;;;;;;;;;",
";;;;;;;;;;;O;;O&;;-o#;;;;;;;;;;;",
";;;;;;;;;;;O;;O&;-o@;;;;;;;;;;;;",
";;;;;;;;;;;O;;O&-o+;;;;;;;;;;;;;",
";;;;;;;;;;;O;;OoX OO%;;;;;;;;;;;",
";;;;;;;;;;;O;;O @&&&-;;;;;;;;;;;",
";;;;;;;;;;;O;*X@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;O=X.#&&&&-;;;;;;;;;;;",
";;;;;;;;;;;X.$OoOOOO%;;;;;;;;;;;",
";;;;;;;;;;= $;O&;;;;;;;;;;;;;;;;",
";;;;;;;;;*XO;;O&;;;;;;;;;;;;;;;;",
";;;;;;;;;o$O;;O&;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img219[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::;=:::::::::::::",
":::::::::::::::::#@:::::::::::::",
"::::::::::::::::;.-:::::::::::::",
"::::::::::#$::::$O::::::::::::::",
"::::::::::O+.%;;X&::::::::::::::",
"::::::::::O*-#.#o:::::::::::::::",
"::::::::::O*::= X$::::::::::::::",
"::::::::::O*::-.-@o$::::::::::::",
"::::::::::O*::+$:&.+::::::::::::",
"::::::::::O*:;X$X+*:::::::::::::",
"::::::::::O*:+ +=:::::::::::::::",
"::::::::::O#o =:::::::::::::::::",
"::::::::::++@+::::::::::::::::::",
"::::::::::::X=::::::::::::::::::",
":::::::::::*X:::::::::::::::::::",
":::::::::::;-:::::::::::::::::::"
};
/* XPM */
static const char *img21greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=#@@@@$;;;;;;;;;;;;;",
";;;;;;;;;;;#.@+ O@$;;;;;;;;;;;;;",
";;;;;;;;;;@.*;;OO;;;;;;;;;;;;;;;",
";;;;;;;;;- #;;;@o;;;;;;;;;;;;;;;",
";;;;;;;;;$.;;;;OO;;;;;;;;;;;;;;;",
";;;;;;;;;@o;;;- %;;;;;;;;;;;;;;;",
";;;;;;;;;%X;;;@O;;;;;;;;;;;;;;;;",
";;;;;;;;;;o@%+@;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;=&;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img21[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;&&;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;##;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;#@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;#+Oo.O+@;;;;;;;;;;;;;",
";;;;;;;;;;;;-#  @-;;;;;;;;;;;;;;",
";;;;;;;;;;;;;$.X@;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=X*=o*;;;;;;;;;;;;;;",
";;;;;;;;;;;;%*;;-$;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img220[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::&+:::::::::::::",
":::::::::::::::::#%:::::::::::::",
"::::::::::=;::::-.;:::::::::::::",
"::::::::::OX#:::$+::::::::::::::",
"::::::::::O&@o#:O&::::::::::::::",
"::::::::::O*:-#. -::::::::::::::",
"::::::::::O*:::#X.%;::::::::::::",
"::::::::::O*:::X*-XX::::::::::::",
"::::::::::O*::-X$X+-::::::::::::",
"::::::::::O*::@ +=::::::::::::::",
"::::::::::O&%. =::::::::::::::::",
"::::::::::O.+#o:::::::::::::::::",
"::::::::::&-:+$:::::::::::::::::",
"::::::::::::;X;:::::::::::::::::",
"::::::::::::$+::::::::::::::::::",
"::::::::::+        .::::::::::::",
":::::::::::- :::::::::::::::::::",
":::::::::::=#:::::::::::::::::::"
};
/* XPM */
static const char *img221[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::o:::::::::::::",
":::::::::::::::::&o:::::::::::::",
"::::::::::-*****;@$:::::::::::::",
"::::::::::#OOOOo  ;:::::::::::::",
"::::::::::::::::#oo;::::::::::::",
":::::::::::::::;.=@#::::::::::::",
":::::::::::::::&O:;X::::::::::::",
":::::::::::::::o&:: ::::::::::::",
"::::::::::::::-X:::.::::::::::::",
"::::::::::::::@#::#@::::::::::::",
":::::::::::::;X-:=X=::::::::::::",
"::::::::::&##+X#@.*:::::::::::::",
"::::::::::&## ##&:::::::::::::::",
"::::::::::::&O::::::::::::::::::",
"::::::::::::+%::::::::::::::::::",
"::::::::::@        #::::::::::::",
":::::::::::$#:::::::::::::::::::",
":::::::::::#=:::::::::::::::::::"
};
/* XPM */
static const char *img222[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::;=::::::::::::",
"::::::::::::::::::+$::::::::::::",
"::::::::::#OOOOo #X;::::::::::::",
"::::::::::::::::-+X;::::::::::::",
"::::::::::::::::;.O$::::::::::::",
"::::::::::::::::$O-X::::::::::::",
":::::::::::::::;X*: ::::::::::::",
":::::::::::::::&o:: ::::::::::::",
":::::::::::::::o&:$@::::::::::::",
"::::::::::::::-.:=X*::::::::::::",
"::::::::::-***O+@.%:::::::::::::",
"::::::::::%###.##;::::::::::::::",
":::::::::::::@@:::::::::::::::::",
":::::::::::::X-:::::::::::::::::",
"::::::::::#Oo.OOOOO+::::::::::::",
"::::::::::::o=::::::::::::::::::",
":::::::::::&X:::::::::::::::::::",
"::::::::::&O+######$::::::::::::",
"::::::::::$.#######$::::::::::::",
"::::::::::;*::::::::::::::::::::"
};
/* XPM */
static const char *img223[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;=&&&&&-;;;;;;;;;;;;;;",
";;;;;;;;;;;#OOOOo +-;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;#o-;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;@#;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;-X;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;.;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;#@;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;*X*;;;;;;;;;;;",
";;;;;;;;;;;%#####@.&;;;;;;;;;;;;",
";;;;;;;;;;;%#####%;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;#=;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;@+-;;;;;;;;;;;;;",
";;;;;;;;;;;@        #;;;;;;;;;;;",
";;;;;;;;;;;;;;$X=;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;#-;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img224[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;=&&&&&-;;;;;;;;;;;;;;;",
";;;;;;;;;;#OOOOo +-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;#o-;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;@#;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-X;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;; ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;.;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;#@;;;;;;;;;;;;",
";;;;;;;;;;;;;;@#;*X*;;;;;;;;;;;;",
";;;;;;;;;;%### #@.&;;;;;;;;;;;;;",
";;;;;;;;;;%## @#%;;;;;;;;;;;;;;;",
";;;;;;;;;;;;#+;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;= -;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@        #;;;;;;;;;;;;",
";;;;;;;;;;$o-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;#*;;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img225[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------$#####$--------------",
"-----------$#####@.%------------",
"------------------&X&-----------",
"-------------------#@-----------",
"--------------------.-----------",
"-------------------- -----------",
"-------------------=X-----------",
"-------------------@#-----------",
"------------------#o=-----------",
"-----------#OOOOo +=------------",
"-----------*%%%%%=--------------",
"------------------=$------------",
"------------------+#------------",
"-----------------#O-------------",
"-----------#OOOO..OO+-----------",
"---------------=.%--------------",
"---------------O#---------------",
"-----------#OOo OOOO+-----------",
"-----------*%#X%%%%%&-----------",
"------------*.&-----------------",
"------------*%------------------"
};
/* XPM */
static const char *img226[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::#OOOOo #;::::::::::::::",
":::::::::::::::-#o;:::::::::::::",
":::::::::::::::::+$:::::::::::::",
":::::::::::::::::-X:::::::::::::",
":::::::::::::::::: :::::::::::::",
":::::::::::::::::: :::::::::::::",
":::::::::::::::::$@:::::::::::::",
":::::::::::::%#:=X*:::::::::::::",
":::::::::-***o@@.%::::::::::::::",
":::::::::%##+X##;:::::::::::::::",
"::::::::::::@#::::::::::::::::::",
"::::::::::::X-::::::::::::::::::",
":::::::::#Oo.OOOOO+:::::::::::::",
":::::::::::+%:::::::::::::::::::",
"::::::::::- ::::::::::::::::::::",
":::::::::&@X######$:::::::::::::",
":::::::::& @######$:::::::::::::",
":::::::::*X:::::::::::::::::::::",
":::::::::;-:::::::::::::::::::::"
};
/* XPM */
static const char *img227[] = {
/* columns rows colors chars-per-pixel */
"32 32 3 1",
"  c #777777",
". c #BBBBBB",
"X c gray100",
/* pixels */
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX"
};
/* XPM */
static const char *img228[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c #444444",
". c #777777",
"X c #BBBBBB",
"o c gray80",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO oOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO oOOOOOOOOOOOOOO"
};
/* XPM */
static const char *img229[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c gray20",
". c #444444",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c gray80",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%@.@%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ $%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%o.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%#O #%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%+..$%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%XX%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%O %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%$OX@%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img22greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;-$@@@;;;;;;;;;;;;;",
";;;;;;;;;;;;;*+&;;*;;;;;;;;;;;;;",
";;;;;;;;;;;;;X*;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;%@;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;@o;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;= +=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;$. #-;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;@ +;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;@O;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=@O*;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img22[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::-$::::::=#::::::::::::",
"::::::::::;.;:::::##::::::::::::",
":::::::::::+#::::- ;::::::::::::",
":::::::::::*X;:::#@:::::::::::::",
"::::::::::::O&::;.=:::::::::::::",
"::::::::::::&o::%O::::::::::::::",
":::::::::::::.-:X*::::::::::::::",
":::::::::::::$+*o:::::::::::::::",
":::::::::::::;Xo$:::::::::::::::",
"::::::::::::::+.::::::::::::::::",
"::::::::::::::;&::::::::::::::::"
};
/* XPM */
static const char *img230[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"************+X@*****************",
"*************& +****************",
"**************+X****************",
"**************+X****************",
"**************+X****************",
"**************+X****************",
"**************+X****************",
"**************$.+%**************",
"**************&XX#**************",
"**************+.****************",
"**************+X****************",
"**************+X****************",
"**************+X****************",
"**************+X****************",
"**************XO****************",
"************+oo&****************"
};
/* XPM */
static const char *img231[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c gray40",
"X c #777777",
"o c #888888",
"O c #BBBBBB",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++Oo++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++O   .+++++++++++++++"
};
/* XPM */
static const char *img232[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c #444444",
"X c #777777",
"o c #BBBBBB",
"O c gray80",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"+++++++++++++++XO+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"++++++++++++.   O+++++++++++++++"
};
/* XPM */
static const char *img233[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c gray40",
"X c #777777",
"o c #888888",
"O c #BBBBBB",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++O   .+++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++OX++++++++++++++++++",
"++++++++++++Oo++++++++++++++++++"
};
/* XPM */
static const char *img234[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c #444444",
"X c #777777",
"o c #BBBBBB",
"O c gray80",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++.   O+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++Xo+++++++++++++++",
"+++++++++++++++XO+++++++++++++++"
};
/* XPM */
static const char *img235[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%X#%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%$.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%Oo%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%.$%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%@.%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%o+%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%$ $%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%+o%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%+o%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%$ $%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%o+%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%@.%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%.$%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%Oo%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%$.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%X#%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img236[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%#o%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%% $%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%oO%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%@.%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%.@%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%+o%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%$ %%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%o+%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%o+%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%$ %%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%+o%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%.@%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%@.%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%XO%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%% $%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%#o%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img237[] = {
/* columns rows colors chars-per-pixel */
"32 32 22 1",
"  c black",
". c #060606",
"X c #0E0E0E",
"o c gray6",
"O c #101010",
"+ c #111111",
"@ c #222222",
"# c gray20",
"$ c #444444",
"% c #555555",
"& c gray40",
"* c #777777",
"= c #888888",
"- c gray60",
"; c #AAAAAA",
": c #B1B1B1",
"> c #BBBBBB",
", c gray80",
"< c gray81",
"1 c #DDDDDD",
"2 c #EEEEEE",
"3 c gray100",
/* pixels */
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"333333333333333<;333333333333333",
"333333333333333+.233333333333333",
"33333333333332#oo#<3333333333333",
"33333333331>& +;>+ %><3333333333",
"33333>*#     #>33<$     @&;33333",
"3331&      @;333333>$      %<333",
"33,@ #=<33333333333333331-$ +;33",
"32@#;3333333333333333333333>#+13",
"3*+,3333333333333333333333332o%3",
"31,3333333333332>3333333333331<3",
"33333333333333*@ 333333333333333",
"333333333333333%%333333333333333",
"333333333333333+-333333333333333",
"333333332>3333> ;>333333>,333333",
"3333333-$>&%13- *;$133>#;==33333",
"333333=+23- 23%$23$*3-+,3$$33333",
"333332 *33&%33 *33$*2+*33;,33333",
"33333- <33$*31 <33+*- ,333333333",
"33333*@332 ->>@33; ;*@3333333333",
"33333=#33= 2%<#33$$3-@3331*33333",
"333333+-**o*-3#-&%333#*>**333333",
"3333333>232,333>1333331>33333333"
};
/* XPM */
static const char *img238[] = {
/* columns rows colors chars-per-pixel */
"32 32 22 1",
"  c black",
". c #060606",
"X c gray3",
"o c #101010",
"O c #111111",
"+ c #1E1E1E",
"@ c #222222",
"# c gray20",
"$ c #444444",
"% c #555555",
"& c gray40",
"* c #777777",
"= c #888888",
"- c gray60",
"; c #A4A4A4",
": c #AAAAAA",
"> c #BBBBBB",
", c #C0C0C0",
"< c gray80",
"1 c #DDDDDD",
"2 c #EEEEEE",
"3 c gray100",
/* pixels */
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"33333333333333333333333333333333",
"3333333333333332>333333333333333",
"33333333333333*@ 333333333333333",
"333333333333333%%333333333333333",
"333333333333333O-333333333333333",
"333333332>3333> :>333333><333333",
"3333333-$>&%13- *:$133>#:==33333",
"333333=O23- 23%$23$*3-O<3$$33333",
"333332 *33&%33 *33$*2O*33:<33333",
"33333- <33$*31 <33O*- <333333333",
"33333*@332 ->>@33: :*@3333333333",
"33333=#33= 2%<#33$$3-@3331*33333",
"333333O-**O*-3#-&%333#*>**333333",
"3333333>232<333>1333331>33333333",
"311333333333333333333333333332<3",
"3*O23333333333333333333333333@%3",
"31O#<33333333333333333333332#O<3",
"33>O %><33333333333333331>& O:33",
"333<$     @&:333333>*#     #>333",
"33333>$      %<331&      @:33333",
"33333333331-$ O:<@ #=<3333333333",
"3333333333333>#O+#:3333333333333",
"333333333333332X.<33333333333333",
"333333333333333,;333333333333333"
};
/* XPM */
static const char *img239[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::                      :::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::;*:::::::::::::::",
"::::::::::::::#X :::::::::::::::",
":::::::::::::::++:::::::::::::::",
":::::::::::::::.%:::::::::::::::",
"::::::::;*::::* &*::::::*=::::::",
":::::::%O*@+-:% #&O-::*o&$$:::::",
"::::::$.;:% ;:+O;:O#:%.=:OO:::::",
":::::; #::@+:: #::O#;.#::&=:::::",
":::::% =::O#:- =::.#% =:::::::::",
":::::#X::; %**X::& &#X::::::::::",
":::::$o::$ ;+=o::OO:%X:::-#:::::",
"::::::.%##.#%:o%@+:::o#*##::::::",
":::::::*;:;=:::*-:::::-*::::::::"
};
/* XPM */
static const char *img23greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------=$@@@@@#-------------",
"-----------+O@X+@@$-------------",
"----------$@--o=----------------",
"-------------*o-----------------",
"-------------@o-----------------",
"-------------+@-----------------",
"------------=.%-----------------",
"------------% ------------------",
"------------=&------------------"
};
/* XPM */
static const char *img23[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::=&##*-:::::::::::::",
":::::::::::-@.#*&@.#;:::::::::::",
"::::::::::-X%::::::@O:::::::::::",
"::::::::::o$::::::::+#::::::::::",
":::::::::%O:::::::::-X-:::::::::",
":::::::::o%::::::::::@#:::::::::",
"::::::::: ;::::::::::&O:::::::::",
":::::::::O::::::::::::O:::::::::",
":::::::::O::::::::::::O:::::::::",
"::::::::: ;::::::::::&O:::::::::",
":::::::::o%::::::::::@#:::::::::",
":::::::::%O:::::::::-X-:::::::::",
"::::::::::o$::::::::+#::::::::::",
"::::::::::-o$;::::-@+:::::::::::",
":::::::::::-@.#*&@.#;:::::::::::",
":::::::::::::=&##*-:::::::::::::"
};
/* XPM */
static const char *img240[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::;*::::::::::::::::",
":::::::::::::#X ::::::::::::::::",
"::::::::::::::++::::::::::::::::",
"::::::::::::::.%::::::::::::::::",
":::::::;*::::* &*::::::*=:::::::",
"::::::%O*@+-:% #&O-::*o&$$::::::",
":::::$.;:% ;:+O;:O#:%.=:OO::::::",
"::::; #::@+:: #::O#;.#::&=::::::",
"::::% =::O#:- =::.#% =::::::::::",
"::::#X::; %**X::& &#X:::::::::::",
"::::$o::$ ;+=o::OO:%X:::-#::::::",
":::::.%##.#%:o%@+:::o#*##:::::::",
"::::::*;:;=:::*-:::::-*:::::::::",
"::::                      ::::::"
};
/* XPM */
static const char *img241[] = {
/* columns rows colors chars-per-pixel */
"32 32 19 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c gray22",
"+ c #444444",
"@ c #484848",
"# c #505050",
"$ c #555555",
"% c gray40",
"& c #777777",
"* c #888888",
"= c gray60",
"- c #AAAAAA",
"; c #BBBBBB",
": c gray80",
"> c #DDDDDD",
", c #EEEEEE",
"< c gray100",
/* pixels */
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<:<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<o<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<=$<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<:.><<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<&.$&&&&&&&#OO@&&&&&*<<<<<<",
"<<<<<<&.$&&&&&&&#OO@&&&&&*<<<<<<",
"<<<<<<<:.><<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<=$<<<<<<<<<<<<<<<<<<<<<<",
"<<<<<<<<<o<<<<<,;<<<<<<<<<<<<<<<",
"<<<<<<<<<:<<<<&X <<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<$$<<<<<<<<<<<<<<<",
"<<<<<<<<<<<<<<<.=<<<<<<<<<<<<<<<",
"<<<<<<<<,;<<<<; -;<<<<<<;:<<<<<<",
"<<<<<<<=+;%$><= &-+><<;o-**<<<<<",
"<<<<<<*.,<= ,<$+,<+&<=.:<++<<<<<",
"<<<<<, &<<%$<< &<<+&,.&<<-:<<<<<",
"<<<<<= :<<+&<> :<<.&= :<<<<<<<<<",
"<<<<<&X<<, =;;X<<- -&X<<<<<<<<<<",
"<<<<<*o<<* ,$:o<<++<=X<<<>&<<<<<",
"<<<<<<.=&&.&=<o=%$<<<o&;&&<<<<<<",
"<<<<<<<;,<,:<<<;><<<<<>;<<<<<<<<"
};
/* XPM */
static const char *img242[] = {
/* columns rows colors chars-per-pixel */
"32 32 18 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c gray22",
"+ c gray25",
"@ c #444444",
"# c #555555",
"$ c gray40",
"% c #777777",
"& c #888888",
"* c gray60",
"= c #AAAAAA",
"- c #BBBBBB",
"; c gray80",
": c #DDDDDD",
"> c #EEEEEE",
", c gray100",
/* pixels */
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,>:,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,;$,,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,.:,,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,*o>,,,,,,,,",
",,,,,=%%%%%OOO+%%%%%%%oX=,,,,,,,",
",,,,,=%%%%%OOO+%%%%%%%oX=,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,*o>,,,,,,,,",
",,,,,,,,,,,,,,,,,,,,,.:,,,,,,,,,",
",,,,,,,,,,,,,,>-,,,,;$,,,,,,,,,,",
",,,,,,,,,,,,,%X ,,,,>:,,,,,,,,,,",
",,,,,,,,,,,,,,##,,,,,,,,,,,,,,,,",
",,,,,,,,,,,,,,.*,,,,,,,,,,,,,,,,",
",,,,,,,>-,,,,- =-,,,,,,-;,,,,,,,",
",,,,,,*@-$#:,* %=@:,,-o=&&,,,,,,",
",,,,,&.>,* >,#@>,@%,*.;,@@,,,,,,",
",,,,> %,,$#,, %,,@%>.%,,=;,,,,,,",
",,,,* ;,,@%,: ;,,.%* ;,,,,,,,,,,",
",,,,%X,,> *--X,,= =%X,,,,,,,,,,,",
",,,,&o,,& >#;o,,@@,*X,,,:%,,,,,,",
",,,,,.*%%.%*,o*$#,,,o%-%%,,,,,,,",
",,,,,,->,>;,,,-:,,,,,:-,,,,,,,,,"
};
/* XPM */
static const char *img243[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::-;::::::::::::::::",
":::::::::::=$XX.O%-:::::::::::::",
"::::::::-#X+%*:;*$oO$;::::::::::",
":::::::+#=::::::::::&##:::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::;*::::::::::::::::",
":::::::::::::#X ::::::::::::::::",
"::::::::::::::++::::::::::::::::",
"::::::::::::::.%::::::::::::::::",
":::::::;*::::* &*::::::*=:::::::",
"::::::%O*@+-:% #&O-::*o&$$::::::",
":::::$.;:% ;:+O;:O#:%.=:OO::::::",
"::::; #::@+:: #::O#;.#::&=::::::",
"::::% =::O#:- =::.#% =::::::::::",
"::::#X::; %**X::& &#X:::::::::::",
"::::$o::$ ;+=o::OO:%X:::-#::::::",
":::::.%##.#%:o%@+:::o#*##:::::::",
"::::::*;:;=:::*-:::::-*:::::::::"
};
/* XPM */
static const char *img244[] = {
/* columns rows colors chars-per-pixel */
"32 32 4 1",
"  c #111111",
". c #444444",
"X c #BBBBBB",
"o c gray100",
/* pixels */
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"ooooooooooooXXXXXXoooooooooooooo",
"oooooooooooo .....oooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo"
};
/* XPM */
static const char *img245[] = {
/* columns rows colors chars-per-pixel */
"32 32 4 1",
"  c black",
". c #444444",
"X c #BBBBBB",
"o c gray100",
/* pixels */
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"ooooooooooooXXXXXXoooooooooooooo",
"oooooooooooo..... oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo"
};
/* XPM */
static const char *img246[] = {
/* columns rows colors chars-per-pixel */
"32 32 4 1",
"  c #222222",
". c #444444",
"X c #777777",
"o c gray100",
/* pixels */
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"ooooooooooooXooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo.ooooooooooooooooooo",
"oooooooooooo XXXXXoooooooooooooo",
"ooooooooooooXXXXXXoooooooooooooo"
};
/* XPM */
static const char *img247[] = {
/* columns rows colors chars-per-pixel */
"32 32 4 1",
"  c black",
". c #555555",
"X c #777777",
"o c gray100",
/* pixels */
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"oooooooooooooooooooooooooooooooo",
"ooooooooooooooooo.oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooooooo oooooooooooooo",
"ooooooooooooXXXXX oooooooooooooo",
"ooooooooooooXXXXXXoooooooooooooo"
};
/* XPM */
static const char *img248[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #111111",
". c gray20",
"X c #555555",
"o c #777777",
"O c gray60",
"+ c gray80",
"@ c #DDDDDD",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"############+###################",
"############.###################",
"###########OX###################",
"##########+ @###################",
"#########o XooooooooooO#########",
"#########o XooooooooooO#########",
"##########+ @###################",
"###########OX###################",
"############.###################",
"############+###################"
};
/* XPM */
static const char *img249[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #111111",
". c gray20",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c gray80",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%#%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%.%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%@X%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%# $%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%O XOOOOOOOOOOoOOOOOOOO+%%%%",
"%%%%%O XOOOOOOOOOOoOOOOOOOO+%%%%",
"%%%%%%# $%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%@X%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%.%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%#%%%%%%%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img24greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"===========$X+===OO=============",
"==========*X* ===. =============",
"==========O@# ===$ =============",
"==========%*XX===&X=============",
"===========& #===++=============",
"===========$ &===X&=============",
"===========$ &==++==============",
"============oo$+O===============",
"=============&$*================"
};
/* XPM */
static const char *img24[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**************#$****************",
"************$ooXo%**************",
"************X@**@O**************",
"************X**** **************",
"************.****.**************",
"************o+&%OO**************",
"************&+ .+&**************"
};
/* XPM */
static const char *img250[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"***************&&***************",
"***************@@***************",
"***************X.***************",
"**************+  O**************",
"************$XoOOO.$************",
"************#%*OO*%#************",
"***************OO***************",
"***************OO***************",
"***************OO***************",
"***************OO***************",
"***************OO***************",
"***************OO***************",
"***************OO***************",
"***************OO***************",
"***************OO***************"
};
/* XPM */
static const char *img251[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"************&+******************",
"************O@******************",
"***********#.$$$$$$$$%**********",
"**********+.ooooooooo+**********",
"********@o+*********************",
"********@XO*********************",
"**********+.ooooooooo+**********",
"***********# $$$$$$$$%**********",
"************O@******************",
"************&+******************"
};
/* XPM */
static const char *img252[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #202020",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray59",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------=@----------------------",
"--------+#----------------------",
"-------%.********$*********=----",
"------@.OOOOOOOOO.OOOOOOOOO&----",
"----#O@-------------------------",
"----#o+-------------------------",
"------@.OOOOOOOOO.OOOOOOOOO&----",
"-------% ********$*********=----",
"--------+#----------------------",
"--------=@----------------------"
};
/* XPM */
static const char *img253[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;+&;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;=.+;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;+$O%;;;;;;;;;;;;;;;",
";;;;;;;;;;;;@O;=.*;;;;;;;;;;;;;;",
";;;;;;;;;;=+o@;; X#;;;;;;;;;;;;;",
";;;;;;;;;;+$&@;; =@#;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;;",
";;;;;;;;;;;;--;;=;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img254[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&%$&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&#o&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&& $&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&+X%&&&&&&&&&&&",
"&&&&&&&&OOOOOOOOOOOX.@&&&&&&&&&&",
"&&&&&&&&OOOOOOOOOOOX.@&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&+X%&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&& $&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&#o&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&%$&&&&&&&&&&&&&"
};
/* XPM */
static const char *img255[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c gray25",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"***********************&%*******",
"***********************$O*******",
"************************ %******",
"************************@X&*****",
"*****#++++++++o++++++++++X.#****",
"*****#++++++++o++++++++++X.#****",
"************************@X&*****",
"************************ %******",
"***********************$O*******",
"***********************&%*******"
};
/* XPM */
static const char *img256[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&%%&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&OO&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&@#&OO&$@&&&&&&&&&&&&&",
"&&&&&&&&&&&$XoOOO.$&&&&&&&&&&&&&",
"&&&&&&&&&&&&&+  O&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&o.&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&@@&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img257[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"*****************+**************",
"*****************O@*************",
"*********$$$$$$$$# %************",
"*********oooooooooo.#***********",
"*******************&Oo$*********",
"*******************&Xo$*********",
"*********oooooooooo.#***********",
"*********$$$$$$$$@ %************",
"*****************O@*************",
"*****************+**************"
};
/* XPM */
static const char *img258[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #222222",
"X c gray18",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c gray60",
"$ c #AAAAAA",
"% c #AFAFAF",
"& c #BBBBBB",
"* c gray80",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------------------@---------",
"----------------------+#--------",
"----&&&&&&&&&&%&&&&&&&$ *-------",
"----OOOOOOOOOOXOOOOOOOOO.$------",
"------------------------=+O&----",
"------------------------=oO&----",
"----OOOOOOOOOOXOOOOOOOOO.$------",
"----&&&&&&&&&&%&&&&&&&# *-------",
"----------------------+#--------",
"----------------------@---------"
};
/* XPM */
static const char *img259[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------==--*---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"------------&@-- ---------------",
"----------+$&@-- *@#------------",
"----------*+o@-- X#-------------",
"------------#O-*.*--------------",
"-------------+$O%---------------",
"-------------*.+----------------",
"--------------+&----------------",
"--------------*-----------------"
};
/* XPM */
static const char *img25greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::;X::::::::::::::",
"::::::::::::::::*#::::::::::::::",
"::::::::::::::::$*::::::::::::::",
"::::::::::::::::o-::::::::::::::",
":::::::::::::-%@.#&:::::::::::::",
"::::::::::::*o*=#-+%::::::::::::",
":::::::::::& =:#%:&X::::::::::::",
":::::::::::.#::O;:- ::::::::::::",
"::::::::::- =::+::$.::::::::::::",
"::::::::::- ;:&@:;O#::::::::::::",
":::::::::::.%:@&:@o:::::::::::::",
":::::::::::-o$o$@$::::::::::::::",
":::::::::::::-o=::::::::::::::::",
":::::::::::::&@:::::::::::::::::",
":::::::::::::#&:::::::::::::::::",
":::::::::::::#::::::::::::::::::"
};
/* XPM */
static const char *img25[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;*@;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;O -;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=.O@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;@+=.-;;;;;;;;;;;;;;;",
";;;;;;;;;;;- -;o%;;;;;;;;;;;;;;;",
";;;;;;;;;;;$o;;%X;;;;;;;;;;;;;;;",
";;;;;;;;;;;.&;;; &;;;;;;;;;;;;;;",
";;;;;;;;;;%X;;;;#o;;;;;;;;;;;;;;",
";;;;;;;;;;X#;;;;- =;;;;;;;;;;;;;",
";;;;;;;;;= ;;;;;;@@;;;;;;;;;;;;;",
";;;;;;;;;-&;;;;;;-%;;;;;;;;;;;;;"
};
/* XPM */
static const char *img260[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"************$*****&%************",
"************X*****$O************",
"***********@o****** %***********",
"**********$ %******@X&**********",
"*********+ o++++++++X.#*********",
"*********+ o++++++++X.#*********",
"**********$ %******@X&**********",
"***********@o****** %***********",
"************X*****$O************",
"************$*****&%************"
};
/* XPM */
static const char *img261[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #484848",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"======%==================*&=====",
"======X==================%+=====",
"=====#O=================== &====",
"====% &===================#X*===",
"===@ O@@@@@@@@@@o@@@@@@@@@@X.$==",
"===@ O@@@@@@@@@@o@@@@@@@@@@X.$==",
"====% &===================#X*===",
"=====#O=================== &====",
"======X==================%+=====",
"======%==================*&====="
};
/* XPM */
static const char *img262[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------==----------------",
"--------------#@----------------",
"-------------=X.=---------------",
"------------=+  O=--------------",
"-----------#o@@@@X#-------------",
"-----------%*-@@-=%-------------",
"--------------@@----------------",
"--------------@@----------------",
"--------------@@----------------",
"--------------@@----------------",
"--------------@@----------------",
"--------------@@----------------",
"-----------*--@@--*-------------",
"-----------@X$@@%o@-------------",
"------------*O.XX&--------------",
"-------------*..*---------------",
"--------------@@----------------",
"--------------**----------------"
};
/* XPM */
static const char *img263[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"============#+====O&============",
"============X#====++============",
"===========+o$$$$$$ $===========",
"==========@.oooooooo.$==========",
"========&oo*========%.+*========",
"========&oX*========% +*========",
"==========@.oooooooo.$==========",
"===========+o$$$$$$ $===========",
"============X#====++============",
"============#+====O&============"
};
/* XPM */
static const char *img264[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c #111111",
". c #202020",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray59",
"& c gray60",
"* c #AAAAAA",
"= c #BBBBBB",
"- c gray80",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::;#:::::::::::::::@::::::::",
"::::::@$:::::::::::::::+&:::::::",
":::::%X=======-%=======* -::::::",
"::::#XOOOOOOOOO OOOOOOOOOX*:::::",
"::$O#::::::::::::::::::::;+O=:::",
"::$o@::::::::::::::::::::;oO=:::",
"::::#XOOOOOOOOOXOOOOOOOOOX*:::::",
":::::& ========%=======& -::::::",
"::::::@$:::::::::::::::+&:::::::",
"::::::;#:::::::::::::::@::::::::"
};
/* XPM */
static const char *img265[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;o#;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;#Oo*;;;;;;;;;;;;;;",
";;;;;;;;;;;;;$.;%X=;;;;;;;;;;;;;",
";;;;;;;;;;;-+X@;; O#;;;;;;;;;;;;",
";;;;;;;;;;;@$&@;; =@$;;;;;;;;;;;",
";;;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&@;; ;;;;;;;;;;;;;;",
";;;;;;;;;;;$*&@;; ;$&;;;;;;;;;;;",
";;;;;;;;;;;&oO@;; X+-;;;;;;;;;;;",
";;;;;;;;;;;;;@o;*.*;;;;;;;;;;;;;",
";;;;;;;;;;;;;;++o&;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;-o@;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;&;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img266[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #101010",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #686868",
"# c #777777",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------------=*-------------",
"--------*--------&+-------------",
"--------O---------.*------------",
"--------O---------$o=-----------",
"-------- +#########oX%----------",
"--------.@#########oX%----------",
"--------O---------$o=-----------",
"--------O---------.*------------",
"-----------------&+-------------",
"-----------------=*-------------"
};
/* XPM */
static const char *img267[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c gray9",
"X c #222222",
"o c gray20",
"O c gray25",
"+ c #444444",
"@ c gray40",
"# c #686868",
"$ c #777777",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;-=;;;;;;;;",
";;;;=;;;;;;;;;;;;;;;;;*@;;;;;;;;",
";;;;+;;;;;;;;;;;;;;;;;; =;;;;;;;",
";;;;+;;;;;;;;;;;;;;;;;;%o-;;;;;;",
";;;;.#$$$$$$$O$$$$$$$$$$oX&;;;;;",
";;;;.#$$$$$$$O$$$$$$$$$$oX&;;;;;",
";;;;+;;;;;;;;;;;;;;;;;;%o-;;;;;;",
";;;;+;;;;;;;;;;;;;;;;;; =;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;*@;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;-=;;;;;;;;"
};
/* XPM */
static const char *img268[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"=================#&===&=========",
"=================$.XoXo=========",
"====================# @=========",
"===================$o@@=========",
"==================#o*$+=========",
"=================$O*=*X*========",
"================$o*===@%========",
"===============#o===============",
"==============#o*===============",
"=============$o*================",
"============#o*=================",
"===========$o===================",
"==========$o====================",
"=========@o*====================",
"=========+*====================="
};
/* XPM */
static const char *img269[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #484848",
"+ c #555555",
"@ c gray44",
"# c #777777",
"$ c gray60",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"=========%======================",
"=========o========& #*==========",
"========$+=========*+$==========",
"=======%.&==========$#==========",
"======#.+#########@OX%==========",
"======#.+#########@O&===========",
"=======%.&======================",
"========$+======================",
"=========o======================",
"=========%======================"
};
/* XPM */
static const char *img26greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::$:::;%O#;:::::::::::",
":::::::::::&#:::@+*@#:::::::::::",
":::::::::::o;::&@::;O:::::::::::",
"::::::::::-#:::+;:::+:::::::::::",
"::::::::::*#::=@:::&#:::::::::::",
"::::::::::=+::@*::-O-:::::::::::",
":::::::::::o+-o:;%X*::::::::::::",
":::::::::::;+ .O.O-:::::::::::::",
":::::::::::::$O*;:::::::::::::::",
":::::::::::::+$:::::::::::::::::",
"::::::::::::; =:::::::::::::::::",
"::::::::::::=.::::::::::::::::::"
};
/* XPM */
static const char *img26[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #444444",
"X c gray40",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c gray80",
"# c #DDDDDD",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%$+%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%@ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%$oOXOo$%%%%%%%%%%%%%%",
"%%%%%%%%%%%#.oXo.#%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%+ %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%% %%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%.%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%+%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img270[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c #111111",
". c #222222",
"X c gray19",
"o c gray20",
"O c gray25",
"+ c #606060",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::;-::::::::::::",
"::::::::$ %:::::::=@::::::::::::",
":::::::-.-::::::::: -:::::::::::",
":::::::*@::::::::::%o;::::::::::",
"::::::::.o+#########o.&:::::::::",
"::::::::;O+#########o.&:::::::::",
":::::::::::::::::::%o;::::::::::",
"::::::::::::::::::: -:::::::::::",
"::::::::::::::::::=@::::::::::::",
"::::::::::::::::::;-::::::::::::"
};
/* XPM */
static const char *img271[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"========O*======================",
"========@X*=====================",
"=========#o=====================",
"==========#o*===================",
"===========#o*==================",
"============#o*=================",
"=============#o*================",
"==============@X================",
"===============#o*===+$=========",
"================#o*=&X*=========",
"=================#o*#O==========",
"==================#o++==========",
"==================%O +==========",
"================#.XoXo==========",
"================@&===&==========",
"================================"
};
/* XPM */
static const char *img272[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c #222222",
"X c gray20",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c gray80",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$@$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$#X$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$oO$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$+.#$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$O oOOOOOOOOOO+$$$$$$$$$",
"$$$$$$$$$OOOOOOOOOOOOO+$$$$$$$$$"
};
/* XPM */
static const char *img273[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #111111",
". c #444444",
"X c #777777",
"o c gray60",
"O c gray80",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@+.@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@.o@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@O O@@@@@@@@@@",
"@@@@@@@@@XXXXXXXXXXX. o@@@@@@@@@",
"@@@@@@@@@XXXXXXXXXXXXXo@@@@@@@@@"
};
/* XPM */
static const char *img274[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"=====================&+=========",
"====================&.&=========",
"===================*o&==========",
"==================*X&===========",
"=================*X&============",
"================&o&=============",
"===============&o&==============",
"==============*X%===============",
"========+$===*X&================",
"========&o==&o&=================",
"=========X*&o&==================",
"=========O#o&===================",
"=========o @&===================",
"========= OOXO%=================",
"=========*===&#================="
};
/* XPM */
static const char *img275[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c #222222",
"X c gray20",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c gray80",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$OOOOOOOOOOOOO+$$$$$$$$$",
"$$$$$$$$$O oOOOOOOOOOO+$$$$$$$$$",
"$$$$$$$$$$+.#$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$oO$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$#X$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$@$$$$$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img276[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #777777",
"O c gray60",
"+ c gray80",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$oooooooooooooO$$$$$$$$$",
"$$$$$$$$$oooooooooooX O$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$+ +$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$.O$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$@X$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$#@$$$$$$$$$$$$"
};
/* XPM */
static const char *img277[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========&===%@================",
"========== OOXO$================",
"==========O.$===================",
"==========O@o%==================",
"==========X&%o$=================",
"=========%O==&o%================",
"=========+#===&X%===============",
"===============&o$==============",
"================%X%=============",
"=================%o%============",
"==================&X$===========",
"===================*X%==========",
"====================&o%=========",
"=====================%X$========",
"======================%+========"
};
/* XPM */
static const char *img278[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #777777",
"O c #888888",
"+ c gray60",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&$@&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&X%&&&&&&&&&&&",
"&&&&&&&&@@@@@@@@@@@O.%&&&&&&&&&&",
"&&&&&&&&XXXXXXXXXXXXXo&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&XXXXXXXXXXXXXo&&&&&&&&&&",
"&&&&&&&&# +@@@@@@@@@@#&&&&&&&&&&",
"&&&&&&&&&#o&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&+&&&&&&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img279[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c gray80",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&$%&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&& O&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&+ #&&&&&&",
"&&&&&&&#++++##++++#&%ooX .@&&&&&",
"&&&&&&&#++++##++++#&%+++ .@&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&+ #&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&& O&&&&&&&"
};
/* XPM */
static const char *img27greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::$@#;::::**::::::::::::",
"::::::::::#;.@:::-O-::::::::::::",
"::::::::::::#X;:=O-:::::::::::::",
"::::::::::::- $;O*::::::::::::::",
":::::::::::::OOo*:::::::::::::::",
":::::::::::::# $::::::::::::::::",
":::::::::::::# %::::::::::::::::",
"::::::::::::%#o#::::::::::::::::",
":::::::::::*@:@.::::::::::::::::",
"::::::::::&O;:- &:::::::::::::::",
":::::::::-o;:::XO-#:::::::::::::",
":::::::::&-::::-@+*:::::::::::::"
};
/* XPM */
static const char *img27[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c gray40",
"+ c #777777",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&@#&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&#o  o$&&&&&&&&&&&&&&",
"&&&&&&&&&&&&X    O&&&&&&&&&&&&&&",
"&&&&&&&&&&&&      &&&&&&&&&&&&&&",
"&&&&&&&&&&&&     .&&&&&&&&&&&&&&",
"&&&&&&&&&&&&o    O&&&&&&&&&&&&&&",
"&&&&&&&&&&&&%+ .+%&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img280[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #727272",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********%%**********************",
"*******&Xo**********************",
"*******+ $**********************",
"******o  oo+***#++++O++++#******",
"******o .++@***#++++O++++#******",
"*******+ $**********************",
"*******&Xo**********************"
};
/* XPM */
static const char *img281[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&+&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&#O&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&#.+@@@@@@@@@@#&&&&&&&&&&",
"&&&&&&&&X XXXXXXXXXXXO&&&&&&&&&&",
"&&&&&&&&%o$&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&%X&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&%X&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&%o$&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&X XXXXXXXXXXXO&&&&&&&&&&",
"&&&&&&&&$X$&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&#O&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&+&&&&&&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img282[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&O&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&@#&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&+.+++++++++++#&&&&&&&&&&",
"&&&&&&&&+.+++++++++++#&&&&&&&&&&",
"&&&&&&&&&#@&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&+&&&&&&&%$&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&X&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&$X&&&&&&&&&&&",
"&&&&&&&&XXXXXXXXXXXX @&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&+@&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&%o&&&&&&&&&&&&"
};
/* XPM */
static const char *img283[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==============$=================",
"=============&.=================",
"=============+@=================",
"============%         o=========",
"===========*X%==================",
"==========*o#===================",
"=========%.O++++++++++#=========",
"=========%.O++++++++++#=========",
"==========*o#===================",
"===========*X$==================",
"============%         o=========",
"=============+@=================",
"=============&.=================",
"==============$================="
};
/* XPM */
static const char *img284[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #111111",
". c #222222",
"X c gray40",
"o c #777777",
"O c #888888",
"+ c gray60",
"@ c #AAAAAA",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"###########o##o#################",
"##########OO#o@#################",
"#########o oX.oooooooo+#########",
"#########o oX.oooooooo+#########",
"##########OO#o@#################",
"###########o##o#################"
};
/* XPM */
static const char *img285[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #111111",
". c gray20",
"X c #555555",
"o c #777777",
"O c #888888",
"+ c gray60",
"@ c #BBBBBB",
"# c gray80",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%$o%%%%%%%%%%%@#%%%%%%%%",
"%%%%%%%%%O+%%%%%%%%%%$X$%%%%%%%%",
"%%%%%%%%o ooooooooooo.#%%%%%%%%%",
"%%%%%%%%o ooooooooooo.#%%%%%%%%%",
"%%%%%%%%%O+%%%%%%%%%%$X$%%%%%%%%",
"%%%%%%%%%$o%%%%%%%%%%%@#%%%%%%%%"
};
/* XPM */
static const char *img286[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"===================&$&==========",
"==================+.oX+=========",
"=================*.*==.&========",
"===========+=====$+===o$========",
"==========@@=====$+===.%========",
"=========+ ++++++Oo+OX+=========",
"=========+ ++++++Oo++%==========",
"==========@@=====$+=============",
"===========+=====$+=============",
"=================$+=============",
"=================%#============="
};
/* XPM */
static const char *img287[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #777777",
"O c gray60",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&O&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&@o&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&# +@@@@@@@@@@#&&&&&&&&&",
"&&&&&&&&&XXXXXXXXXXXXXo&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&XXXXXXXXXXXXXo&&&&&&&&&",
"&&&&&&&&&@@@@@@@@@@@o.%&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&X&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&$@&&&&&&&&&&&"
};
/* XPM */
static const char *img288[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=%##*-;;;;;;;;;;;;",
";;;;;;;;;;;;;$.#*&@X*;;;;;;;;;;;",
";;;;;;;;;;;;@O=;;;;*.&;;;;;;;;;;",
";;;;;;;;;;;$O;;;;;;;*X-;;;;;;;;;",
";;;;;;;;;;;.=;;;;;;;;+@;;;;;;;;;",
";;;;;;;;$@%.#@;;;;;;;=o;;;;;;;;;",
";;;;;;;;;*. *;;;;;;;;;o;;;;;;;;;",
";;;;;;;;;;%#;;;;;;;;;;O;;;;;;;;;"
};
/* XPM */
static const char *img289[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #222222",
". c #555555",
"X c gray40",
"o c #777777",
"O c #888888",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"****************$#**************",
"**************#O.&**************",
"**********&o%*O o%**************",
"*********&X%***.%o$*************",
"*********o$****@#*X*************",
"*********o********+#************",
"*********o*********o************",
"*********o*********o************",
"*********o********+#************",
"*********o#*******X*************",
"*********&X%*****o$*************",
"**********&oo@#oo%**************",
"*************$#&****************"
};
/* XPM */
static const char *img28greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;##;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;@&;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;.-;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*O;;;;;;;;;;;;;;;",
";;;;;;;;;;&O#;;%$;#@;;;;;;;;;;;;",
";;;;;;;;;-O- ;;@&;o ;;;;;;;;;;;;",
";;;;;;;;;@$% ;;.-;= ;;;;;;;;;;;;",
";;;;;;;;;*-OO;;O;;;O;;;;;;;;;;;;",
";;;;;;;;;;= %;%@;;&@;;;;;;;;;;;;",
";;;;;;;;;;& =;+%;-O=;;;;;;;;;;;;",
";;;;;;;;;;* &;O;-o&;;;;;;;;;;;;;",
";;;;;;;;;;;$X#X#O*;;;;;;;;;;;;;;",
";;;;;;;;;;;;;@+=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;O*;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;O;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;@;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img28[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"============X===================",
"============.#==================",
"============@+==================",
"============% ==================",
"=============.$=================",
"=============#+=================",
"=============% =================",
"==============o%================",
"==============@O================",
"==============&.================",
"===============o#===============",
"===============@O===============",
"===============*.===============",
"================o#==============",
"================#+==============",
"================* =============="
};
/* XPM */
static const char *img290[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&@&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&@+&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&@X$$$$&&&&&&&&&&&&&&",
"&&&&&&&&&&&&o.XXX &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&O#&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&%X&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&& &&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&& &&&&&&&&&&&&&&"
};
/* XPM */
static const char *img291[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"************O@***#O*************",
"***********O..+*@. O************",
"**********+@O$+oO$X$O***********",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************%&***&%*************"
};
/* XPM */
static const char *img292[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c #222222",
". c #444444",
"X c #777777",
"o c gray60",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c gray80",
"# c #DDDDDD",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$#$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$@.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$o .$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$+XO.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+.$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$#$$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img293[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #222222",
". c #444444",
"X c #777777",
"o c #AAAAAA",
"O c #BBBBBB",
"+ c gray80",
"@ c #DDDDDD",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"###############@################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"##############O.################",
"############OXo.################",
"#############o .################",
"##############+.################",
"###############@################"
};
/* XPM */
static const char *img294[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #111111",
". c #555555",
"X c #777777",
"o c #888888",
"O c gray60",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@+oo+@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@+ OO +@@@@@@@@@",
"@@@@@@@XXXXXXXXXX.X@@Xo@@@@@@@@@",
"@@@@@@@XXXXXXXXXX.X@@Xo@@@@@@@@@",
"@@@@@@@@@@@@@@@@@+ OO +@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@+oo+@@@@@@@@@@"
};
/* XPM */
static const char *img295[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------@--------------@--------",
"-------##=+%---@$---$@=@$-------",
"------@ @X+.%-@X.$-$.Oo@ $------",
"------@ @$-% OX=*.+ &-#@ $------",
"-------##---%O=--&O&---@$-------",
"--------@--------------@--------"
};
/* XPM */
static const char *img296[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #BBBBBB",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&$#&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&X&&&&&&&&&&&",
"&&&&&&&&&###########O.%&&&&&&&&&",
"&&&&&&&&&XXXXXXXXXXXX O&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&@+&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&$o&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&$o&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&@+&&&&&&&&&&",
"&&&&&&&&&XXXXXXXXXXXX O&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&#X&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&X&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&$#&&&&&&&&&&&"
};
/* XPM */
static const char *img297[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------------*+------------",
"-------------------O&-----------",
"--------++++++++++++ $----------",
"--------++++++++++++ $----------",
"-------------------o*-----------",
"----------#-------*@------------",
"---------&+---------------------",
"--------*.=---------------------",
"--------o XXXXXXXXXXX+----------",
"--------=O%---------------------",
"---------=X---------------------"
};
/* XPM */
static const char *img298[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c #111111",
". c #555555",
"X c #777777",
"o c #888888",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c gray80",
"# c #DDDDDD",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$X$#o$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$X+$.@$$$$$$$$$$$",
"$$$$$$$$XXXXXXXXX XX O$$$$$$$$$$",
"$$$$$$$$XXXXXXXXX XX O$$$$$$$$$$",
"$$$$$$$$$$$$$$$$X+$.@$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$X$#o$$$$$$$$$$$$"
};
/* XPM */
static const char *img299[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c gray20",
". c #555555",
"X c #777777",
"o c #888888",
"O c gray60",
"+ c #BBBBBB",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$X$$$$$$$$$$$+O$$$$$$$$$$",
"$$$$$$$$oo$$$$$$$$$$#.#$$$$$$$$$",
"$$$$$$$$$.XXXXXXXXXXX. @$$$$$$$$",
"$$$$$$$$$.XXXXXXXXXXX. @$$$$$$$$",
"$$$$$$$$oo$$$$$$$$$$#.#$$$$$$$$$",
"$$$$$$$$X$$$$$$$$$$$+O$$$$$$$$$$"
};
/* XPM */
static const char *img29greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-&;;;;;-O&;;;;;;;;;;;;",
";;;;;;;;;;O&;;;;;* @;;;;;;;;;;;;",
";;;;;;;;;=O;;;;;;;@@;;;;;;;;;;;;",
";;;;;;;;;+%;;-.*;;$#;;;;;;;;;;;;",
";;;;;;;;;o;;;$.;;;O*;;;;;;;;;;;;",
";;;;;;;;;o-;;@+;;*X;;;;;;;;;;;;;",
";;;;;;;;;o@-#.o=$.*;;;;;;;;;;;;;",
";;;;;;;;;%  .%   %;;;;;;;;;;;;;;",
";;;;;;;;;;=&;;-&;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img29[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c #222222",
"X c #444444",
"o c gray40",
"O c #BBBBBB",
"+ c gray80",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$#O$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$O $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$@ $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$O#X#O$$$$$$$$$$$$$$$",
"$$$$$$$$$$$+ XXX +$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$.$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$+ $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$+ $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$+ $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$O $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$ $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$@XoXoX@$$$$$$$$$$$$$$",
"$$$$$$$$$$$$O@X+O$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$@ $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$O $$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$#O$$$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img2greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::::*=:::::::::::::",
":::::::::::::::$@&%O;:::::::::::",
"::::::::::::::#%:::O%:::::::::::",
":::::::::::::&@::::.%:::::::::::",
":::::::::::::+;:::%.;:::::::::::",
"::::::::::::-O:&#$X&::::::::::::",
"::::::::::::*%:&#$.-::::::::::::",
"::::::::::::#*::::o+::::::::::::",
"::::::::::::o:::::XO::::::::::::",
":::::::::::=+::::= +::::::::::::",
":::::::::::&#::::# =::::::::::::",
":::::::::::@X;::-.@:::::::::::::",
":::::::::::o*@&%O%::::::::::::::",
":::::::::::@::==::::::::::::::::",
"::::::::::&#::::::::::::::::::::",
"::::::::::@=::::::::::::::::::::",
"::::::::::%:::::::::::::::::::::"
};
/* XPM */
static const char *img2[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------=$oo+*--------------",
"-----------&XO%&@.@-------------",
"----------= &----=o#------------",
"----------&@------%o------------",
"----------&@------&o------------",
"----------&@------&o------------",
"----------&@------&o------------",
"----------&@------&o------------",
"----------&@------&o------------",
"----------&@------&o------------",
"----------=&------=%------------"
};
/* XPM */
static const char *img300[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;*&-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;Xoo.$;;;;;;;;;;;;;;;;;;",
";;;;;;;;$+;;*X;;;;;;;;;;;;;;;;;;",
";;;;;;;;@@;;;X;;;;;=#;;;;;;;;;;;",
";;;;;;;;#+;;;o;;;;;;O*;;;;;;;;;;",
";;;;;;;;;Xo@@.@@@@@@@ %;;;;;;;;;",
";;;;;;;;;;%@@.@@@@@@@ %;;;;;;;;;",
";;;;;;;;;;;;;o;;;;;;O*;;;;;;;;;;",
";;;;;;;;;;;;;o;;;;;=#;;;;;;;;;;;",
";;;;;;;;;;;;;o;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;@;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img301[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::-&##&;:::::::::::::",
"::::::::::::$X#*&@.*::::::::::::",
":::::::::::#o-::::=.%:::::::::::",
"::::::::::*X;::::::;.=::::::::::",
"::::::::::X$::::::::%+::::::::::",
":::::::::;X:::::::-+# =O*:::::::",
":::::::::*#:::::::::# o-::::::::",
":::::::::*#::::::::::O-:::::::::"
};
/* XPM */
static const char *img302[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #444444",
". c #555555",
"X c gray40",
"o c #777777",
"O c gray60",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&$+&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&Xo@$&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&%o .$&o$&&&&&&&&&&&&&",
"&&&&&&&&&&%X$X%&&&o#&&&&&&&&&&&&",
"&&&&&&&&&&o#%o&&&&&X&&&&&&&&&&&&",
"&&&&&&&&&&o&&&&&&&&O@&&&&&&&&&&&",
"&&&&&&&&&&o&&&&&&&&&o&&&&&&&&&&&",
"&&&&&&&&&&o&&&&&&&&&o&&&&&&&&&&&",
"&&&&&&&&&&o&&&&&&&&O@&&&&&&&&&&&",
"&&&&&&&&&&o@&&&&&&&X&&&&&&&&&&&&",
"&&&&&&&&&&%X$&&&&&o#&&&&&&&&&&&&",
"&&&&&&&&&&&%oo+@oo$&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&#@%&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img303[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%O$%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%$$$$.$%%%%%%%%%%%%%%%",
"%%%%%%%%%%% XXX +%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%+@%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%o%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X%%%%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img304[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"************%&***&%*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"************O$***$X*************",
"**********+@O$+oO$X$O***********",
"***********O..@*#. O************",
"************O@***#O*************"
};
/* XPM */
static const char *img305[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #111111",
". c #444444",
"X c gray40",
"o c #BBBBBB",
"O c #DDDDDD",
"+ c #EEEEEE",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o .+@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.oX@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@O@@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img306[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #111111",
". c #444444",
"X c #555555",
"o c gray40",
"O c #BBBBBB",
"+ c #DDDDDD",
"@ c #EEEEEE",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##############+#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.#################",
"#############O.Oo###############",
"#############O X@###############",
"#############O.#################"
};
/* XPM */
static const char *img307[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==================*@============",
"========*o&===&o&==o&===========",
"========.OX#=%XO.+++ $==========",
"========$=& + %=%+++ $==========",
"===========&O%=====o&===========",
"==================*@============"
};
/* XPM */
static const char *img308[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c #222222",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$@$$$$$$$$$$$$$$$",
"$$$$$$$$$$X$$$$@.$$$$$$$$$$$$$$$",
"$$$$$$$$$+o$$$$XO$$$$$$$$$$$$$$$",
"$$$$$$$$O OOOOo OOOOO+$$$$$$$$$$",
"$$$$$$$$O OOOo OOOOOO+$$$$$$$$$$",
"$$$$$$$$$+o$$oO$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$X$@.#$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$@$$$$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img309[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------------*---------------",
"---------------*X-%#------------",
"---------------O@-=o&-----------",
"--------@@@@@@+ @@@O.$----------",
"--------@@@@@+ @@@@O.$----------",
"-------------+@---=o&-----------",
"------------*X=---%#------------",
"-------------*------------------"
};
/* XPM */
static const char *img30greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**********#o  OOOX O************",
"************O ****@O************",
"************O *****@************",
"************O *****+************",
"************O *****%************",
"************O ******************",
"************O ******************",
"************O ******************",
"************O ******************",
"************O ******************",
"************O ******************",
"**********$@. @@&***************"
};
/* XPM */
static const char *img30[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #222222",
". c #444444",
"X c gray40",
"o c #777777",
"O c gray80",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@X O@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@o.+@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img310[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-@;;;%$;;;;;;;;;;;;;",
";;;;;;;;;;;;+#;;;o$;;;;;;;;;;;;;",
";;;;;;;;;;;$X&&&&.%&&*;;;;;;;;;;",
";;;;;;;;;;@XOOOO.XOOO@;;;;;;;;;;",
";;;;;;;;#O@;;;;;X=;;;;;;;;;;;;;;",
";;;;;;;;#o+;;;;$O;;;;;;;;;;;;;;;",
";;;;;;;;;;@XOOOXXOOOO@;;;;;;;;;;",
";;;;;;;;;;;$.&# &&&&&*;;;;;;;;;;",
";;;;;;;;;;;;+#@@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-@@*;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img311[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::%%@:::::::::::::::",
"::::::::::::::o&+%::::::::::::::",
"::::::::*****$.&&.=:::::::::::::",
"::::::::OOOOO.oOOOX&::::::::::::",
"::::::::::::: -:::;+O*::::::::::",
"::::::::::::%@::::;oO*::::::::::",
"::::::::OOOO.XOOOOX&::::::::::::",
"::::::::***$o***%.=:::::::::::::",
":::::::::::@#:::+%::::::::::::::",
":::::::::::#-:::@:::::::::::::::"
};
/* XPM */
static const char *img312[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=;;;;;;;;;;;;;;;",
";;;;;;;;;;O;;;;=X;&#;;;;;;;;;;;;",
";;;;;;;;;$+;;;;O@;-o*;;;;;;;;;;;",
";;;;;;;;@ @@@@+ @@@O.%;;;;;;;;;;",
";;;;;;;;@ @@@+ @@@@O.%;;;;;;;;;;",
";;;;;;;;;$+;;+@;;;-o*;;;;;;;;;;;",
";;;;;;;;;;O;=X-;;;&#;;;;;;;;;;;;",
";;;;;;;;;;;;;=;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img313[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;%#;;%#+=;;;;;;;;;;;;",
";;;;;;;;;;;;o%;;#$##;;;;;;;;;;;;",
";;;;;;;;;;;#O&&&o%&.&;;;;;;;;;;;",
";;;;;;;;;;$XOOOX.OOOX&;;;;;;;;;;",
";;;;;;;;=OO-;;;##;;;*X#;;;;;;;;;",
";;;;;;;;=Oo-;;;O&;;;*.#;;;;;;;;;",
";;;;;;;;;;$XOOO oOOOX&;;;;;;;;;;",
";;;;;;;;;;;#O&#+&&&.&;;;;;;;;;;;",
";;;;;;;;;;;;o%@%;;##;;;;;;;;;;;;",
";;;;;;;;;;;;%#o*;;+=;;;;;;;;;;;;"
};
/* XPM */
static const char *img314[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==================*@============",
"========*o&===&o&==o&===========",
"========.OX#=%XO.+++ $==========",
"========$=& + %=%+++ $==========",
"===========&O%=====o&===========",
"==================*@============"
};
/* XPM */
static const char *img315[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c black",
". c #555555",
"X c gray40",
"o c #888888",
"O c gray80",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@oX+@@@@oX+@@@@oX+@@@@@@@",
"@@@@@@@@. O@@@@. O@@@@. O@@@@@@@"
};
/* XPM */
static const char *img316[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c #222222",
". c #444444",
"X c gray40",
"o c #777777",
"O c gray80",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@X O@@@@X O@@@@X O@@@@@@@@",
"@@@@@@@o.+@@@@o.+@@@@o.+@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img317[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c black",
". c #555555",
"X c gray40",
"o c #888888",
"O c gray80",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@oX+@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@. O@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@oX+@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@. O@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@oX+@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@. O@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img318[] = {
/* columns rows colors chars-per-pixel */
"32 32 7 1",
"  c black",
". c #555555",
"X c gray40",
"o c #888888",
"O c gray80",
"+ c #DDDDDD",
"@ c gray100",
/* pixels */
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@oX+@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@. O@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@oX+@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@. O@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@oX+@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@. O@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@",
"@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
};
/* XPM */
static const char *img319[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::-::::-:::::::::::::::",
":::::::::::O::::.-::::::::::::::",
"::::::::::: %:::X@::::::::::::::",
":::::::::::$.=::= %:::::::::::::",
"::::::::::::@.;::XO:::::::::::::",
":::::::::::;O+O:*%&:::::::::::::",
":::::::::::%@-X@**::::::::::::::",
":::::::::::+#:=.o=::::::::::::::",
":::::::::::O@::& *::::::::::::::",
":::::::::::% *::#.-:::::::::::::",
":::::::::::;.X:::+@:::::::::::::",
":::::::::::#.o:::=+:::::::::::::"
};
/* XPM */
static const char *img31greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::-&::::::::::::::::",
"::::::::::::::+ -:::::::::::::::",
":::::::::::::-o #:::::::::::::::",
":::::::::::::+*X ;::::::::::::::",
"::::::::::::-@:$ #::::::::::::::",
"::::::::::::+=::o.;:::::::::::::",
":::::::::::=+:::% #:::::::::::::",
":::::::::::@=::::o.-::::::::::::",
"::::::::::=O:::::& #::::::::::::",
"::::::::::@=::::::. -:::::::::::",
":::::::::=+:::::::& #:::::::::::",
":::::::::++########  ;::::::::::",
":::::::::            #::::::::::"
};
/* XPM */
static const char *img31[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-@=;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;#.=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;X$;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;O@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;-.%;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;%.=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;X@;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;- &;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;& ;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;= =;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;o+-;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;-#*;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img320[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==============+o================",
"=============*  ================",
"=============% O================",
"=============# %================",
"=============Xo=================",
"============= @=================",
"============$.*=================",
"============O+==================",
"============&*=================="
};
/* XPM */
static const char *img321[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::-:::::::-:::::::::::::",
"::::::::::X;:::::*.:::::::::::::",
"::::::::::O$:::::##:::::::::::::",
"::::::::::*+:::::.=:::::::::::::",
":::::::::::.%***$o::::::::::::::",
":::::::::::#o###.&::::::::::::::",
":::::::::::*X::: ;::::::::::::::",
"::::::::::::o*:$@:::::::::::::::",
"::::::::::::%@:O%:::::::::::::::",
"::::::::::::- -X::::::::::::::::",
":::::::::::::@X@::::::::::::::::",
":::::::::::::% -::::::::::::::::",
"::::::::::::::&:::::::::::::::::"
};
/* XPM */
static const char *img322[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::==::::::*-::::::::::::",
"::::::::;+o.o-::*O#@#:::::::::::",
"::::::::@%:-O.=&O-::$%::::::::::",
"::::::::#::::X.X;::::#::::::::::",
"::::::::#::::=.o:::::#::::::::::",
"::::::::#::::*. #::::#::::::::::",
"::::::::+=::;X=# %::$#::::::::::",
"::::::::-+##o=::$ +@O:::::::::::",
"::::::::::==::::::*-::::::::::::"
};
/* XPM */
static const char *img323[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;=*;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;o.o;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;-&.+&&*;;;;;;;;;;;;;;",
";;;;;;;;;;;-# %&&*;;;;;;;;;;;;;;",
";;;;;;;;;;;;% ;&=;;;;;;;;;;;;;;;",
";;;;;;;;;;;;+X@&X&;;;;;;;;;;;;;;",
";;;;;;;;;;;;.O;;+@;;;;;;;;;;;;;;",
";;;;;;;;;;;& &;;X#;;;;;;;;;;;;;;",
";;;;;;;;;;;$.;;; &;;;;;;;;;;;;;;",
";;;;;;;;;;;O+;;#.-%;;;;;;;;;;;;;",
";;;;;;;;;;; @;;o@*@;;;;;;;;;;;;;",
";;;;;;;;;;= &;;O+O=;;;;;;;;;;;;;",
";;;;;;;;;;;*;;;;&-;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img324[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;=##o*;;;;;;;;;;;;;;",
";;;;;;;;;;;;*O=%.*;;;;;;;;;;;;;;",
";;;;;;;;;;;;O$;#.@;;;;;;;;;;;;;;",
";;;;;;;;;;;; =;O@.;;;;;;;;;;;;;;",
";;;;;;;;;;;= ;-X; =;;;;;;;;;;;;;",
";;;;;;;;;;;& ;%O; &;;;;;;;;;;;;;",
";;;;;;;;;;;& ;@@; &;;;;;;;;;;;;;",
";;;;;;;;;;;& ;o=; &;;;;;;;;;;;;;",
";;;;;;;;;;;* *.;; *;;;;;;;;;;;;;",
";;;;;;;;;;;; @+;&X;;;;;;;;;;;;;;",
";;;;;;;;;;;;O.%;@@;;;;;;;;;;;;;;",
";;;;;;;;;;;;& %&o-;;;;;;;;;;;;;;",
";;;;;;;;;;;;&O##-;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=&;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img325[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c #444444",
"X c #BBBBBB",
"o c gray80",
"O c #DDDDDD",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++XXXXXXo+++++++++++++",
"+++++++++++O...... +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++       +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"++++++++++++++++++ +++++++++++++",
"+++++++++++O...... +++++++++++++"
};
/* XPM */
static const char *img326[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #BBBBBB",
"$ c gray80",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&%#&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&o+O&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&@#+X&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&+&.+&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&# $&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&oX%#&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&& +@#&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&.Oo&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&%#&&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img327[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::-           *::::::::::",
"::::::::::O &*******+:::::::::::",
"::::::::::= %::::::*&:::::::::::",
":::::::::::O.::::::@::::::::::::",
":::::::::::& $::::*%::::::::::::",
"::::::::::::OX::::@:::::::::::::",
"::::::::::::& #::&&:::::::::::::",
":::::::::::::oX::+::::::::::::::",
":::::::::::::& $&%::::::::::::::",
"::::::::::::::oX#;::::::::::::::",
"::::::::::::::* &:::::::::::::::",
":::::::::::::::@::::::::::::::::"
};
/* XPM */
static const char *img328[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c #444444",
". c #777777",
"X c #BBBBBB",
"o c #DDDDDD",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOo        .OOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOX OOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOX OOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOX OOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOo.OOOOOOOOOOOO"
};
/* XPM */
static const char *img329[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"===============&%===============",
"==============$+X#==============",
"=============&O=oo==============",
"=============%$=.+==============",
"===============% %==============",
"===============+.===============",
"===============Oo===============",
"===============.+===============",
"==============% %===============",
"===========*.@@.================",
"===========& +.%================",
"============%$&================="
};
/* XPM */
static const char *img32greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::;*=::::::::::::::::",
":::::::::::*O#*%O#;:::::::::::::",
"::::::::::% *:::;OO;::::::::::::",
":::::::::=.#:::::; #::::::::::::",
":::::::::# =::::::+.-:::::::::::",
"::::::::: X;-::::=% &:::::::::::",
"::::::::: O*XOOOOO* #:::::::::::",
"::::::::: O*XOOOOO* #:::::::::::",
"::::::::: X;-::::=% &:::::::::::",
":::::::::O -::::::@ =:::::::::::",
":::::::::* $:::::; +::::::::::::",
"::::::::::#.;::::#o-::::::::::::",
":::::::::::%o%:-+O;:::::::::::::",
":::::::::::::&#$-:::::::::::::::"
};
/* XPM */
static const char *img32[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #777777",
"@ c gray60",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&@o .O&$O .O$&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&&& +&&&&OO&&&&&&&&&&&&",
"&&&&&&&&&&#+ O++++XX+%&&&&&&&&&&"
};
/* XPM */
static const char *img330[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::*#::::::::::",
"::::::::::::::::::::O&::::::::::",
":::::::::::::::::::&X:::::::::::",
":::::::::::::::::::O%:::::::::::",
"::::::::::::::::::-X;:::::::::::",
"::::::::::::::::::O$::::::::::::",
":::::::::::::::::-.;::::::::::::",
":::::::::::::::::+$:::::::::::::",
":::::::::-+%::::=X;:::::::::::::",
":::::::::@OX::::@#::::::::::::::",
"::::::::::* *::*.:::::::::::::::",
":::::::::::oO::@$:::::::::::::::",
":::::::::::$ =- -:::::::::::::::",
":::::::::::;X+##::::::::::::::::",
"::::::::::::@. -::::::::::::::::",
"::::::::::::;.#:::::::::::::::::",
":::::::::::::%;:::::::::::::::::"
};
/* XPM */
static const char *img331[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&$%%-;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&O&+O;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;% &;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;% *;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&;@X;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&&=.$;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&%O+;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&o#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;=*;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img332[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;*&;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;o.=;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;%o@#;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;o%=.-;;;;;;;;;;;;;;",
";;;;;;;;;;;;$o;;#@;;;;;;;;;;;;;;",
";;;;;;;;;;;-X*;;-X*;;;;;;;;;;;;;",
";;;;;;;;;;;$+;;;;#@;;;;;;;;;;;;;",
";;;;;;;;;;=.=;;;;;.%;;;;;;;;;;;;",
";;;;;;;;;;##;;;;;;%O;;;;;;;;;;;;",
";;;;;;;;;= =;;;;;;;X%;;;;;;;;;;;",
";;;;;;;;;+#;;;;;;;;%X;;;;;;;;;;;",
";;;;;;;;; oOOOOOOOOO *;;;;;;;;;;"
};
/* XPM */
static const char *img333[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::-*;::::::::::::::",
"::::::::::::::=o%%::::::::::::::",
"::::::::::::::O%=%::::::::::::::",
":::::::::::::*.:#;::::::::::::::",
":::::::::::::O@;#:::::::::::::::",
"::::::::::::- *#=:::::::::::::::",
"::::::::::::* %#::::::::::::::::",
"::::::::::::#.@:::::::::::::::::",
"::::::::::::+o;:::::::::::::::::",
":::::::::::;X#::::::::::::::::::",
":::::::::::###::$:::::::::::::::",
"::::::::::::=o&@=:::::::::::::::",
":::::::::::::;*:::::::::::::::::"
};
/* XPM */
static const char *img334[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c #444444",
". c gray40",
"X c #777777",
"o c #BBBBBB",
"O c gray80",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++XXXXXXXXXXO+++++++++++",
"++++++++++XXXX. XXXXO+++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++",
"++++++++++++++oX++++++++++++++++"
};
/* XPM */
static const char *img335[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #222222",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"************#*******************",
"************+*******************",
"************+*******************",
"************+**%****************",
"************O@.X****************",
"************  o+****************",
"************O%*+****************",
"************+**+****************",
"************+**+****************",
"************+**+****************",
"************+*&+****************",
"************O+.X****************",
"************ .O+****************",
"************#&*+****************",
"***************+****************",
"***************$****************"
};
/* XPM */
static const char *img336[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::*+O%;:::::::::::::",
":::::::::::::&    @:::::::::::::",
":::::::::::::+     :::::::::::::",
":::::::::::::O     :::::::::::::",
":::::::::::::@     :::::::::::::",
":::::::::::::&    @:::::::::::::",
":::::::::::# oX   o +=::::::::::",
"::::::::::$          +::::::::::",
"::::::::::O           ::::::::::",
"::::::::::O           ::::::::::",
"::::::::::#    oX.   o::::::::::",
"::::::::::;.  .*#+   &::::::::::",
":::::::::::;$#;#O:%#-:::::::::::",
":::::::::::::::O :::::::::::::::",
":::::::::::::::-=:::::::::::::::"
};
/* XPM */
static const char *img337[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&-;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;@@--%@%;;;;;;;;;;;;;",
";;;;;;;;;;;*O;%@&;+@;;;;;;;;;;;;",
";;;;;;;;;;;@@%#;;;@O;;;;;;;;;;;;",
";;;;;;;;;;;O$+;;;;@O;;;;;;;;;;;;",
";;;;;;;;;;;OX=;;;;o+;;;;;;;;;;;;",
";;;;;;;;;;;$ &*+;%.-;;;;;;;;;;;;",
";;;;;;;;;;;$oX*+$X*;;;;;;;;;;;;;",
";;;;;;;;;;;+-o#=*;;;;;;;;;;;;;;;",
";;;;;;;;;;;+;@%;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;+*o;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&#-;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img338[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c #EEEEEE",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##############@+################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##########XXXX. XXXXO###########"
};
/* XPM */
static const char *img339[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #BBBBBB",
"# c #DDDDDD",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%@%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%@%%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%O$%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%O+. @%%%%%%%%%%%%%%%",
"%%%%%%%%%%%@  XO$%%%%%%%%%%%%%%%",
"%%%%%%%%%%%#X#%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%X#%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%O+. @%%%%%%%%%%%%%%%",
"%%%%%%%%%%%@ .o+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%#X%%+%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%+%%@%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%@%%%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img33greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------%%----------------",
"--------------o@----------------",
"-------------=..=---------------",
"-------------#. %---------------",
"-------------+& @---------------",
"------------=O-X.=--------------",
"------------$@-@ %--------------",
"------------@=-% @--------------",
"------------X---..--------------",
"-----------%@---@ *-------------",
"-----------@%---# @-------------",
"----------=X----=.o-------------",
"---------%o O*-*+  @%-----------"
};
/* XPM */
static const char *img33[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*+o;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*+o&;;;;;;;;;;;;;",
";;;;;;;;;;;;;*Oo%;;;;;;;;;;;;;;;",
";;;;;;;;;;;*+o&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;# %;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-@o#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=+X$;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=#.$-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=#.$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@        X;;;;;;;;;;;;"
};
/* XPM */
static const char *img340[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::=$::::::::::::::::",
"::::::::::::::o -:::::::::::::::",
":::::::::::::$o#+:::::::::::::::",
"::::::::::::;X*;X*::::::::::::::",
"::::::::::::+#::&.;:::::::::::::",
":::::::::::$o::::#O:::::::::::::",
"::::::::::%.-:::::O@::::::::::::",
":::::::::: %::::::: %:::::::::::",
"::::::::::%.-:::::O@::::::::::::",
":::::::::::$o::::#O:::::::::::::",
"::::::::::::+#::&.;:::::::::::::",
"::::::::::::;X=;o&::::::::::::::",
":::::::::::::$O#+:::::::::::::::",
"::::::::::::::o -:::::::::::::::",
"::::::::::::::*#::::::::::::::::"
};
/* XPM */
static const char *img341[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::;*=::-%#;:::::::::::::",
"::::::::::+*+$$+$ @:::::::::::::",
"::::::::::#:&.@::#.=::::::::::::",
"::::::::::O=: $::-.@::::::::::::",
"::::::::::=o; #:::# *:::::::::::",
":::::::::::#* o***O$-:::::::::::",
"::::::::::*#* X#.O=:::::::::::::",
"::::::::::@+: O:OO::::::::::::::",
"::::::::::--: #:OO::::::::::::::",
"::::::::::-:: #:OO::::::::::::::",
":::::::::-X:- -:OO:=;:::::::::::",
"::::::::::#*#+::# #O;:::::::::::",
":::::::::::%%::::&%:::::::::::::"
};
/* XPM */
static const char *img343[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"============X===================",
"============.#==================",
"============@+==================",
"============% ==================",
"=============.$=================",
"=============#+=================",
"=============% =================",
"==============o%================",
"==============@O================",
"==============&.================",
"===============o#===============",
"===============@O===============",
"===============*.===============",
"================o#==============",
"================#+==============",
"================* =============="
};
/* XPM */
static const char *img344[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::;&#&::=#$-::::::::::::",
"::::::::::#O*+o#o&#o::::::::::::",
":::::::::: -::+.;::X&:::::::::::",
"::::::::::o:::*$:::##:::::::::::",
"::::::::::o::::::::##:::::::::::",
":::::::::: ;:::::::o&:::::::::::",
"::::::::::+#::::::=X;:::::::::::",
"::::::::::-.*::::;X&::::::::::::",
":::::::::::* ;:::+#:::::::::::::",
"::::::::::::%X=;O+::::::::::::::",
":::::::::::::%X@@:::::::::::::::",
"::::::::::::::+.;:::::::::::::::",
"::::::::::::::=$::::::::::::::::"
};
/* XPM */
static const char *img345[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::;***:::::::::::::::::",
"::::::::::=@**@o=:::::::::::::::",
"::::::::::+::::o *::::::::::::::",
"::::::::::#::::;oo:+::::::::::::",
"::::::::::#::::::%#-::::::::::::",
"::::::::::#*::::=o#%::::::::::::",
"::::::::::;$#%::X#:#::::::::::::",
"::::::::::::::::.O::::::::::::::",
"::::::::::::::::& $:::::::::::::",
"::::::::::#X+;:::@O:::::::::::::",
":::::::::::;oo;::oO:::::::::::::",
"::::::::::::;oo$+.=:::::::::::::",
"::::::::::::::=**:::::::::::::::"
};
/* XPM */
static const char *img346[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;-o$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;+@;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;#o;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;%o=;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;*.*;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;=X&;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-o#;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;+@;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;#o;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;$X-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;; XOOOOOOO&;;;;;;;;;;;;"
};
/* XPM */
static const char *img347[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::;&#%;:::::::::::::::",
":::::::::::;O**#o-::::::::::::::",
":::::::::::$o:::@#::::::::::::::",
":::::::::::%O:::#.::::::::::::::",
"::::::::::::-**-# ::::::::::::::",
":::::::::::*o**@# ::::::::::::::",
"::::::::::$.-::* o::::::::::::::",
":::::::::; #:::* $::::::::::::::",
":::::::::% =:::* =::::::::::::::",
":::::::::#X::::O+:::::::::::::::",
":::::::::%X:::&.-:::::::::::::::",
"::::::::::o+*$X=::::::::::::::::",
":::::::::::&#*::::::::::::::::::"
};
/* XPM */
static const char *img348[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::=$::::::::::::::::",
"::::::::::::::+.-:::::::::::::::",
":::::::::::::*  #:::::::::::::::",
"::::::::::::;X   *::::::::::::::",
":::::::::::;o     *:::::::::::::",
"::::::::::;o      .=::::::::::::",
"::::::::::#        o::::::::::::",
"::::::::::          %:::::::::::",
"::::::::::          #:::::::::::",
"::::::::::          #:::::::::::",
"::::::::::    oX.   &:::::::::::",
"::::::::::+  X*#@  .::::::::::::",
"::::::::::;$$:#O:&#-::::::::::::",
"::::::::::::::O ::::::::::::::::",
"::::::::::::::-=::::::::::::::::"
};
/* XPM */
static const char *img349[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=*;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o.o;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;.#&++-;;;;;;;;;;;;;;",
";;;;;;;;;;;$ +&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;$@ ;&=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;+X@&X&;;;;;;;;;;;;;;;",
";;;;;;;;;;;.O;;+@;;;;;;;;;;;;;;;",
";;;;;;;;;;& &;;X#;;;;;;;;;;;;;;;",
";;;;;;;;;;$.;;; &;;;;;;;;;;;;;;;",
";;;;;;;;;;O+;;#.-%;;;;;;;;;;;;;;",
";;;;;;;;;; @;;o@*@;;;;;;;;;;;;;;",
";;;;;;;;;= &;;O+O=;;;;;;;;;;;;;;",
";;;;;;;;;;*;;;;&-;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img34greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #222222",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**********XXXXXXXXX@************",
"*********&X++++++++O************",
"*********$+********X************",
"********************************",
"***********+*****@%*************",
"***********XXXXXX.$*************",
"***********X+++++X$*************",
"***********@*****$&*************",
"********************************",
"*********$+********X************",
"*********&o$$$$$$$#O************",
"**********         +************"
};
/* XPM */
static const char *img34[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------*---------------------",
"----------@.#-------------------",
"-----------&OX$-----------------",
"-------------%+.$=--------------",
"---------------&O.$-------------",
"-----------------&.X------------",
"----------------$XO&------------",
"--------------%.X%--------------",
"------------$Xo$----------------",
"----------$oo&------------------",
"----------$&--------------------",
"--------------------------------",
"--------------------------------",
"----------+        .------------"
};
/* XPM */
static const char *img350[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;*;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;- #;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;@.o;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;.*.&;;;;;;;;;;;;;;;",
";;;;;;;;;;;;$o;$O;;;;;;;;;;;;;;;",
";;;;;;;;;;;;X&;- *;;;;;;;;;;;;;;",
";;;;;;;;;;;& ;;;@+;;;;;;;;;;;;;;",
";;;;;;;;;;;o$;;;= -;;;;;;;;;;;;;",
";;;;;;;;;;* -;;;;@@;;;;;;;;;;;;;",
";;;;;;;;;;+o@@@@@+.;;;;;;;;;;;;;",
";;;;;;;;;;%@@@@@@@#;;;;;;;;;;;;;"
};
/* XPM */
static const char *img351[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::-*******=::::::::::::",
":::::::::::+XOOOOOo.::::::::::::",
":::::::::::&X;::::#@::::::::::::",
"::::::::::::o&:::;X;::::::::::::",
"::::::::::::&o:::$O:::::::::::::",
":::::::::::::.-::o*:::::::::::::",
":::::::::::::$+:&o::::::::::::::",
":::::::::::::;X;O&::::::::::::::",
"::::::::::::::@OX;::::::::::::::",
"::::::::::::::- #:::::::::::::::",
":::::::::::::::%;:::::::::::::::"
};
/* XPM */
static const char *img352[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c #777777",
"O c #AAAAAA",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++XXXXXXXXXXO+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++ XXXXXXXX.o+++++++++++"
};
/* XPM */
static const char *img353[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=%;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;o *;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;#o#o;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=.=;o$;;;;;;;;;;;;;;",
";;;;;;;;;;;;+@;;= =;;;;;;;;;;;;;",
";;;;;;;;;;;%X-;;;@+;;;;;;;;;;;;;",
";;;;;;;;;;;X$;;;;-X&;;;;;;;;;;;;",
";;;;;;;;;;*X-;;;;;@+;;;;;;;;;;;;",
";;;;;;;;;;;O@;;;;* -;;;;;;;;;;;;",
";;;;;;;;;;;=.*;;;O#;;;;;;;;;;;;;",
";;;;;;;;;;;;#o;;#o-;;;;;;;;;;;;;",
";;;;;;;;;;;;;O$-.*;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&X+@;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;@X-;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;=;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img354[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::;****=:::::::::::::",
"::::::::::::$.+##@.@=:::::::::::",
"::::::::::;OO;:::::$X*::::::::::",
"::::::::::+@::;#$;&:*X;:::::::::",
":::::::::*o;:=O;-+O::#O:::::::::",
":::::::::+$::O%::;+::;.;::::::::",
":::::::::O;::+o-::-:::O*::::::::",
":::::::::X:::;X o+;:::@#::::::::",
":::::::::X:::::&@XO:::O%::::::::",
":::::::::O&::*:::-.:::o-::::::::",
":::::::::#@::+-:::O::&.:::::::::",
"::::::::::.&:OO%*+%:;o&:::::::::",
"::::::::::*X*-:-*;::O@::::::::::",
":::::::::::=o@*-;*$X#:::::::::::",
"::::::::::::;$+. o#=::::::::::::"
};
/* XPM */
static const char *img355[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::*=::::::::::::",
":::::::::::::::::=X=::::::::::::",
"::::::::::::::::;X%:::::::::::::",
"::::::::::::::::O@::::::::::::::",
":::::::::::::::#+;::::::::::::::",
"::::::::::::::&o;:::::::::::::::",
":::::::::::::=X=::::::::::::::::",
"::::::::::::;.@:::::::::::::::::",
"::::::::::::O@.-::::::::::::::::",
":::::::::::#+:##::::::::::::::::",
"::::::::::$o;:;X::::::::::::::::",
":::::::::: XOOO OOO&::::::::::::",
":::::::::::::::%::::::::::::::::"
};
/* XPM */
static const char *img356[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::&%::::::::::::::",
"::::::::::::::::+$::::::::::::::",
"::::::::::::****o$=:::::::::::::",
":::::::::::-OOOO.O :::::::::::::",
":::::::::::::::&O: :::::::::::::",
":::::::::::::::##: :::::::::::::",
":::::::::::::::O&: :::::::::::::",
":::::::::::::::X:: :::::::::::::",
"::::::::::::       :::::::::::::",
"::::::::::::::#@:: :::::::::::::",
"::::::::::::::#%:: :::::::::::::",
"::::::::::::::o;:: :::::::::::::",
":::::::::::::- ::: :::::::::::::",
":::::::::::-Oo.OOO :::::::::::::",
":::::::::::::$$:::::::::::::::::"
};
/* XPM */
static const char *img357[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::X  :::O  -:::::::::::",
":::::::::::#:@:::@--$:::::::::::",
"::::::::::=*-o:::#%:%:::::::::::",
"::::::::::::+%:::- ;::::::::::::",
":::::::::::* *::::o#::::::::::::",
":::::::::::OX:::::#.;:::::::::::",
"::::::::::: @:::::% $:::::::::::",
"::::::::::: #:::::* #:::::::::::",
"::::::::::: O:::::$ %:::::::::::",
":::::::::::$ *:::;oO::::::::::::",
"::::::::::::%.&:=OO:::::::::::::",
"::::::::::::::%#$;::::::::::::::"
};
/* XPM */
static const char *img358[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c black",
". c #222222",
"X c #444444",
"o c #DDDDDD",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOoOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOO.    OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOO OOOOOOOOOOOOO",
"OOOOOOOOOOOoXXXXXX OOOOOOOOOOOOO"
};
/* XPM */
static const char *img359[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;&&&*;;;;;;;;;;;;;;;;",
";;;;;;;;;;=..@@ +-;;;;;;;;;;;;;;",
";;;;;;;;;;;=;;;;+o-;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;o$;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;$.;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;; ;;;;;;;;;;;;;",
";;;;;;;;;;-&&&;;;;o;;;;;;;;;;;;;",
";;;;;;;;;;@.oo;;;; ;;;;;;;;;;;;;",
";;;;;;;;;;@@;;;;;% ;;;;;;;;;;;;;",
";;;;;;;;;;@@;;;;;O#;;;;;;;;;;;;;",
";;;;;;;;;;@@;;;;@X-;;;;;;;;;;;;;",
";;;;;;;;;;#o@@@oo-;;;;;;;;;;;;;;",
";;;;;;;;;;;%@@@*;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img35greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"*********#o  OOOOO  O%**********",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"***********O ***** @************",
"*********$@. @#*#+ X@&**********"
};
/* XPM */
static const char *img35[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c black",
". c #777777",
"X c gray60",
"o c gray80",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOO          XOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOO..........oOOOOOOOOOOOO",
"OOOOOOOOO..........oOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOO          XOOOOOOOOOOOO"
};
/* XPM */
static const char *img360[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;# X&;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o&&;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o&&;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o&&-&&&-;;;;;;;;;;;;;",
";;;;;;;;;;;o&&-X #-;;;;;;;;;;;;;",
";;;;;;;;;;;o&&*o*;;;;;;;;;;;;;;;",
";;;;;;;;;;;o&# =;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o& %o;;;;;;;;;;;;;;;;",
";;;;;;;;;;;o&#o$O;;;;;;;;;;;;;;;",
";;;;;;;;;;;o&&&O@#;;;;;;;;;;;;;;",
";;;;;;;;;;$X+o=.@ #;;;;;;;;;;;;;"
};
/* XPM */
static const char *img361[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #222222",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"*************+o*****************",
"*************X #****************",
"*************@ +****************",
"************** O****************",
"**************+ &***************",
"**************% $***************",
"***************o+***************",
"***************#.***************",
"****************$***************"
};
/* XPM */
static const char *img362[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::=*;::;-:::::::::::",
"::::::::::::%oOOo@=X%:::::::::::",
":::::::::::#+;:::+ &::::::::::::",
"::::::::::=.;:::%.O$::::::::::::",
"::::::::::$#:::#o=*+::::::::::::",
"::::::::::##::@O;::O::::::::::::",
"::::::::::$#;o@:::&+::::::::::::",
"::::::::::- o$::::o%::::::::::::",
"::::::::::*..*::-+O:::::::::::::",
"::::::::::.==XXo.$::::::::::::::"
};
/* XPM */
static const char *img363[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;=;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;-.$;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;# O;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;X  *;;;;;;;;;;;;;;",
";;;;;;;;;;;;;%   +;;;;;;;;;;;;;;",
";;;;;;;;;;;;;o    =;;;;;;;;;;;;;",
";;;;;;;;;;;;*     @;;;;;;;;;;;;;",
";;;;;;;;;;;;O      -;;;;;;;;;;;;",
";;;;;;;;;;;=       #;;;;;;;;;;;;",
";;;;;;;;;;;@       X;;;;;;;;;;;;",
";;;;;;;;;;;&#######$;;;;;;;;;;;;"
};
/* XPM */
static const char *img364[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::-*******=::::::::::::",
":::::::::::+       .::::::::::::",
":::::::::::&       @::::::::::::",
"::::::::::::o      ;::::::::::::",
"::::::::::::&     O:::::::::::::",
":::::::::::::.    *:::::::::::::",
":::::::::::::$   o::::::::::::::",
":::::::::::::;.  &::::::::::::::",
"::::::::::::::@ X;::::::::::::::",
"::::::::::::::- #:::::::::::::::",
":::::::::::::::%;:::::::::::::::"
};
/* XPM */
static const char *img365[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c black",
". c #444444",
"X c #777777",
"o c #AAAAAA",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOO..........oOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO",
"OOOOOOOOOO          XOOOOOOOOOOO"
};
/* XPM */
static const char *img366[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=%;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;o *;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;#  o;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=.   $;;;;;;;;;;;;;;",
";;;;;;;;;;;;+     =;;;;;;;;;;;;;",
";;;;;;;;;;;%      +;;;;;;;;;;;;;",
";;;;;;;;;;;X       &;;;;;;;;;;;;",
";;;;;;;;;;*        +;;;;;;;;;;;;",
";;;;;;;;;;;O       -;;;;;;;;;;;;",
";;;;;;;;;;;=.     #;;;;;;;;;;;;;",
";;;;;;;;;;;;#    o-;;;;;;;;;;;;;",
";;;;;;;;;;;;;O   *;;;;;;;;;;;;;;",
";;;;;;;;;;;;;&. @;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;@X-;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;=;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img367[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================&===============",
"===============*X*==============",
"===============$ $==============",
"===============O O==============",
"===============   ==============",
"=========*$$$$#   #$$$$=========",
"=========*O           O=========",
"===========#X       X#==========",
"============%o     o%===========",
"=============O     +============",
"=============X     X============",
"============$  o&o  $===========",
"============+.@===@ +===========",
"============+%=====%+==========="
};
/* XPM */
static const char *img368[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==================&O%===========",
"================&X.%============",
"==============&@.@.=============",
"============&+ $*=.=============",
"===========O.#====O&============",
"===========O #====o&============",
"============&+ $*=.=============",
"==============&@.+.=============",
"================*XX%============",
"==================&O%==========="
};
/* XPM */
static const char *img369[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #444444",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&$OO#&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&o    X&&&&&&&&&&&&&&&",
"&&&&&&&&&&& .++. @&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&O @&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&O @&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&%X%&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&%X%&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&O @&&&&&&&&&&&&&&",
"&&&&&&&&&&& O&&O @&&&&&&&&&&&&&&",
"&&&&&&&&&&& .++. @&&&&&&&&&&&&&&",
"&&&&&&&&&&&o    X&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&$OO#&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img36greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::  oOOOOX  *::::::::::::",
":::::::::# @:::::= #::::::::::::",
"::::::::::o &:::::$#::::::::::::",
"::::::::::=.X;::::-#::::::::::::",
":::::::::::# O:::::-::::::::::::",
"::::::::::::O %:::::::::::::::::",
"::::::::::::-.$:::::::::::::::::",
"::::::::::::##:::::-::::::::::::",
":::::::::::&+:::::-#::::::::::::",
"::::::::::*o::::::##::::::::::::",
":::::::::=o;:::::& #::::::::::::",
":::::::::oXOOOOOX  *::::::::::::"
};
/* XPM */
static const char *img36[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #202020",
". c #444444",
"X c #585858",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c #EEEEEE",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##########+o####################",
"##########+o####################",
"##########+o####################",
"##########+o####################",
"##########+o####################",
"##########+X+++++++++@##########",
"##########+ .........O##########",
"##########+o####################",
"##########+o####################",
"##########+ .........O##########",
"##########+X+++++++++@##########",
"##########+o####################",
"##########+o####################",
"##########+o####################",
"##########+o####################",
"##########+o####################"
};
/* XPM */
static const char *img370[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#%*::=*::::::::::::::",
":::::::::::**#o@O ::::::::::::::",
"::::::::::*.$X#X#$::::::::::::::",
"::::::::::=O$::- *::::::::::::::",
"::::::::::::;**-+o::::::::::::::",
":::::::::::=o&*## =:::::::::::::",
"::::::::::;.$:::o *:::::::::::::",
"::::::::::$ ;:::$ *:::::::::::::",
"::::::::::# ::::* ;:::::::::::::",
"::::::::::% ;:::#X::::::::::::::",
"::::::::::; %:::X&::::::::::::::",
":::::::::::*.%*++:::::::::::::::",
"::::::::::::;%#=::::::::::::::::"
};
/* XPM */
static const char *img371[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"======================&=========",
"=====================+O=========",
"====================+X==========",
"===================@X*==========",
"==================@o*===========",
"=================#.*============",
"================# &=============",
"===============#.&==============",
"==============#.&===============",
"=============#.%================",
"============$.%=================",
"===========% %==================",
"==========$.$===================",
"=========$ $====================",
"=========.$=====================",
"=========&======================"
};
/* XPM */
static const char *img372[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"---------*----------------------",
"---------.%---------------------",
"---------& $--------------------",
"----------%.%-------------------",
"-----------& %------------------",
"------------&.&-----------------",
"-------------#.&----------------",
"--------------#.*---------------",
"---------------# *--------------",
"----------------# *-------------",
"-----------------#.=------------",
"------------------@o=-----------",
"-------------------@X=----------",
"--------------------@X=---------",
"---------------------+O---------",
"----------------------*---------"
};
/* XPM */
static const char *img37greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::;*:::::==::::::::::::",
"::::::::::$  .*:;+  o;::::::::::",
"::::::::::.$*O.-@ &*O%::::::::::",
"::::::::::%:::o#.&::=%::::::::::",
"::::::::::::::$X.:::::::::::::::",
"::::::::::::::- @:::::::::::::::",
"::::::::::::::: #:::::::::::::::",
"::::::::::::::: #:::::::::::::::",
"::::::::::::::: #:::::::::::::::",
"::::::::::::::: #:::::::::::::::",
"::::::::::::::: #:::::::::::::::",
"::::::::::::::: #:::::::::::::::",
"::::::::::::*#@ X#%:::::::::::::"
};
/* XPM */
static const char *img37[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-------------------+------------",
"------------------=.------------",
"------------------O@------------",
"----------------&Oo=------------",
"----------*%$@OXX#--------------",
"----------@ooo .@=--------------",
"---------------$@ $-------------",
"-----------------*.$------------",
"------------------%o------------",
"-------------------.------------"
};
/* XPM */
static const char *img38greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::#O. oO=::::::::::::::",
":::::::::::::# :::::::::::::::::",
":::::::::::-$X @&:::::::::::::::",
"::::::::::#o*# ;#o=:::::::::::::",
":::::::::@ *:# ::O.=::::::::::::",
":::::::::  ::# ::# #::::::::::::",
":::::::::  ::# ::# #::::::::::::",
":::::::::+ =:# ::+.*::::::::::::",
":::::::::;Oo;# :%.&:::::::::::::",
":::::::::::&#o ##;::::::::::::::",
":::::::::::::# :::::::::::::::::",
":::::::::::%#o ##-::::::::::::::"
};
/* XPM */
static const char *img38[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;#=;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@#;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%X-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;#o%;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;*+oO#$&*;;;;;;;;;;;;",
";;;;;;;;;;;;;%+ OOO+;;;;;;;;;;;;",
";;;;;;;;;;;*o@$-;;;;;;;;;;;;;;;;",
";;;;;;;;;;=.%;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;##;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+&;;;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img39greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------&Oo  O@-------------",
"--------------- @---------------",
"----------O+=-- @--$O#----------",
"----------% $-- @--.+-----------",
"----------- @-- @-- @-----------",
"----------- @-- @-- @-----------",
"-----------oO-- @-& $-----------",
"-----------# =- @-+o------------",
"------------+O- @$.$------------",
"-------------$@ X@*-------------",
"--------------- @---------------",
"------------*@@ X@#-------------"
};
/* XPM */
static const char *img39[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------=@o@*----*%-----------",
"----------@X@O.$---@#-----------",
"----------X---%.O%@.=-----------",
"----------@----*+ X&------------",
"--------------------------------"
};
/* XPM */
static const char *img3greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;-#o@-;;&&;;;;;;;;;;;;",
";;;;;;;;;;-X.@ O;;O-;;;;;;;;;;;;",
";;;;;;;;;;@@;;-X=%O;;;;;;;;;;;;;",
";;;;;;;;;;#;;;;$@+*;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;-Oo;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;.%;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;; -;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;-@;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;#@;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;o%;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;o;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;O;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img3[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c gray80",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"*************#+*****************",
"************$ oO****************",
"***********# %&oO***************",
"**********#.%***o+**************",
"**********# %***X+**************",
"***********# %&oO***************",
"************$ XO****************",
"*************$@*****************"
};
/* XPM */
static const char *img40greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::::::=*;::::::::::::::",
"::::::::::::-+O%*#X%::::::::::::",
":::::::::::=.O::::* @:::::::::::",
":::::::::::o *:::::O &::::::::::",
":::::::::::  ;:::::# #::::::::::",
":::::::::::  ::::::# #::::::::::",
":::::::::::. *:::::O $::::::::::",
":::::::::::$ %:::::XX;::::::::::",
":::::::::::;oO::::* &:::::::::::",
"::::::::::::= ::::#+::::::::::::",
"::::::::::-#:@&:::o-:@::::::::::",
":::::::::::O*%@::-O*%#::::::::::",
":::::::::::X  O::*   %::::::::::"
};
/* XPM */
static const char *img40[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c #EEEEEE",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##############@+################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##############+o################",
"##########XXXX. XXXXO###########"
};
/* XPM */
static const char *img41[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::-:::::::::::",
":::::::::::::::::::: :::::::::::",
":::::::::::::::::::&+:::::::::::",
"::::::::::::::::::*X*:::::::::::",
":::::::::::::::=&+X=::::::::::::",
":::::::::::#Oo  X%;:::::::::::::",
":::::::::::::;*$Oo@:::::::::::::",
":::::::::::::::::;#X;:::::::::::",
":::::::::::::::::::##:::::::::::",
":::::::::::::::::::;.:::::::::::",
"::::::::::::::::::::%:::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::::@        X:::::::::::"
};
/* XPM */
static const char *img42[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;=;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;o$;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;#+;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;=X@;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;-+X$&;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;*+  .oO;;;;;;;;;;;;",
";;;;;;;;;;;;$Xo@&=;;;;;;;;;;;;;;",
";;;;;;;;;;;+o=;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%X-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;O#;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%-;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+        .;;;;;;;;;;;;"
};
/* XPM */
static const char *img43[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"===========$+$*====*%===========",
"==========@ O.o&===$+===========",
"==========X&=*+ +$@.&===========",
"==========+====%O X$============",
"================================",
"================================",
"================================",
"==========          #==========="
};
/* XPM */
static const char *img44[] = {
/* columns rows colors chars-per-pixel */
"32 32 3 1",
"  c #777777",
". c #BBBBBB",
"X c gray100",
/* pixels */
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX",
"XXXXXXXXXXXXXX. XXXXXXXXXXXXXXXX"
};
/* XPM */
static const char *img45[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------------%----$---------",
"---------------&Xo--$ +---------",
"-------------*O.$-&Xo&----------",
"------------# @==+ #------------",
"----------%.o&-# +*-------------",
"---------o &-=.X*---------------",
"---------o &-=.X*---------------",
"----------%.o&-# +*-------------",
"------------# +==+ #------------",
"--------------O.$-=Xo&----------",
"---------------&Xo--$ +---------",
"-----------------&----&---------"
};
/* XPM */
static const char *img46[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;%;;;-*;;;;;;;;;;;;;;;;;",
";;;;;;;;;Xo*;=X+-;;;;;;;;;;;;;;;",
";;;;;;;;;;%X@=;# #-;;;;;;;;;;;;;",
";;;;;;;;;;;-@.$;=@X&;;;;;;;;;;;;",
";;;;;;;;;;;;;*oo&;&.O=;;;;;;;;;;",
";;;;;;;;;;;;;;;&.+;;$.@;;;;;;;;;",
";;;;;;;;;;;;;;;&.+;;$.@;;;;;;;;;",
";;;;;;;;;;;;;*oo&;&.O=;;;;;;;;;;",
";;;;;;;;;;;-@.$;=+X&;;;;;;;;;;;;",
";;;;;;;;;;%X@;;# $;;;;;;;;;;;;;;",
";;;;;;;;;Xo*;=X+-;;;;;;;;;;;;;;;",
";;;;;;;;;*;;;-=;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img47[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;X*;;;;;;-O$;;;;;;;;;;;;",
";;;;;;;;;&.#=;;-%.#;;;;;;;;;;;;;",
";;;;;;;;;;-@.oO +*;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-@.oO +*;;;;;;;;;;;;;;",
";;;;;;;;;%.#=;;-%.@;;;;;;;;;;;;;",
";;;;;;;;;X*;;;;;;;O$;;;;;;;;;;;;"
};
/* XPM */
static const char *img48[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c #444444",
". c #777777",
"X c #BBBBBB",
"o c gray80",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO oOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO XOOOOOOOOOOOOOO",
"OOOOOOOOOOOOX.OO oOOOOOOOOOOOOOO"
};
/* XPM */
static const char *img49[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&%oXXXXXo&&&&&&&&&&&&",
"&&&&&&&&&&&@.+%&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&% $&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&X@&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&X@&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&% $&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&#.+%&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&%oXXXXXo&&&&&&&&&&&&"
};
/* XPM */
static const char *img4greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=$&;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;%@#.o;;;;;;;;;;;;;;",
";;;;;;;;;;;;;@*;-=;;;;;;;;;;;;;;",
";;;;;;;;;;;;;#o;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;-.@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;*X *;;;;;;;;;;;;;;;",
";;;;;;;;;;;;@+=X@;;;;;;;;;;;;;;;",
";;;;;;;;;;;#.-;Oo;;;;;;;;;;;;;;;",
";;;;;;;;;;;.@;;@o;;;;;;;;;;;;;;;",
";;;;;;;;;;= *;;@O;;;;;;;;;;;;;;;",
";;;;;;;;;;& ;;;o@;;;;;;;;;;;;;;;",
";;;;;;;;;;- =;*.-;;;;;;;;;;;;;;;",
";;;;;;;;;;;#o&o*;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-&;;;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img4[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c gray40",
". c #777777",
"X c gray60",
"o c #AAAAAA",
"O c #BBBBBB",
"+ c gray80",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+O#$$$$$$$$$$$$$$$",
"$$$$$$$$$$$#..o ..@$$$$$$$$$$$$$",
"$$$$$$$$$$# @$$.$$.+$$$$$$$$$$$$",
"$$$$$$$$$$.+$$$.$$$ $$$$$$$$$$$$",
"$$$$$$$$$$.$$$$.$$$XO$$$$$$$$$$$",
"$$$$$$$$$$ OOOO OOOO.$$$$$$$$$$$",
"$$$$$$$$$$ OOOO OOOO.$$$$$$$$$$$",
"$$$$$$$$$$.$$$$.$$$XO$$$$$$$$$$$",
"$$$$$$$$$$.O$$$.$$$ $$$$$$$$$$$$",
"$$$$$$$$$$# @$$.$$.+$$$$$$$$$$$$",
"$$$$$$$$$$$#..o ..@$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+O#$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img50[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c gray40",
"+ c #777777",
"@ c gray60",
"# c #BBBBBB",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%+oooooo#%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%$@oO%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%$X@%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%#o%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%% %%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%#o%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%$.@%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%$@o+%%%%%%%%%%%%",
"%%%%%%%%%%%+oooooo#%%%%%%%%%%%%%"
};
/* XPM */
static const char *img51[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::;$O#-::::-&::::::::::::",
":::::::::@X#O.%:::$$::::::::::::",
":::::::::O;::*.+##.;::::::::::::",
":::::::::%::::;@O+=:::::::::::::",
":::::::::;+ O=::::=$::::::::::::",
":::::::::O+##.#;::#%::::::::::::",
":::::::::+:::=oX#Oo;::::::::::::",
":::::::::%:::::%O#;:::::::::::::"
};
/* XPM */
static const char *img52[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c #0B0B0B",
". c #111111",
"X c #222222",
"o c gray16",
"O c gray23",
"+ c #444444",
"@ c #555555",
"# c gray35",
"$ c #777777",
"% c #888888",
"& c gray60",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
":::::::::%@-:::::::=+*::::::::::",
":::::::::$@.%;:::-$X@*::::::::::",
":::::::::$$;$X&:%.$;$*::::::::::",
":::::::::$$::-+ #;::$*::::::::::",
":::::::::$$::-o O;::$*::::::::::",
":::::::::$$;$X&:%.$;$*::::::::::",
":::::::::$+.%;:::-$X+*::::::::::",
":::::::::%@-:::::::-+*::::::::::"
};
/* XPM */
static const char *img53[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;=****=;;;;;;;;;;;;",
";;;;;;;;;;;;#.XOOOO+;;;;;;;;;;;;",
";;;;;;;;;;;@O-;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;&X-;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@#;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;O*;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;+$;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;%O;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-o#;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;-OO#####$;;;;;;;;;;;;",
";;;;;;;;;;;;;=$####$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;*        X;;;;;;;;;;;;"
};
/* XPM */
static const char *img54[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------*%%%%%=---------------",
"----------#OOOOo +=-------------",
"-----------------#o=------------",
"------------------@#------------",
"------------------=X------------",
"------------------- ------------",
"-------------------.------------",
"------------------#@------------",
"-----------------&X&------------",
"----------$#####@.%-------------",
"----------$#####$---------------",
"--------------------------------",
"--------------------------------",
"----------@        #------------"
};
/* XPM */
static const char *img55[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------=@o@*----*%-----------",
"----------@X@O.$---@#-----------",
"----------X---%.O%@.=-----------",
"----------@----*+ X&------------",
"----------&&&&&&&&&&=-----------",
"----------oooooooooo%-----------",
"--------------------------------",
"--------------------------------",
"----------oooooooooo%-----------",
"----------&&&&&&&&&&=-----------"
};
/* XPM */
static const char *img56[] = {
/* columns rows colors chars-per-pixel */
"32 32 23 1",
"  c gray4",
". c gray5",
"X c #111111",
"o c gray9",
"O c #222222",
"+ c #252525",
"@ c #373737",
"# c #3F3F3F",
"$ c gray25",
"% c #444444",
"& c #555555",
"* c #585858",
"= c gray40",
"- c #777777",
"; c #888888",
": c gray59",
"> c gray60",
", c #AAAAAA",
"< c #AFAFAF",
"1 c #BBBBBB",
"2 c #DDDDDD",
"3 c #EEEEEE",
"4 c gray100",
/* pixels */
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"44444444444444444444444444444444",
"444444444444444444,3444444444444",
"444444444444444442O3444444444444",
"44444444444444444-=4444444444444",
"44444444444444442X34444444444444",
"4444444444444444&-44444444444444",
"444444444411111:.<11344444444444",
"4444444444%%%%%o+%%%,44444444444",
"444444444444442X3444444444444444",
"44444444444444&;4444444444444444",
"4444444444%%%@ $%%%%,44444444444",
"4444444444111#*11111344444444444",
"4444444444441O444444444444444444",
"444444444444%,444444444444444444",
"44444444444,O4444444444444444444",
"44444444444%>4444444444444444444",
"44444444444>34444444444444444444"
};
/* XPM */
static const char *img57[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"========O===========*+==========",
"========$O*========%o*==========",
"=========%X@&====%OO*===========",
"===========#@.  X@%============="
};
/* XPM */
static const char *img58[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #222222",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&%#########%&&&&&&&&&&&",
"&&&&&&&&&&O.XXXXXXXX@&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OO&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&OXOOOOOOOO$&&&&&&&&&&&",
"&&&&&&&&&&$OOOOOOOOO$&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&o         +&&&&&&&&&&&"
};
/* XPM */
static const char *img59[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c black",
". c #222222",
"X c #444444",
"o c #777777",
"O c #AAAAAA",
"+ c #BBBBBB",
"@ c #DDDDDD",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##########+++++++++@############",
"##########XXXXXXXXXX############",
"###################X############",
"###################X############",
"###################X############",
"###################X############",
"###################X############",
"###################X############",
"###################X############",
"##########oooooooooX############",
"##########oooooooooO############",
"################################",
"################################",
"##########         .############"
};
/* XPM */
static const char *img5greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c gray20",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==============%+O$==============",
"============*O.$$&==============",
"============o &=================",
"===========* .OO@===============",
"===========$ O$$&===============",
"===========$ $==================",
"===========* +==================",
"============$.#+X&==============",
"==============$%================"
};
/* XPM */
static const char *img5[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%          +%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%ooooX.oooo@%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%#O%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%$#%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img60[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #444444",
"X c #555555",
"o c gray40",
"O c #888888",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&Oo$&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&X #&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&@@@@@@@@@@%&&&&&&&&&&&",
"&&&&&&&&&&..........+&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&..........+&&&&&&&&&&&",
"&&&&&&&&&&@@@@@@@@@@%&&&&&&&&&&&"
};
/* XPM */
static const char *img61[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==============*%%===============",
"===========*@X.XX O#============",
"==========%o$======+o*==========",
"=========%O*========&X*=========",
"=========o===========*O========="
};
/* XPM */
static const char *img62[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c black",
". c #111111",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"*************%oXXXX*************",
"************@.+&****************",
"***********% $******************",
"***********OO*******************",
"***********XoOOOOOO*************",
"***********XoOOOOOO*************",
"***********OO*******************",
"***********% $******************",
"************#.+&****************",
"*************%oXXXX*************"
};
/* XPM */
static const char *img63[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #111111",
". c #444444",
"X c #555555",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c #EEEEEE",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%O....@%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%#Xo$%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%$X+%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%# %%%%%%%%%%%%%",
"%%%%%%%%%%%@OOOOOO %%%%%%%%%%%%%",
"%%%%%%%%%%%@OOOOOO %%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%# %%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%$.+%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%#Xo%%%%%%%%%%%%%%",
"%%%%%%%%%%%O....@%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img64[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;&=;;;;;&=;;;;;;;;;;;;",
";;;;;;;;;-+O.#-;=O#&;;;;;;;;;;;;",
";;;;;;;;;+*;=XO*o=;;;;;;;;;;;;;;",
";;;;;;;;;#;;;* X&;;;;;;;;;;;;;;;",
";;;;;;;;;#;;;;# =;;;;;;;;;;;;;;;",
";;;;;;;;;#;;;;# O;;;;;;;;;;;;;;;",
";;;;;;;;;@-;;%+% $;;;;;;;;;;;;;;",
";;;;;;;;;=+##+-;&.@&;;;;;;;;;;;;",
";;;;;;;;;;;&=;;;;;&=;;;;;;;;;;;;"
};
/* XPM */
static const char *img65[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c black",
". c #444444",
"X c gray40",
"o c #DDDDDD",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOoOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO       XOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOO.OOOOOOOOOOOOOOOOOOOO"
};
/* XPM */
static const char *img66[] = {
/* columns rows colors chars-per-pixel */
"32 32 5 1",
"  c black",
". c #444444",
"X c #BBBBBB",
"o c #DDDDDD",
"O c gray100",
/* pixels */
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOOoOOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOO       .OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO",
"OOOOOOOOOOOOOOOOX.OOOOOOOOOOOOOO"
};
/* XPM */
static const char *img67[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"*****************+o*************",
"**************&@ +%*************",
"************&# +%***************",
"**********&@ +%*****************",
"*********#XO&*******************",
"*********#.o&*******************",
"**********&@ +%*****************",
"************&# +$***************",
"***************@ +%*************",
"*****************+o*************"
};
/* XPM */
static const char *img68[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c gray80",
"$ c #DDDDDD",
"% c #EEEEEE",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&Oo%&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&%+.O#&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&%@ O$&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&%+ O$&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&+XO&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&+.O&&&&&&&&&&&&",
"&&&&&&&&&&&&&&%+ O$&&&&&&&&&&&&&",
"&&&&&&&&&&&&%+ O$&&&&&&&&&&&&&&&",
"&&&&&&&&&&%+.O%&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&Oo%&&&&&&&&&&&&&&&&&&&"
};
/* XPM */
static const char *img69[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::  OOOOOOOo   +::::::::::",
"::::::::# $:::::::;%O.;:::::::::",
"::::::::;o -:::::::::@%:::::::::",
":::::::::-.o::::::::::#:::::::::",
"::::::::::& @:::::::::::::::::::",
":::::::::::@ &::::::::::::::::::",
"::::::::::::o.-:::::::::::::::::",
"::::::::::::- o;::::::::::::::::",
":::::::::::::+O;::::::::::::::::",
"::::::::::::&X;:::::::::::::::::",
":::::::::::;X=::::::::::::::::::",
"::::::::::;o%:::::::::-:::::::::",
"::::::::::+#:::::::::;#:::::::::",
":::::::::$o:::::::::;o&:::::::::",
"::::::::*X-:::::::*@.X::::::::::",
"::::::::.            @::::::::::"
};
/* XPM */
static const char *img6greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;*+. @-;;;;;;;;;;;;;",
";;;;;;;;;;;;&o&;-$=;;;;;;;;;;;;;",
";;;;;;;;;;;;O&;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;$oOo&;;;;;;;;;;;;;;;",
";;;;;;;;;;;;o%$%;;;;;;;;;;;;;;;;",
";;;;;;;;;;;#$;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;@$;;;-&;;;;;;;;;;;;;;",
";;;;;;;;;;;=X@@@O-;;;;;;;;;;;;;;",
";;;;;;;;;;;;-#@&;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img6[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #111111",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c gray60",
"@ c #BBBBBB",
"# c gray80",
"$ c #DDDDDD",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%$+%%%%%%$O%%%%%%%%%%%%",
"%%%%%%%%%%@O%%%%%%@X%%%%%%%%%%%%",
"%%%%%%%%%%@O%%%%%%@X%%%%%%%%%%%%",
"%%%%%%%%%%@O%%%%%%@X%%%%%%%%%%%%",
"%%%%%%%%%%@O%%%%%%@X%%%%%%%%%%%%",
"%%%%%%%%%%@O%%%%%%@X%%%%%%%%%%%%",
"%%%%%%%%%%@O%%%%%%@X%%%%%%%%%%%%",
"%%%%%%%%%%@o%%%%%%+X%%%%%%%%%%%%",
"%%%%%%%%%%% +%%%%#.@%%%%%%%%%%%%",
"%%%%%%%%%%%$.XOOO +%%%%%%%%%%%%%",
"%%%%%%%%%%%%%$OO+%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img70[] = {
/* columns rows colors chars-per-pixel */
"32 32 11 1",
"  c black",
". c #111111",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c gray100",
/* pixels */
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&",
"&&&&&&&&&&&%o. .X%&&&&&&&&&&&&&&",
"&&&&&&&&&&# o+$@o @&&&&&&&&&&&&&",
"&&&&&&&&&$ O&&&&&+ #&&&&&&&&&&&&",
"&&&&&&&&&Xo&&&&&&&oX&&&&&&&&&&&&",
"&&&&&&&&& +&&&&&&&% %&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& $&&&&&&&& $&&&&&&&&&&&",
"&&&&&&&&& %&&&&&&&& %&&&&&&&&&&&"
};
/* XPM */
static const char *img71[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::&OX  O@;::::::::::::",
"::::::::::-o.@$*&#o $:::::::::::",
":::::::::;oo*:::::;# %::::::::::",
":::::::::Oo;::::::::% *:::::::::",
"::::::::& =::::::::::+O:::::::::",
"::::::::O@:::::::::::- =::::::::",
":::::::: #:::::*-::::: &::::::::",
":::::::: *::::$ O:::::O#::::::::",
":::::::: *::::$ O:::::O#::::::::",
":::::::: #:::::::::::: &::::::::",
"::::::::O@:::::::::::- =::::::::",
"::::::::& *::::::::::O+:::::::::",
":::::::::+o;::::::::$ =:::::::::",
":::::::::;oo*:::::;# %::::::::::",
"::::::::::;+.O$*&@oX%:::::::::::",
"::::::::::::&#X  +#;::::::::::::"
};
/* XPM */
static const char *img72[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c #888888",
"@ c #BBBBBB",
"# c gray80",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$.  XXXXXX.  X$$$$$$$$$$",
"$$$$$$$$$$o $$$$$$@ +$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$O $$$$$$@ @$$$$$$$$$$$",
"$$$$$$$$$$o #$$$$$+ +$$$$$$$$$$$",
"$$$$$$$$$    X$$$X    $$$$$$$$$$"
};
/* XPM */
static const char *img73[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------- *-------- *-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- #-------& =-----------",
"---------oO-------Oo------------",
"---------* +-----@ %------------",
"----------&.X#&$X.%-------------",
"-----------*@. .@*--------------"
};
/* XPM */
static const char *img74[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::&OX  O@;::::::::::::",
"::::::::::-o.@$*&#o $:::::::::::",
":::::::::;oX*:::::;# %::::::::::",
":::::::::O..&:::::;O. *:::::::::",
"::::::::& =#.&::::OX;+O:::::::::",
"::::::::O@::#.*::OX-:- =::::::::",
":::::::: #:::# %Oo=::: &::::::::",
":::::::: *::::# X-::::O#::::::::",
":::::::: *::::@ X=::::O#::::::::",
":::::::: #:::@.*+X=::: &::::::::",
"::::::::O@::#.=::+.-:- =::::::::",
"::::::::& *@.*::::+.-O+:::::::::",
":::::::::+..*:::::;+. =:::::::::",
":::::::::;oo*:::::;# %::::::::::",
"::::::::::;+.O$*&@oX%:::::::::::",
"::::::::::::&#X  +#;::::::::::::"
};
/* XPM */
static const char *img75[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c #BBBBBB",
"$ c gray80",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%X  .+%%%+   o%%%%%%%%%%",
"%%%%%%%%%%O $%%%%%@ @%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%+ %%%%%%# #%%%%%%%%%%%",
"%%%%%%%%%%O %%%%%%# @%%%%%%%%%%%",
"%%%%%%%%%             %%%%%%%%%%"
};
/* XPM */
static const char *img76[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c black",
". c #111111",
"X c #888888",
"o c #BBBBBB",
"O c gray80",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"+++++++++ O++++++++ O+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ o++++++++ o+++++++++++",
"+++++++++ Xoooooooo o+++++++++++",
"+++++++++.          O+++++++++++"
};
/* XPM */
static const char *img77[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::&OX  O@;::::::::::::",
"::::::::::-o.@$o+#o $:::::::::::",
":::::::::;oo*::O#:;# %::::::::::",
":::::::::Oo;:::O#:::% *:::::::::",
"::::::::& =::::O#::::+O:::::::::",
"::::::::O@:::::O#::::- =::::::::",
":::::::: #:::::O#::::: &::::::::",
":::::::: oOOOOO.XOOOOO.#::::::::",
":::::::: @#####XO#####X#::::::::",
":::::::: #:::::O#::::: &::::::::",
"::::::::O@:::::O#::::- =::::::::",
"::::::::& *::::O#::::O+:::::::::",
":::::::::+o;:::O#:::$ =:::::::::",
":::::::::;oo*::O#:;# %::::::::::",
"::::::::::;+.O$o+@oX%:::::::::::",
"::::::::::::&#X  +#;::::::::::::"
};
/* XPM */
static const char *img78[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::##@&::::::::::::",
":::::::::::::::*o:OO::::::::::::",
":::::::::::::::+#:-;::::::::::::",
":::::::::::::::O#:::::::::::::::",
":::::::::::::::X#:::::::::::::::",
"::::::::::::::: %:::::::::::::::",
"::::::::::::::* *:::::::::::::::",
"::::::::::::::& *:::::::::::::::",
"::::::::::::::# ::::::::::::::::",
"::::::::::::::#.::::::::::::::::",
"::::::::::::::OO::::::::::::::::",
"::::::::::::::OO::::::::::::::::",
"::::::::::::::OO::::::::::::::::",
"::::::::::::::O#::::::::::::::::",
"::::::::::::::X%::::::::::::::::",
"::::::::::;$;; -::::::::::::::::",
"::::::::::=.=#@:::::::::::::::::",
":::::::::::$##;:::::::::::::::::"
};
/* XPM */
static const char *img79[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;; &;;;;;;;-.*;;;;;;;;;;;",
";;;;;;;;;X#;;;;;;;#X;;;;;;;;;;;;",
";;;;;;;;;#X;;;;;;;X#;;;;;;;;;;;;",
";;;;;;;;;& &;;;;;= %;;;;;;;;;;;;",
";;;;;;;;;;X#;;;;;#X;;;;;;;;;;;;;",
";;;;;;;;;;$.;;;;;O#;;;;;;;;;;;;;",
";;;;;;;;;;* =;;;= &;;;;;;;;;;;;;",
";;;;;;;;;;;o@;;;#o;;;;;;;;;;;;;;",
";;;;;;;;;;;#X;;;X#;;;;;;;;;;;;;;",
";;;;;;;;;;;= &;& =;;;;;;;;;;;;;;",
";;;;;;;;;;;;O+;#X;;;;;;;;;;;;;;;",
";;;;;;;;;;;;#X;X#;;;;;;;;;;;;;;;",
";;;;;;;;;;;;- @ &;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;O.X;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;$ $;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;-.*;;;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img7greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::O:::::::::::::::",
":::::::::::::::-.O+:::::::::::::",
"::::::::::::::&+-*-:::::::::::::",
":::::::::::::-O:::::::::::::::::",
"::::::::::::;o-:::::::::::::::::",
"::::::::::::$#::::::::::::::::::",
"::::::::::::X=::::::::::::::::::",
":::::::::::;o:::::::::::::::::::",
":::::::::::*#:::::::::::::::::::",
":::::::::::*o:::::::::::::::::::",
":::::::::::- %::::::::::::::::::",
"::::::::::::@ o$-:::::::::::::::",
":::::::::::::=@X.&::::::::::::::",
"::::::::::::::::O#::::::::::::::",
":::::::::::::;=:@%::::::::::::::",
"::::::::::::::%#%:::::::::::::::"
};
/* XPM */
static const char *img7[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;*&;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;o.=;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;%o@#;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;o%=.-;;;;;;;;;;;;;;",
";;;;;;;;;;;;$o;;#@;;;;;;;;;;;;;;",
";;;;;;;;;;;-X*;;-X*;;;;;;;;;;;;;",
";;;;;;;;;;;$+;;;;#@;;;;;;;;;;;;;",
";;;;;;;;;;=.=;;;;;.%;;;;;;;;;;;;",
";;;;;;;;;;##;;;;;;%O;;;;;;;;;;;;",
";;;;;;;;;= =;;;;;;;X%;;;;;;;;;;;",
";;;;;;;;;+#;;;;;;;;%X;;;;;;;;;;;",
";;;;;;;;; oOOOOOOOOO *;;;;;;;;;;"
};
/* XPM */
static const char *img80[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------- *-------- *-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &-------- &-----------",
"--------- &---o=--- &-----------",
"--------- &--- &--- &-----------",
"--------- &=&& #&=- &-----------",
"--------- &O     o- &-----------",
"--------- &=&& #&*- &-----------",
"--------- &--- &--- &-----------",
"--------- &---o=--- &-----------",
"--------- #-------& =-----------",
"---------oO-------Oo------------",
"---------* +-----@ %------------",
"----------&.X#&$X.%-------------",
"-----------*@. .@*--------------"
};
/* XPM */
static const char *img81[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::##@&::::::::::::",
":::::::::::::::*o:OO::::::::::::",
":::::::::::::::+#:-;::::::::::::",
":::::::::::::::O#:::::::::::::::",
":::::::::::::::X#:::::::::::::::",
"::::::::::::::= %:::::::::::::::",
"::::::::::::;oo .$::::::::::::::",
"::::::::::::##& &.=:::::::::::::",
"::::::::::::O*# :#*:::::::::::::",
"::::::::::::+&#.:O*:::::::::::::",
"::::::::::::*.oO#o;:::::::::::::",
":::::::::::::&X.#;::::::::::::::",
"::::::::::::::OO::::::::::::::::",
"::::::::::::::O#::::::::::::::::",
"::::::::::::::X%::::::::::::::::",
"::::::::::;$;; -::::::::::::::::",
"::::::::::=.=#@:::::::::::::::::",
":::::::::::$##;:::::::::::::::::"
};
/* XPM */
static const char *img82[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;-.*;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;# #;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;O.X;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;= # &;;;;;;;;;;;;;;",
";;;;;;;;;;;;;#X;X#;;;;;;;;;;;;;;",
";;;;;;;;;;;;;O+;#.;;;;;;;;;;;;;;",
";;;;;;;;;;;;= &;& =;;;;;;;;;;;;;",
";;;;;;;;;;;;#o;;;o@;;;;;;;;;;;;;",
";;;;;;;;;;;;X#;;;#X;;;;;;;;;;;;;",
";;;;;;;;;;;* =;;;= &;;;;;;;;;;;;",
";;;;;;;;;;;$X;;;;;O#;;;;;;;;;;;;",
";;;;;;;;;;;X#;;;;;#X;;;;;;;;;;;;",
";;;;;;;;;;& &;;;;;- %;;;;;;;;;;;",
";;;;;;;;;;#X;;;;;;;X#;;;;;;;;;;;",
";;;;;;;;;;.#;;;;;;;$.;;;;;;;;;;;",
";;;;;;;;;; *;;;;;;;-.*;;;;;;;;;;"
};
/* XPM */
static const char *img83[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*+o;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*+o&;;;;;;;;;;;;;",
";;;;;;;;;;;;;*Oo%;;;;;;;;;;;;;;;",
";;;;;;;;;;;*+o&;;;;;;;;;;;;;;;;;",
";;;;;;;;;;# %;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;-@o#;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;=+X$;;;;;;;;;;;;;;;;",
";;;;;;;;;;*=;;=#.$-;;;;;;;;;;;;;",
";;;;;;;;;;%.#-;;=#.$;;;;;;;;;;;;",
";;;;;;;;;;;-#.$-;;-$;;;;;;;;;;;;",
";;;;;;;;;;;;;-#o#-;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;-#.#=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;=#X;;;;;;;;;;;;"
};
/* XPM */
static const char *img84[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c gray40",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------*--------------------",
"-----------+ @------------------",
"------------&o.$----------------",
"--------------%O $=-------------",
"----------------&o $------------",
"------------------& .-----------",
"-----------------$.o&-----------",
"---------------% .%-------------",
"-------------$.X$---%-----------",
"-----------$XX&---#.O-----------",
"-----------$&---#.X*------------",
"--------------$.o&--------------",
"-----------=$ O%----------------",
"-----------Oo%------------------"
};
/* XPM */
static const char *img85[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-------------------*+-----------",
"-----------------&Oo -----------",
"---------------&OX%- -----------",
"-------------&+.$=-- -----------",
"-----------&Oo%----- -----------",
"-----------@ #------ -----------",
"------------&+.$=--- -----------",
"--------------&@X#=- -----------",
"----------------=OX# -----------",
"------------------*O.-----------"
};
/* XPM */
static const char *img86[] = {
/* columns rows colors chars-per-pixel */
"32 32 10 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c #555555",
"O c #777777",
"+ c gray60",
"@ c #AAAAAA",
"# c #BBBBBB",
"$ c gray80",
"% c gray100",
/* pixels */
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%O@%%%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X. @%%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X#$X.@%%%%%%%%%%%%%%%",
"%%%%%%%%%%%X#%%$XX+%%%%%%%%%%%%%",
"%%%%%%%%%%%X#%%%%$o.@%%%%%%%%%%%",
"%%%%%%%%%%%X#%%%%%$ X%%%%%%%%%%%",
"%%%%%%%%%%%X#%%%@.X@%%%%%%%%%%%%",
"%%%%%%%%%%%X#%@X.@%%%%%%%%%%%%%%",
"%%%%%%%%%%%XOo.#%%%%%%%%%%%%%%%%",
"%%%%%%%%%%%o.#%%%%%%%%%%%%%%%%%%"
};
/* XPM */
static const char *img87[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;=;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;*+ ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;*+o& ;;;;;;;;;;;;",
";;;;;;;;;;;;;*Oo%;; ;;;;;;;;;;;;",
";;;;;;;;;;;*+o&;;;; ;;;;;;;;;;;;",
";;;;;;;;;;# %;;;;;; ;;;;;;;;;;;;",
";;;;;;;;;;-@o#;;;;; ;;;;;;;;;;;;",
";;;;;;;;;;;;=+X$;;; ;;;;;;;;;;;;",
";;;;;;;;;;;;;;=#.$- ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;=#. ;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;-$;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;@        X;;;;;;;;;;;;"
};
/* XPM */
static const char *img88[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #888888",
"# c #AAAAAA",
"$ c #BBBBBB",
"% c gray80",
"& c #DDDDDD",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========&=====================",
"==========o.@===================",
"==========o@OX#=================",
"==========o$=$+.#*==============",
"==========o$===%O.#=============",
"==========o$=====%.X============",
"==========o$====#XO%============",
"==========o$==$.X$==============",
"==========o$#Xo#================",
"==========o.o%==================",
"==========#%====================",
"================================",
"================================",
"==========+        .============"
};
/* XPM */
static const char *img89[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c #040404",
". c gray2",
"X c gray4",
"o c #0B0B0B",
"O c #222222",
"+ c gray22",
"@ c gray23",
"# c gray25",
"$ c #444444",
"% c #494949",
"& c gray36",
"* c gray52",
"= c #BBBBBB",
"- c #C0C0C0",
"; c #DFDFDF",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::O%::::-o::::::::::::::",
"::::::::::# &::-oo::::::::::::::",
"::::::::::$* %-o+$::::::::::::::",
"::::::::::$=;o &:$::::::::::::::",
"::::::::::$=;  %:$::::::::::::::",
"::::::::::$* %-o+$::::::::::::::",
"::::::::::+ &::-oo::::::::::::::",
"::::::::::O&::::;o::::::::::::::"
};
/* XPM */
static const char *img8greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"------------@+&*@++=------------",
"-----------*+%.O=-X#------------",
"-----------+$+ =--X+------------",
"-----------&=X+--* %------------",
"------------* %--% &------------",
"------------% *--+.-------------",
"------------+X---.+-------------",
"------------.+--- %-------------",
"------------*=--& &-------------",
"----------------+.--------------",
"----------------o+--------------",
"----------------o$--------------"
};
/* XPM */
static const char *img8[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c gray40",
". c #777777",
"X c gray60",
"o c #AAAAAA",
"O c #BBBBBB",
"+ c gray80",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+O#$$$$$$$$$$$$$$$",
"$$$$$$$$$$$#..oO..@$$$$$$$$$$$$$",
"$$$$$$$$$$# @$$$$$.+$$$$$$$$$$$$",
"$$$$$$$$$$.+$$$$$$$ $$$$$$$$$$$$",
"$$$$$$$$$$.$$$$$$$$XO$$$$$$$$$$$",
"$$$$$$$$$$ OOOOOOOOO.$$$$$$$$$$$",
"$$$$$$$$$$ OOOOOOOOO.$$$$$$$$$$$",
"$$$$$$$$$$.$$$$$$$$XO$$$$$$$$$$$",
"$$$$$$$$$$.O$$$$$$$ $$$$$$$$$$$$",
"$$$$$$$$$$# @$$$$$.+$$$$$$$$$$$$",
"$$$$$$$$$$$#..oO..@$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$+O#$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img90[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c gray20",
". c #444444",
"X c #555555",
"o c #777777",
"O c #888888",
"+ c #BBBBBB",
"@ c gray80",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##########o........X############",
"##########.O+++++++@############",
"##########.+####################",
"##########.+####################",
"##########.+####################",
"##########.+####################",
"##########.+####################",
"##########.+####################",
"##########.+####################",
"##########X .......X############"
};
/* XPM */
static const char *img91[] = {
/* columns rows colors chars-per-pixel */
"32 32 8 1",
"  c #222222",
". c #444444",
"X c gray40",
"o c #777777",
"O c #888888",
"+ c #AAAAAA",
"@ c #BBBBBB",
"# c gray100",
/* pixels */
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"################################",
"##########..........+###########",
"##########@@@@@@@@@Xo###########",
"###################oo###########",
"###################oo###########",
"###################oo###########",
"###################oo###########",
"###################oo###########",
"###################oo###########",
"###################oo###########",
"##########......... O###########"
};
/* XPM */
static const char *img92[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c black",
". c #222222",
"X c #444444",
"o c #777777",
"O c #888888",
"+ c #BBBBBB",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$@O#$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$X +$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$@O#$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$@$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$ooooo.oooo+$$$$$$$$$$$",
"$$$$$$$$$$ooooo.oooo+$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$X$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$@$$$$$$$$$$$$$$$$"
};
/* XPM */
static const char *img93[] = {
/* columns rows colors chars-per-pixel */
"32 32 12 1",
"  c #222222",
". c gray20",
"X c #444444",
"o c gray40",
"O c #777777",
"+ c #888888",
"@ c gray60",
"# c #AAAAAA",
"$ c gray80",
"% c #DDDDDD",
"& c #EEEEEE",
"* c gray100",
/* pixels */
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"********************************",
"**********oO&*******************",
"**********&oX%******************",
"************@ @*****************",
"*************$.o****************",
"***************o.%**************",
"****************+ #*************",
"*****************% O************",
"*******************@************"
};
/* XPM */
static const char *img94[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c black",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-$oo+=;;;;;;;;;;;;;;",
";;;;;;;;;;;&XO%&@.@;;;;;;;;;;;;;",
";;;;;;;;;;- &;;;;-o#;;;;;;;;;;;;",
";;;;;;;;;;&@;*. $;%o;;;;;;;;;;;;",
";;;;;;;;;;&@;@#- ;&o;;;;;;;;;;;;",
";;;;;;;;;;&@;@&; ;&o;;;;;;;;;;;;",
";;;;;;;;;;&@;@&; ;&o;;;;;;;;;;;;",
";;;;;;;;;;&@;@&; ;&o;;;;;;;;;;;;",
";;;;;;;;;;&@;@&; ;&o;;;;;;;;;;;;",
";;;;;;;;;;&@;@&; ;&o;;;;;;;;;;;;",
";;;;;;;;;;-&;&-;$;-%;;;;;;;;;;;;"
};
/* XPM */
static const char *img95[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"----------*#-#*-+-*@------------",
"----------%@-@%- -%o------------",
"----------%@-@%- -%o------------",
"----------%@-@%- -%o------------",
"----------%@-@%- -%o------------",
"----------%@-@%- -%o------------",
"----------%@-@@=.-%o------------",
"----------%O-&Oo$-#o------------",
"-----------.#----&X%------------",
"-----------*Xo@@@.#-------------",
"-------------*@@#---------------"
};
/* XPM */
static const char *img96[] = {
/* columns rows colors chars-per-pixel */
"32 32 13 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c #777777",
"@ c #888888",
"# c gray60",
"$ c #AAAAAA",
"% c #BBBBBB",
"& c gray80",
"* c #EEEEEE",
"= c gray100",
/* pixels */
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"================================",
"==========+++++++$==============",
"==========%%%%%%%&==============",
"================================",
"================================",
"=============X+=================",
"============#..=================",
"============O$o#================",
"===========& =%X================",
"===========o#==X$===============",
"==========%.*==$X===============",
"==========O+===*.$==============",
"========== *====@O=============="
};
/* XPM */
static const char *img97[] = {
/* columns rows colors chars-per-pixel */
"32 32 14 1",
"  c black",
". c #111111",
"X c #222222",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c gray80",
"* c #DDDDDD",
"= c #EEEEEE",
"- c gray100",
/* pixels */
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"--------------------------------",
"-----------$-----*%-------------",
"-----------.%----+@-------------",
"-----------$O---& *-------------",
"-----------*.&--@@--------------",
"------------#O-= *--------------",
"------------=.=@@---------------",
"-------------@+X&---------------",
"-------------*.O----------------",
"--------------@&----------------",
"--------------------------------",
"--------------------------------",
"-----------ooooooo@-------------"
};
/* XPM */
static const char *img98[] = {
/* columns rows colors chars-per-pixel */
"32 32 15 1",
"  c #111111",
". c #222222",
"X c gray20",
"o c #444444",
"O c #555555",
"+ c gray40",
"@ c #777777",
"# c #888888",
"$ c gray60",
"% c #AAAAAA",
"& c #BBBBBB",
"* c gray80",
"= c #DDDDDD",
"- c #EEEEEE",
"; c gray100",
/* pixels */
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;&&&&&&&=;;;;;;;;;;;;;;",
";;;;;;;;;;@@@@@@@$;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;ooooooo@;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;;*-;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;-.+;;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;#o.-;;;;;;;;;;;;;;;;",
";;;;;;;;;;;;.&O@;;;;;;;;;;;;;;;;",
";;;;;;;;;;;%X;= -;;;;;;;;;;;;;;;",
";;;;;;;;;;-.%;;O#;;;;;;;;;;;;;;;",
";;;;;;;;;;%X;;;&.-;;;;;;;;;;;;;;",
";;;;;;;;;;X#;;;;o$;;;;;;;;;;;;;;",
";;;;;;;;;;+;;;;;&@;;;;;;;;;;;;;;"
};
/* XPM */
static const char *img99[] = {
/* columns rows colors chars-per-pixel */
"32 32 6 1",
"  c #111111",
". c #222222",
"X c #444444",
"o c #777777",
"O c #AAAAAA",
"+ c gray100",
/* pixels */
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++++++++++++++++++++++++",
"++++++++++XXXXXXXXXXO+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++ XXXXXXXX.o+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++X++++++++oo+++++++++++",
"++++++++++ XXXXXXXX.o+++++++++++"
};
/* XPM */
static const char *img9greek[] = {
/* columns rows colors chars-per-pixel */
"32 32 16 1",
"  c black",
". c #111111",
"X c #222222",
"o c gray20",
"O c #444444",
"+ c #555555",
"@ c gray40",
"# c #777777",
"$ c #888888",
"% c gray60",
"& c #AAAAAA",
"* c #BBBBBB",
"= c gray80",
"- c #DDDDDD",
"; c #EEEEEE",
": c gray100",
/* pixels */
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::::::::::::::::::",
"::::::::::::::::=-::::::::::::::",
"::::::::::::::=o%O&:::::::::::::",
":::::::::::::-.&:&X:::::::::::::",
":::::::::::::oO::* =::::::::::::",
"::::::::::::& &::% *::::::::::::",
"::::::::::::O ;::@ -::::::::::::",
":::::::::::: o***.X:::::::::::::",
":::::::::::= @**& #:::::::::::::",
":::::::::::$ &::% *:::::::::::::",
":::::::::::# :::Oo::::::::::::::",
":::::::::::$ ::= &::::::::::::::",
":::::::::::- ::O+:::::::::::::::",
"::::::::::::o#@@::::::::::::::::",
":::::::::::::=-:::::::::::::::::"
};
/* XPM */
static const char *img9[] = {
/* columns rows colors chars-per-pixel */
"32 32 9 1",
"  c #222222",
". c gray20",
"X c gray40",
"o c #777777",
"O c #888888",
"+ c gray60",
"@ c #DDDDDD",
"# c #EEEEEE",
"$ c gray100",
/* pixels */
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$",
"$$$$$$$$$$$XO$$$$@.$$$$$$$$$$$$$",
"$$$$$$$$$$$#.+$$@.+$$$$$$$$$$$$$",
"$$$$$$$$$$$$@ O@.o$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$#. +$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$$#  O$$$$$$$$$$$$$$$",
"$$$$$$$$$$$$@ O@.o$$$$$$$$$$$$$$",
"$$$$$$$$$$$@.+$$@.O$$$$$$$$$$$$$",
"$$$$$$$$$$$X+$$$$#.$$$$$$$$$$$$$"
};

static const char *img342[] = {
/* columns rows colors chars-per-pixel */
"1 16 2 1",
"  c black",
". c None",
/* pixels */
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
".",
"."
};



//////////////////////////////////////////////////////////

SymbolView::SymbolView(int page,QWidget *parent, const char *name): SpecialIconView( parent, name )
{
codesymbol=="";
setGridX( 36 );
setGridY( 36);
setSpacing(2);
setWordWrapIconText (false);
setShowToolTips (true);
setResizeMode( Adjust );
setHScrollBarMode( AlwaysOff );
setVScrollBarMode( Auto );
setAutoArrange(true);
setSorting(false);
setItemsMovable(false);
setArrangement(LeftToRight);
setAcceptDrops(false);
setItemTextPos(Right);
InitPage(page);
connect(this,SIGNAL(clicked(SpecialIconViewItem*)),this,SLOT(setSymbolCode(SpecialIconViewItem*)));
}
SymbolView::~SymbolView()
{
}

void SymbolView::InitPage(int page)
{
const ListPixmap pix=
{
QPixmap(img1),
QPixmap(img2),
QPixmap(img3),
QPixmap(img4),
QPixmap(img5),
QPixmap(img6),
QPixmap(img7),
QPixmap(img8),
QPixmap(img9),
QPixmap(img10),
QPixmap(img11),
QPixmap(img12),
QPixmap(img13),
QPixmap(img14),
QPixmap(img15),
QPixmap(img16),
QPixmap(img17),
QPixmap(img18),
QPixmap(img19),
QPixmap(img20),
QPixmap(img21),
QPixmap(img22),
QPixmap(img23),
QPixmap(img24),
QPixmap(img25),
QPixmap(img26),
QPixmap(img27),
QPixmap(img28),
QPixmap(img29),
QPixmap(img30),
QPixmap(img31),
QPixmap(img32),
QPixmap(img33),
QPixmap(img34),
QPixmap(img35),
QPixmap(img36),
QPixmap(img37),
QPixmap(img38),
QPixmap(img39),
QPixmap(img40),
QPixmap(img41),
QPixmap(img42),
QPixmap(img43),
QPixmap(img44),
QPixmap(img45),
QPixmap(img46),
QPixmap(img47),
QPixmap(img48),
QPixmap(img49),
QPixmap(img50),
QPixmap(img51),
QPixmap(img52),
QPixmap(img53),
QPixmap(img54),
QPixmap(img55),
QPixmap(img56),
QPixmap(img57),
QPixmap(img58),
QPixmap(img59),
QPixmap(img60),
QPixmap(img61),
QPixmap(img62),
QPixmap(img63),
QPixmap(img64),
QPixmap(img65),
QPixmap(img66),
QPixmap(img67),
QPixmap(img68),
QPixmap(img69),
QPixmap(img70),
QPixmap(img71),
QPixmap(img72),
QPixmap(img73),
QPixmap(img74),
QPixmap(img75),
QPixmap(img76),
QPixmap(img77),
QPixmap(img78),
QPixmap(img79),
QPixmap(img80),
QPixmap(img81),
QPixmap(img82),
QPixmap(img83),
QPixmap(img84),
QPixmap(img85),
QPixmap(img86),
QPixmap(img87),
QPixmap(img88),
QPixmap(img89),
QPixmap(img90),
QPixmap(img91),
QPixmap(img92),
QPixmap(img93),
QPixmap(img94),
QPixmap(img95),
QPixmap(img96),
QPixmap(img97),
QPixmap(img98),
QPixmap(img99),
QPixmap(img100),
QPixmap(img101),
QPixmap(img102),
QPixmap(img103),
QPixmap(img104),
QPixmap(img105),
QPixmap(img106),
QPixmap(img107),
QPixmap(img108),
QPixmap(img109),
QPixmap(img110),
QPixmap(img111),
QPixmap(img112),
QPixmap(img113),
QPixmap(img114),
QPixmap(img115),
QPixmap(img116),
QPixmap(img117),
QPixmap(img118),
QPixmap(img119),
QPixmap(img120),
QPixmap(img121),
QPixmap(img122),
QPixmap(img123),
QPixmap(img124),
QPixmap(img125),
QPixmap(img126),
QPixmap(img127),
QPixmap(img128),
QPixmap(img129),
QPixmap(img130),
QPixmap(img131),
QPixmap(img132),
QPixmap(img133),
QPixmap(img134),
QPixmap(img135),
QPixmap(img136),
QPixmap(img137),
QPixmap(img138),
QPixmap(img139),
QPixmap(img140),
QPixmap(img141),
QPixmap(img142),
QPixmap(img143),
QPixmap(img144),
QPixmap(img145),
QPixmap(img146),
QPixmap(img147),
QPixmap(img148),
QPixmap(img149),
QPixmap(img150),
QPixmap(img151),
QPixmap(img152),
QPixmap(img153),
QPixmap(img154),
QPixmap(img155),
QPixmap(img156),
QPixmap(img157),
QPixmap(img158),
QPixmap(img159),
QPixmap(img160),
QPixmap(img161),
QPixmap(img162),
QPixmap(img163),
QPixmap(img164),
QPixmap(img165),
QPixmap(img166),
QPixmap(img167),
QPixmap(img168),
QPixmap(img169),
QPixmap(img170),
QPixmap(img171),
QPixmap(img172),
QPixmap(img173),
QPixmap(img174),
QPixmap(img175),
QPixmap(img176),
QPixmap(img177),
QPixmap(img178),
QPixmap(img179),
QPixmap(img180),
QPixmap(img181),
QPixmap(img182),
QPixmap(img183),
QPixmap(img184),
QPixmap(img185),
QPixmap(img186),
QPixmap(img187),
QPixmap(img188),
QPixmap(img189),
QPixmap(img190),
QPixmap(img191),
QPixmap(img192),
QPixmap(img193),
QPixmap(img194),
QPixmap(img195),
QPixmap(img196),
QPixmap(img197),
QPixmap(img198),
QPixmap(img199),
QPixmap(img200),
QPixmap(img201),
QPixmap(img202),
QPixmap(img203),
QPixmap(img204),
QPixmap(img205),
QPixmap(img206),
QPixmap(img207),
QPixmap(img208),
QPixmap(img209),
QPixmap(img210),
QPixmap(img211),
QPixmap(img212),
QPixmap(img213),
QPixmap(img214),
QPixmap(img215),
QPixmap(img216),
QPixmap(img217),
QPixmap(img218),
QPixmap(img219),
QPixmap(img220),
QPixmap(img221),
QPixmap(img222),
QPixmap(img223),
QPixmap(img224),
QPixmap(img225),
QPixmap(img226),
QPixmap(img227),
QPixmap(img228),
QPixmap(img229),
QPixmap(img230),
QPixmap(img231),
QPixmap(img232),
QPixmap(img233),
QPixmap(img234),
QPixmap(img235),
QPixmap(img236),
QPixmap(img237),
QPixmap(img238),
QPixmap(img239),
QPixmap(img240),
QPixmap(img241),
QPixmap(img242),
QPixmap(img243),
QPixmap(img244),
QPixmap(img245),
QPixmap(img246),
QPixmap(img247),
QPixmap(img248),
QPixmap(img249),
QPixmap(img250),
QPixmap(img251),
QPixmap(img252),
QPixmap(img253),
QPixmap(img254),
QPixmap(img255),
QPixmap(img256),
QPixmap(img257),
QPixmap(img258),
QPixmap(img259),
QPixmap(img260),
QPixmap(img261),
QPixmap(img262),
QPixmap(img263),
QPixmap(img264),
QPixmap(img265),
QPixmap(img266),
QPixmap(img267),
QPixmap(img268),
QPixmap(img269),
QPixmap(img270),
QPixmap(img271),
QPixmap(img272),
QPixmap(img273),
QPixmap(img274),
QPixmap(img275),
QPixmap(img276),
QPixmap(img277),
QPixmap(img278),
QPixmap(img279),
QPixmap(img280),
QPixmap(img281),
QPixmap(img282),
QPixmap(img283),
QPixmap(img284),
QPixmap(img285),
QPixmap(img286),
QPixmap(img287),
QPixmap(img288),
QPixmap(img289),
QPixmap(img290),
QPixmap(img291),
QPixmap(img292),
QPixmap(img293),
QPixmap(img294),
QPixmap(img295),
QPixmap(img296),
QPixmap(img297),
QPixmap(img298),
QPixmap(img299),
QPixmap(img300),
QPixmap(img301),
QPixmap(img302),
QPixmap(img303),
QPixmap(img304),
QPixmap(img305),
QPixmap(img306),
QPixmap(img307),
QPixmap(img308),
QPixmap(img309),
QPixmap(img310),
QPixmap(img311),
QPixmap(img312),
QPixmap(img313),
QPixmap(img314),
QPixmap(img315),
QPixmap(img316),
QPixmap(img317),
QPixmap(img318),
QPixmap(img319),
QPixmap(img320),
QPixmap(img321),
QPixmap(img322),
QPixmap(img323),
QPixmap(img324),
QPixmap(img325),
QPixmap(img326),
QPixmap(img327),
QPixmap(img328),
QPixmap(img329),
QPixmap(img330),
QPixmap(img331),
QPixmap(img332),
QPixmap(img333),
QPixmap(img334),
QPixmap(img335),
QPixmap(img336),
QPixmap(img337),
QPixmap(img338),
QPixmap(img339),
QPixmap(img340),
QPixmap(img341),
QPixmap(img342),
QPixmap(img343),
QPixmap(img344),
QPixmap(img345),
QPixmap(img346),
QPixmap(img347),
QPixmap(img348),
QPixmap(img349),
QPixmap(img350),
QPixmap(img351),
QPixmap(img352),
QPixmap(img353),
QPixmap(img354),
QPixmap(img355),
QPixmap(img356),
QPixmap(img357),
QPixmap(img358),
QPixmap(img359),
QPixmap(img360),
QPixmap(img361),
QPixmap(img362),
QPixmap(img363),
QPixmap(img364),
QPixmap(img365),
QPixmap(img366),
QPixmap(img367),
QPixmap(img368),
QPixmap(img369),
QPixmap(img370),
QPixmap(img371),
QPixmap(img372),
QPixmap(img1greek),
QPixmap(img2greek),
QPixmap(img3greek),
QPixmap(img4greek),
QPixmap(img5greek),
QPixmap(img6greek),
QPixmap(img7greek),
QPixmap(img8greek),
QPixmap(img9greek),
QPixmap(img10greek),
QPixmap(img11greek),
QPixmap(img12greek),
QPixmap(img13greek),
QPixmap(img14greek),
QPixmap(img15greek),
QPixmap(img16greek),
QPixmap(img17greek),
QPixmap(img18greek),
QPixmap(img19greek),
QPixmap(img20greek),
QPixmap(img21greek),
QPixmap(img22greek),
QPixmap(img23greek),
QPixmap(img24greek),
QPixmap(img25greek),
QPixmap(img26greek),
QPixmap(img27greek),
QPixmap(img28greek),
QPixmap(img29greek),
QPixmap(img30greek),
QPixmap(img31greek),
QPixmap(img32greek),
QPixmap(img33greek),
QPixmap(img34greek),
QPixmap(img35greek),
QPixmap(img36greek),
QPixmap(img37greek),
QPixmap(img38greek),
QPixmap(img39greek),
QPixmap(img40greek)
};
SpecialIconViewItem* item;
switch (page)
 {
  case 1:
    {
    for ( uint i = 0; i <= 225; i++ )
     {
     item= new SpecialIconViewItem( this);
     item->setPixmap(pix[i]);
     item->setText(code[i]);
     item->setKey(code[i]);
      }
    }break;
  case 2:
    {
    for ( uint i = 247; i <=313 ; i++ )
     {
        item= new SpecialIconViewItem( this);
        item->setPixmap(pix[i]);
        item->setText(code[i]);
        item->setKey(code[i]);
     }
    }break;
 case 3:
    {
    for ( uint i = 314; i <= 371; i++ )
     {
        if (i!=342)
	{
	item= new SpecialIconViewItem( this);
        item->setPixmap(pix[i]);
        item->setText(code[i]);
        item->setKey(code[i]);
	}
      }
    }break;
 case 4:
    {
    for ( uint i = 226; i <= 246; i++ )
     {
        item= new SpecialIconViewItem( this);
        item->setPixmap(pix[i]);
        item->setText(code[i]);
        item->setKey(code[i]);
     }
    }break;
 case 5:
    {
    for ( uint i = 0; i <= 39; i++ )
     {
        item= new SpecialIconViewItem( this);
        item->setPixmap(pix[i+372]);
        item->setText(code[i+372]);
        item->setKey(code[i+372]);
     }
    }break;
 }

}

QString SymbolView::getSymbolCode()
{
return codesymbol;
}

void SymbolView::setSymbolCode(SpecialIconViewItem* item)
{
if (item)
   {
   codesymbol=item->key();
   emit SymbolSelected();
   }
else codesymbol="";
}
